CREATE OR REPLACE FUNCTION create_or_drop_majetek_changes_triggers(docreate boolean)
  RETURNS void AS
$BODY$
BEGIN
  -- Na nektere z tabulek muze byt uvalen zamek (napr. typu AccessShareLock)
  LOCK TABLE mdannakl IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE mdanodpisy IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE mleasing IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE mmajetek IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE msazby IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE msplatkal IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE mtypleas IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE mtypmaj IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE mucetodpisy IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE mudalosti IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE mumisteni IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE mzapujcky IN ACCESS EXCLUSIVE MODE NOWAIT;
  
  IF docreate THEN
    CREATE TRIGGER mdannaklextidsaver
        BEFORE DELETE ON mdannakl
        FOR EACH ROW EXECUTE PROCEDURE saveextid();

    CREATE CONSTRAINT TRIGGER mdannaklchanges
        AFTER UPDATE OR INSERT OR DELETE ON mdannakl
        DEFERRABLE INITIALLY DEFERRED
        FOR EACH ROW EXECUTE PROCEDURE logchanges();

    CREATE TRIGGER mdanodpisyextidsaver
        BEFORE DELETE ON mdanodpisy
        FOR EACH ROW EXECUTE PROCEDURE saveextid();

    CREATE CONSTRAINT TRIGGER mdanodpisychanges
        AFTER UPDATE OR INSERT OR DELETE ON mdanodpisy
        DEFERRABLE INITIALLY DEFERRED
        FOR EACH ROW EXECUTE PROCEDURE logchanges();

    CREATE TRIGGER mleasingextidsaver
        BEFORE DELETE ON mleasing
        FOR EACH ROW EXECUTE PROCEDURE saveextid();

    CREATE CONSTRAINT TRIGGER mleasingchanges
        AFTER UPDATE OR INSERT OR DELETE ON mleasing
        DEFERRABLE INITIALLY DEFERRED
        FOR EACH ROW EXECUTE PROCEDURE logchanges();

    CREATE TRIGGER mmajetekextidsaver
        BEFORE DELETE ON mmajetek
        FOR EACH ROW EXECUTE PROCEDURE saveextid();

    CREATE CONSTRAINT TRIGGER mmajetekchanges
        AFTER UPDATE OR INSERT OR DELETE ON mmajetek
        DEFERRABLE INITIALLY DEFERRED
        FOR EACH ROW EXECUTE PROCEDURE logchanges();

    CREATE TRIGGER msazbyextidsaver
        BEFORE DELETE ON msazby
        FOR EACH ROW EXECUTE PROCEDURE saveextid();

    CREATE CONSTRAINT TRIGGER msazbychanges
        AFTER UPDATE OR INSERT OR DELETE ON msazby
        DEFERRABLE INITIALLY DEFERRED
        FOR EACH ROW EXECUTE PROCEDURE logchanges();

    CREATE TRIGGER msplatkalextidsaver
        BEFORE DELETE ON msplatkal
        FOR EACH ROW EXECUTE PROCEDURE saveextid();

    CREATE CONSTRAINT TRIGGER msplatkalchanges
        AFTER UPDATE OR INSERT OR DELETE ON msplatkal
        DEFERRABLE INITIALLY DEFERRED
        FOR EACH ROW EXECUTE PROCEDURE logchanges();

    CREATE TRIGGER mtypleasextidsaver
        BEFORE DELETE ON mtypleas
        FOR EACH ROW EXECUTE PROCEDURE saveextid();

    CREATE CONSTRAINT TRIGGER mtypleaschanges
        AFTER UPDATE OR INSERT OR DELETE ON mtypleas
        DEFERRABLE INITIALLY DEFERRED
        FOR EACH ROW EXECUTE PROCEDURE logchanges();

    CREATE TRIGGER mtypmajextidsaver
        BEFORE DELETE ON mtypmaj
        FOR EACH ROW EXECUTE PROCEDURE saveextid();

    CREATE CONSTRAINT TRIGGER mtypmajchanges
        AFTER UPDATE OR INSERT OR DELETE ON mtypmaj
        DEFERRABLE INITIALLY DEFERRED
        FOR EACH ROW EXECUTE PROCEDURE logchanges();

    CREATE TRIGGER mucetodpisyextidsaver
        BEFORE DELETE ON mucetodpisy
        FOR EACH ROW EXECUTE PROCEDURE saveextid();

    CREATE CONSTRAINT TRIGGER mucetodpisychanges
        AFTER UPDATE OR INSERT OR DELETE ON mucetodpisy
        DEFERRABLE INITIALLY DEFERRED
        FOR EACH ROW EXECUTE PROCEDURE logchanges();

    CREATE TRIGGER mudalostiextidsaver
        BEFORE DELETE ON mudalosti
        FOR EACH ROW EXECUTE PROCEDURE saveextid();

    CREATE CONSTRAINT TRIGGER mudalostichanges
        AFTER UPDATE OR INSERT OR DELETE ON mudalosti
        DEFERRABLE INITIALLY DEFERRED
        FOR EACH ROW EXECUTE PROCEDURE logchanges();

    CREATE TRIGGER mumisteniextidsaver
        BEFORE DELETE ON mumisteni
        FOR EACH ROW EXECUTE PROCEDURE saveextid();

    CREATE CONSTRAINT TRIGGER mumistenichanges
        AFTER UPDATE OR INSERT OR DELETE ON mumisteni
        DEFERRABLE INITIALLY DEFERRED
        FOR EACH ROW EXECUTE PROCEDURE logchanges();

    CREATE TRIGGER mzapujckyextidsaver
        BEFORE DELETE ON mzapujcky
        FOR EACH ROW EXECUTE PROCEDURE saveextid();

    CREATE CONSTRAINT TRIGGER mzapujckychanges
        AFTER UPDATE OR INSERT OR DELETE ON mzapujcky
        DEFERRABLE INITIALLY DEFERRED
        FOR EACH ROW EXECUTE PROCEDURE logchanges();

  ELSE
    PERFORM invoke_deferred_changes_triggers_immediate();

    DROP TRIGGER IF EXISTS mdannaklchanges ON mdannakl;
    DROP TRIGGER IF EXISTS mdannaklextidsaver ON mdannakl;
    DROP TRIGGER IF EXISTS mdanodpisychanges ON mdanodpisy;
    DROP TRIGGER IF EXISTS mdanodpisyextidsaver ON mdanodpisy;
    DROP TRIGGER IF EXISTS mleasingchanges ON mleasing;
    DROP TRIGGER IF EXISTS mleasingextidsaver ON mleasing;
    DROP TRIGGER IF EXISTS mmajetekchanges ON mmajetek;
    DROP TRIGGER IF EXISTS mmajetekextidsaver ON mmajetek;
    DROP TRIGGER IF EXISTS msazbychanges ON msazby;
    DROP TRIGGER IF EXISTS msazbyextidsaver ON msazby;
    DROP TRIGGER IF EXISTS msplatkalchanges ON msplatkal;
    DROP TRIGGER IF EXISTS msplatkalextidsaver ON msplatkal;
    DROP TRIGGER IF EXISTS mtypleaschanges ON mtypleas;
    DROP TRIGGER IF EXISTS mtypleasextidsaver ON mtypleas;
    DROP TRIGGER IF EXISTS mtypmajchanges ON mtypmaj;
    DROP TRIGGER IF EXISTS mtypmajextidsaver ON mtypmaj;
    DROP TRIGGER IF EXISTS mucetodpisychanges ON mucetodpisy;
    DROP TRIGGER IF EXISTS mucetodpisyextidsaver ON mucetodpisy;
    DROP TRIGGER IF EXISTS mudalostichanges ON mudalosti;
    DROP TRIGGER IF EXISTS mudalostiextidsaver ON mudalosti;
    DROP TRIGGER IF EXISTS mumistenichanges ON mumisteni;
    DROP TRIGGER IF EXISTS mumisteniextidsaver ON mumisteni;
    DROP TRIGGER IF EXISTS mzapujckychanges ON mzapujcky;
    DROP TRIGGER IF EXISTS mzapujckyextidsaver ON mzapujcky;
  END IF;
END;
$BODY$
LANGUAGE 'plpgsql' VOLATILE;
