/*
 Odpočet obratů na uUcty

 Původní autor:        Josef Weinreb
 Verze pro PostgreSQL: Pavel Cvrček
*/
create or replace function dPolDoklDeleteUcto() returns trigger as $$
begin
  execute createOrUpdateObraty(OLD.Ucetni, OLD.Storno, OLD.DatUcto, OLD.idZklMdUcet, OLD.idZklDalUcet,
        OLD.idMeny, OLD.idStred, -OLD.sumZkl, -OLD.sumZklMen);

  execute createOrUpdateObraty(OLD.Ucetni, OLD.Storno, OLD.DatUcto, OLD.idDphMdUcet, OLD.idDphDalUcet,
        OLD.idMeny, OLD.idStred, -OLD.sumDph, -OLD.sumDphMen);

  return OLD;
end;
$$ LANGUAGE plpgsql;

drop trigger if exists dPolDoklDeleteUcto on dpolfak;
drop trigger if exists dPolDoklDeleteUcto on dpolint;
drop trigger if exists dPolDoklDeleteUcto on dpolsklad;

create trigger dPolDoklDeleteUcto before delete on dpolfak
for each row execute procedure dPolDoklDeleteUcto();

create trigger dPolDoklDeleteUcto before delete on dpolint
for each row execute procedure dPolDoklDeleteUcto();

create trigger dPolDoklDeleteUcto before delete on dpolsklad
for each row execute procedure dPolDoklDeleteUcto();