-- trigger volaný při změně položky faktury - aktualizuje položky v daňové evidenci
CREATE OR REPLACE FUNCTION dpolfakupdatedanevid()
  RETURNS trigger AS $$
declare
  idDoklInt integer;
begin
  for idDoklInt in (
    select idTabB from dVazebTab where idTabA = NEW.idDoklFak and typVazbyK in ('typVazbyDokl.uhrada', 'typVazbyDokl.uhradaZALOHY', 'typVazbyDokl.vazbaZDD')
    union
    select idTabB from dVazebTab where typVazbyK = 'typVazbyDokl.uhradaZALOHY' and idTabA in
      (select idTabB from dVazebTab where typVazbyK = 'typVazbyDokl.odpocetZALOHY' and idTabA in
        (select idPolFak from dPolFak where idDoklFak = NEW.idDoklFak))
  ) loop
    perform uUpdateDanEvid(idDoklInt);
  end loop;
  
  return NEW;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.dpolfakupdatedanevid() OWNER TO %firmaRole%;

-- navěšení triggeru na tabulku položek interních dokladů
CREATE TRIGGER dpolfakupdatedanevid AFTER UPDATE ON dpolfak
  FOR EACH ROW EXECUTE PROCEDURE dpolfakupdatedanevid();