-- trigger rusici rezervaci pri vyskladneni
CREATE OR REPLACE FUNCTION dpolskladupdaterezer()
  RETURNS trigger AS $$
declare
  zmena numeric(19,6);
  _idFirmy integer;
begin
  zmena = 0;
  if (tg_op = 'UPDATE') then
    zmena = OLD.mnozMj;
  end if;
  
  zmena = NEW.mnozMj - zmena;

  if (zmena > 0) then
    select idfirmy into _idFirmy from ddoklsklad where idDoklSklad = NEW.idDoklSklad;
    
    perform odrezervuj(_idFirmy, NEW.idCenik, NEW.idSkladu, zmena);
  end if;

  return NEW;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.dpolskladupdaterezer() OWNER TO %firmaRole%;

-- navěšení triggeru na tabulku položek skladovych dokladů
CREATE TRIGGER dpolskladupdaterezer AFTER INSERT OR UPDATE ON dpolsklad
  FOR EACH ROW EXECUTE PROCEDURE dpolskladupdaterezer();
