/*
 Pri vytvareni noveho dokladu nastavi u ucetniho obdobi chybu preceneni pokud je treba

 Autor:       Jan Besta
*/
create or replace function dVazebTabInsDelPreceneni() returns trigger as $$
declare isUcetni boolean;
        celkemMen numeric(15,2);
        datumUcto date;
        datumVyst date;
        ZAZNAM record;
begin
  if (tg_op = 'DELETE') then
    ZAZNAM := OLD;
  else
    ZAZNAM := NEW;
  end if;

  isUcetni := false;
  datumUcto := null;
  datumVyst := null;

  if (ZAZNAM.typVazbyK = 'typVazbyDokl.uhrada') then
    select ucetni, sumCelkemMen into isUcetni, celkemMen from dDoklFak where idDoklFak = ZAZNAM.idTabA and modul = ZAZNAM.modulA;

    if (isUcetni = true and celkemMen <> 0) then
        select datUcto, datVyst into datumUcto, datumVyst from dDoklInt where idDoklInt = ZAZNAM.idTabB and modul = ZAZNAM.modulB;
        
        if (datumUcto is not null) then
          execute uNastavChybaPreceneni(datumUcto);
        else
          execute uNastavChybaPreceneni(datumVyst);
        end if;

    end if;

  end if;
  
  return ZAZNAM;
end;
$$ LANGUAGE plpgsql;

drop trigger if exists dVazebTabInsDelPreceneni on dVazebTab;

create trigger dVazebTabInsDelPreceneni before insert or delete on dVazebTab
for each row execute procedure dVazebTabInsDelPreceneni();