-- trigger volaný při vytváření a mazání vazby mezi doklady - aktualizuje položky v daňové evidenci pokud se jedná o úhradu
CREATE OR REPLACE FUNCTION dvazebtabinsertdeletedanevid()
  RETURNS trigger AS $$
declare
  ZAZNAM record;
  _idDoklInt integer;
begin
  if (tg_op = 'DELETE') then  
    ZAZNAM := OLD;  
  else  
    ZAZNAM := NEW;  
  end if;
  _idDoklInt := null;
  
  if (ZAZNAM.typvazbyk in ('typVazbyDokl.uhrada', 'typVazbyDokl.uhradaZALOHY', 'typVazbyDokl.vazbaZDD')) then
    _idDoklInt := ZAZNAM.idTabB;
  end if;
  if (ZAZNAM.typvazbyk = 'typVazbyDokl.odpocetZALOHY') then
    select idTabB into _idDoklInt from dVazebTab where typVazbyK = 'typVazbyDokl.uhradaZALOHY' and idTabA = ZAZNAM.idTabB;
  end if;
  
  if (_idDoklInt is not null) then
    perform uUpdateDanEvid(_idDoklInt);
  end if;
  
  return ZAZNAM;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.dvazebtabinsertdeletedanevid() OWNER TO %firmaRole%;

-- navěšení triggeru na tabulku vazeb
CREATE TRIGGER dvazebtabinsertdeletedanevid AFTER INSERT OR DELETE ON dvazebtab
  FOR EACH ROW EXECUTE PROCEDURE dvazebtabinsertdeletedanevid();