/*
  Nastavi stavy na skladove karte do dne urceneho parametrem i_datum
  Autor verze pro PostgreSQL: Pavel Cvrcek
  Autor verze pro Sybase:     Karel Běl
*/
CREATE OR REPLACE FUNCTION snastavstavkartydne(i_skladkartaid integer, i_datum date, i_polSkladId integer)
  RETURNS void AS
$BODY$ 
/* Nastavi stav karty i_SkladKartaId, jaky byl ke dni i_Datum */ 
declare 
  zaznam Record; 
begin 
  /* for cyklus, ktery ze skladove karty odecte vsechny prijemky a vydejky nasledujici po zadanem datu. */ 
  for zaznam in select * from dPolSklad where ((DatVyst > i_Datum) or (DatVyst = i_Datum and idPolSklad > i_polSkladId)) 
  and idKarty = i_SkladKartaId order by DatVYst asc loop 
    execute sOdectiSkladKartu(zaznam.MnozMJ,zaznam.CenaMj,zaznam.DatVyst,zaznam.idKarty,zaznam.idDoklSklad,zaznam.idskladu,-1); 
  end loop; 
end 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;