CREATE OR REPLACE FUNCTION saveextid() RETURNS trigger AS $$

    spi_exec "SELECT pg_attribute.attname AS pk
        FROM pg_index, pg_class, pg_attribute
        WHERE
          pg_class.oid = '[ quote $TG_table_name ]'::regclass AND
          indrelid = pg_class.oid AND
          pg_attribute.attrelid = pg_class.oid AND
          pg_attribute.attnum = any(pg_index.indkey) AND indisprimary"

    set pkval [ quote $OLD([ quote $pk ]) ]
    set extid_table "changelog_extid_${TG_table_name}_pk${pkval}"
    
    spi_exec "SELECT attname AS fk
            FROM pg_attribute
            WHERE attrelid = 'wextid'::regclass
                AND attnum IN (
                    SELECT conkey\[1\]
                    FROM pg_constraint
                    WHERE conrelid = 'wextid'::regclass
                        AND confrelid = '[ quote $TG_table_name ]'::regclass)" {
            
        spi_exec "CREATE TEMPORARY TABLE $extid_table ON COMMIT DROP AS SELECT * FROM wextid WHERE $fk = $pkval"
    }
    
    return [ array get OLD ]
    
$$ LANGUAGE pltcl VOLATILE SECURITY DEFINER;

ALTER FUNCTION saveextid() OWNER TO %admin%;
