--------------------------------------------------------------------------------
-- Bug 45556 - Změna základní sazby DPH v Řecku 
--------------------------------------------------------------------------------

UPDATE usazbydph
SET platidodata='2016-05-31'
WHERE uuid='GR_2300_2015';

CREATE OR REPLACE FUNCTION doUpgrade()
  RETURNS void AS
$BODY$    
declare
  pom integer;
  _idstatu integer;
begin    
    select idstatu into _idstatu from astaty where uuid like '%_GR';
    if _idstatu is null then
	return;
    end if;

    -- Sazba DPH 24%
    pom = 0;
    select count(1) into pom from usazbydph
    where typSzbDphK = 'typSzbDph.dphZakl' and szbdph = 24.00 and idstatu = _idstatu
        and (platioddata is null or platioddata >= '2016-06-01');

    if (pom = 0) then

	-- pro jistotu zkusíme ukončit základní sazbu Řecka s platností protínající 2016-06-01
	update usazbydph set platidodata = '2016-05-31' where idstatu = _idstatu and typszbdphk = 'typSzbDph.dphZakl'
	    and coalesce(platioddata, '2016-05-01') < '2016-06-01' and coalesce(platidodata, '2016-06-30') > '2016-06-01';

        INSERT INTO usazbydph (lastupdate, platidodata, platioddata, popis, poznam, szbdph, typszbdphk, idstatu, uuid)
            VALUES ('2016-06-01 15:30:00.000', NULL, '2016-06-01', NULL, NULL, 24.00, 'typSzbDph.dphZakl', _idstatu, 'GR_2400_2016');
    end if;

end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION doUpgrade() OWNER TO %firmaRole%;

select doUpgrade();
drop function doUpgrade();


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 1022, 't', %appVersion%, clock_timestamp());
