-------------------------------------------------------------------------------
-- Bug 42508 - Po vyřazení majetku došlo k otevření uzavřených období 
-------------------------------------------------------------------------------
  
CREATE OR REPLACE FUNCTION mmajetekupdateucto() RETURNS trigger
    AS $$
begin
  IF ( NEW.Ucetni <> OLD.Ucetni OR 
      comparedate(NEW.DatUcto, OLD.DatUcto) = false OR 
 
      compareid(NEW.idZklMdUcet, OLD.idZklMdUcet) = false OR 
      compareid(NEW.idZklDalUcet, OLD.idZklDalUcet) = false OR 
 
      compareid(NEW.idStred, OLD.idStred) = false OR 
 
      NEW.sumZkl <> OLD.sumZkl ) THEN 

    -- odpisy majetku jsou vedeny vzdy v mistni mene, proto za menu
    -- dosazujeme -1 a za sumZklMen 0.0
    execute createOrUpdateObraty(OLD.Ucetni, false, OLD.DatUcto, OLD.idZklMdUcet, OLD.idZklDalUcet,
         -1, OLD.idStred, -OLD.sumZkl, 0.0);

    -- odpisy majetku jsou vedeny vzdy v mistni mene, proto za menu
    -- dosazujeme null a za sumZklMen 0.0
    execute createOrUpdateObraty(NEW.Ucetni, false, NEW.DatUcto, NEW.idZklMdUcet, NEW.idZklDalUcet,
         -1, NEW.idStred, NEW.sumZKl, 0.0);
  END IF;

  return NEW;
end;
$$
    LANGUAGE plpgsql;

ALTER FUNCTION public.mmajetekupdateucto() OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
values (nextval('seq_dbversion'), 1026, 't', %appVersion%, clock_timestamp());
