--------------------------------------------------------------------------------
-- Bug 45707 - EET - tabulka pro ukládání komunikace s EET serverem 
--------------------------------------------------------------------------------


CREATE SEQUENCE seq_deetkom
INCREMENT BY 1
NO MAXVALUE
NO MINVALUE
CACHE 1;
ALTER TABLE public.seq_deetkom OWNER TO %firmaRole%;


CREATE TABLE deetkom (
    ideetkom integer DEFAULT nextval('seq_deetkom'::regclass) NOT NULL,
    iddokl integer NOT NULL,
    formid integer NOT NULL,
    verze integer NOT NULL,
    modul character varying(3) NOT NULL,
    storno boolean DEFAULT false,
    odeslano boolean DEFAULT false,
    cas timestamp with time zone DEFAULT NULL,
    casPosl timestamp with time zone DEFAULT NULL,
    eetmodk character varying(50),
    eettypk character varying(50),
    chyba character varying(255),
    varovani character varying(255),
    sumosv numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumzklzakl numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumdphzakl numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumzklsniz numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumdphsniz numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumzklsniz2 numeric(15,2) DEFAULT 0.0 NOT NULL,
    sumdphsniz2 numeric(15,2) DEFAULT 0.0 NOT NULL,
    zprava text,
    odpoved text,
    zpravaPosl text,
    odpovedPosl text,
    CONSTRAINT deetkom_pkey PRIMARY KEY (ideetkom)
);
ALTER TABLE public.deetkom OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
 values (nextval('seq_dbversion'), 1034, 't', %appVersion%, clock_timestamp());
