-------------------------------------------
-- Bug 45793 - Rovaha a výsledovka do EN
-------------------------------------------

CREATE OR REPLACE FUNCTION runupgrade()
RETURNS void AS $$
DECLARE
  _idtyporgread integer;
BEGIN
  select idtyporg into _idtyporgread from nnastav limit 1;

  -- sestavy aktualizujeme jen pro cechy
  IF (_idtyporgread = 1) THEN
    UPDATE usesradky SET nazeva = 'TOTAL ASSETS' WHERE idsesradky = 201;
   UPDATE usesradky SET nazeva = 'Receivables for subscribed share capital' WHERE idsesradky = 202;
   UPDATE usesradky SET nazeva = 'Fixed assets' WHERE idsesradky = 203;
   UPDATE usesradky SET nazeva = 'Intangible fixed assets' WHERE idsesradky = 204;
   UPDATE usesradky SET nazeva = 'Research & development (intangible profit/loss)' WHERE idsesradky = 205;
   UPDATE usesradky SET nazeva = 'Licenses, know-how, copyright and other valuable' WHERE idsesradky = 206;
   UPDATE usesradky SET nazeva = 'Software' WHERE idsesradky = 207;
   UPDATE usesradky SET nazeva = 'Other valuable' WHERE idsesradky = 208;
   UPDATE usesradky SET nazeva = 'Goodwill (+/-)' WHERE idsesradky = 209;
   UPDATE usesradky SET nazeva = 'Other intangible fixed assets' WHERE idsesradky = 210;
   UPDATE usesradky SET nazeva = 'Payments on account of intangible fixed assets' WHERE idsesradky = 211;
   UPDATE usesradky SET nazeva = 'Payments on account of fixed assets' WHERE idsesradky = 212;
   UPDATE usesradky SET nazeva = 'Unfinished intangible fixed assets' WHERE idsesradky = 213;
   UPDATE usesradky SET nazeva = 'Tangible fixed assets' WHERE idsesradky = 214;
   UPDATE usesradky SET nazeva = 'Land and constructions' WHERE idsesradky = 215;
   UPDATE usesradky SET nazeva = 'Land' WHERE idsesradky = 216;
   UPDATE usesradky SET nazeva = 'Constructions' WHERE idsesradky = 217;
   UPDATE usesradky SET nazeva = 'Other chattels - items and sets', poznam = '' WHERE idsesradky = 218;
   UPDATE usesradky SET nazeva = 'Adjustments to acquired assets (+/-)' WHERE idsesradky = 219;
   UPDATE usesradky SET nazeva = 'Other tangible fixed assets' WHERE idsesradky = 220;
   UPDATE usesradky SET nazeva = 'Permanent crop stands' WHERE idsesradky = 221;
   UPDATE usesradky SET nazeva = 'Livestock and draught animals' WHERE idsesradky = 222;
   UPDATE usesradky SET nazeva = 'Other tangible fixed assets' WHERE idsesradky = 223;
   UPDATE usesradky SET nazeva = 'Payments on account of tangible fixed assets and incomplete fixed assets' WHERE idsesradky = 224;
   UPDATE usesradky SET nazeva = 'Payments on account of tangible fixed assets' WHERE idsesradky = 225;
   UPDATE usesradky SET nazeva = 'Incomplete tangible fixed assets' WHERE idsesradky = 226;
   UPDATE usesradky SET nazeva = 'Long-term investments' WHERE idsesradky = 227;
   UPDATE usesradky SET nazeva = 'Investments - controlled or controlling entity' WHERE idsesradky = 228;
   UPDATE usesradky SET nazeva = 'Loan and credit - controlled or controlling entity' WHERE idsesradky = 229;
   UPDATE usesradky SET nazeva = 'Investment - significant influence' WHERE idsesradky = 230;
   UPDATE usesradky SET nazeva = 'Loans and credits - significant influence' WHERE idsesradky = 231;
   UPDATE usesradky SET nazeva = 'Other long-term investments and shares' WHERE idsesradky = 232;
   UPDATE usesradky SET nazeva = 'Loans and credits - other' WHERE idsesradky = 233;
   UPDATE usesradky SET nazeva = 'Other long-term investments' WHERE idsesradky = 234;
   UPDATE usesradky SET nazeva = 'Other long-term investments' WHERE idsesradky = 235;
   UPDATE usesradky SET nazeva = 'Payments on account of long-term investments' WHERE idsesradky = 236;
   UPDATE usesradky SET nazeva = 'Current assets' WHERE idsesradky = 237;
   UPDATE usesradky SET nazeva = 'Inventories' WHERE idsesradky = 238;
   UPDATE usesradky SET nazeva = 'Raw materials' WHERE idsesradky = 239;
   UPDATE usesradky SET nazeva = 'WIP and semi-finished goods' WHERE idsesradky = 240;
   UPDATE usesradky SET nazeva = 'Products and goods' WHERE idsesradky = 241;
   UPDATE usesradky SET nazeva = 'Products' WHERE idsesradky = 242;
   UPDATE usesradky SET nazeva = 'Goods for resale' WHERE idsesradky = 243;
   UPDATE usesradky SET nazeva = 'Livestock' WHERE idsesradky = 244;
   UPDATE usesradky SET nazeva = 'Payments on account of inventories' WHERE idsesradky = 245;
   UPDATE usesradky SET nazeva = 'Receivables' WHERE idsesradky = 246;
   UPDATE usesradky SET nazeva = 'Long-term receivables' WHERE idsesradky = 247;
   UPDATE usesradky SET nazeva = 'Trade receivables' WHERE idsesradky = 248;
   UPDATE usesradky SET nazeva = 'Receivables - controlled or controlling entity' WHERE idsesradky = 249;
   UPDATE usesradky SET nazeva = 'Receivables - subsidiaries' WHERE idsesradky = 250;
   UPDATE usesradky SET nazeva = 'Deferred tax receivable' WHERE idsesradky = 251;
   UPDATE usesradky SET nazeva = 'Receivables - other' WHERE idsesradky = 252;
   UPDATE usesradky SET nazeva = 'Receivables from partners' WHERE idsesradky = 253;
   UPDATE usesradky SET nazeva = 'Long-term advances paid' WHERE idsesradky = 254;
   UPDATE usesradky SET nazeva = 'Anticipated assets' WHERE idsesradky = 255;
   UPDATE usesradky SET nazeva = 'Other receivables' WHERE idsesradky = 256;
   UPDATE usesradky SET nazeva = 'Short-term receivables' WHERE idsesradky = 257;
   UPDATE usesradky SET nazeva = 'Trade receivables' WHERE idsesradky = 258;
   UPDATE usesradky SET nazeva = 'Receivables - controlled or controlling entities (50%)' WHERE idsesradky = 259;
   UPDATE usesradky SET nazeva = 'Receivables - significant influence' WHERE idsesradky = 260;
   UPDATE usesradky SET nazeva = 'Receivables - other' WHERE idsesradky = 261;
   UPDATE usesradky SET nazeva = 'Receivables from partners' WHERE idsesradky = 262;
   UPDATE usesradky SET nazeva = 'Social security and health insurance receivables' WHERE idsesradky = 263;
   UPDATE usesradky SET nazeva = 'State: Tax receivables' WHERE idsesradky = 264;
   UPDATE usesradky SET nazeva = 'Short-term advances paid' WHERE idsesradky = 265;
   UPDATE usesradky SET nazeva = 'Anticipated assets' WHERE idsesradky = 266;
   UPDATE usesradky SET nazeva = 'Other receivables' WHERE idsesradky = 267;
   UPDATE usesradky SET nazeva = 'Short-term financial assets' WHERE idsesradky = 268;
   UPDATE usesradky SET nazeva = 'Investment - controller or controlling entity' WHERE idsesradky = 269;
   UPDATE usesradky SET nazeva = 'Other short-term financial assets' WHERE idsesradky = 270;
   UPDATE usesradky SET nazeva = 'Finances' WHERE idsesradky = 271;
   UPDATE usesradky SET nazeva = 'Cash box' WHERE idsesradky = 272;
   UPDATE usesradky SET nazeva = 'Bank at bank' WHERE idsesradky = 273;
   UPDATE usesradky SET nazeva = 'Accruals and deferrals of assets' WHERE idsesradky = 274;
   UPDATE usesradky SET nazeva = 'Prepaid expenses' WHERE idsesradky = 275;
   UPDATE usesradky SET nazeva = 'Total prepaid expenses' WHERE idsesradky = 276;
   UPDATE usesradky SET nazeva = 'Anticipated accruals and receivables' WHERE idsesradky = 277;
   UPDATE usesradky SET nazeva = 'TOTAL LIABILITIES' WHERE idsesradky = 278;
   UPDATE usesradky SET nazeva = 'Equity' WHERE idsesradky = 279;
   UPDATE usesradky SET nazeva = 'Share capital' WHERE idsesradky = 280;
   UPDATE usesradky SET nazeva = 'Share capital' WHERE idsesradky = 281;
   UPDATE usesradky SET nazeva = 'Own ownership interests (-)' WHERE idsesradky = 282;
   UPDATE usesradky SET nazeva = 'Changes in the registered capital (+/-)' WHERE idsesradky = 283;
   UPDATE usesradky SET nazeva = 'Share premium and capital contributions' WHERE idsesradky = 284;
   UPDATE usesradky SET nazeva = 'Share premium' WHERE idsesradky = 285;
   UPDATE usesradky SET nazeva = 'Capital funds' WHERE idsesradky = 286;
   UPDATE usesradky SET nazeva = 'Other capital funds' WHERE idsesradky = 287;
   UPDATE usesradky SET nazeva = 'Asset and liabilities revaluation differences (+/-)' WHERE idsesradky = 288;
   UPDATE usesradky SET nazeva = 'Changes in the capital stock revaluation differences (+/-)' WHERE idsesradky = 289;
   UPDATE usesradky SET nazeva = 'Company changes differences (+/-)' WHERE idsesradky = 290;
   UPDATE usesradky SET nazeva = 'Rating difference by company conversion (+/-)' WHERE idsesradky = 291;
   UPDATE usesradky SET nazeva = 'Fund from profit' WHERE idsesradky = 292;
   UPDATE usesradky SET nazeva = 'Other reserve funds' WHERE idsesradky = 293;
   UPDATE usesradky SET nazeva = 'Statutory and other funds' WHERE idsesradky = 294;
   UPDATE usesradky SET nazeva = 'Retained earnings from prior years' WHERE idsesradky = 295;
   UPDATE usesradky SET nazeva = 'Retained profits from prior years' WHERE idsesradky = 296;
   UPDATE usesradky SET nazeva = 'Loss from prior years (-)' WHERE idsesradky = 297;
   UPDATE usesradky SET nazeva = 'Other retained earings from prior years (+/-)' WHERE idsesradky = 298;
   UPDATE usesradky SET nazeva = 'Profit (loss) for the current year' WHERE idsesradky = 299;
   UPDATE usesradky SET nazeva = 'Decided about share profit advance payment' WHERE idsesradky = 300;
   UPDATE usesradky SET nazeva = 'EXTERNAL LIABILITIES' WHERE idsesradky = 301;
   UPDATE usesradky SET nazeva = 'Provisions' WHERE idsesradky = 302;
   UPDATE usesradky SET nazeva = 'Old-age pension provision and similar liabilities' WHERE idsesradky = 303;
   UPDATE usesradky SET nazeva = 'Income tax provision' WHERE idsesradky = 304;
   UPDATE usesradky SET nazeva = 'Special regulatory provisions' WHERE idsesradky = 305;
   UPDATE usesradky SET nazeva = 'Other provisions' WHERE idsesradky = 306;
   UPDATE usesradky SET nazeva = 'Liabilities' WHERE idsesradky = 307;
   UPDATE usesradky SET nazeva = 'Long term liabilities' WHERE idsesradky = 308;
   UPDATE usesradky SET nazeva = 'Debenture bonds issued' WHERE idsesradky = 309;
   UPDATE usesradky SET nazeva = 'Changeable debenture bond' WHERE idsesradky = 310;
   UPDATE usesradky SET nazeva = 'Other debenture bond' WHERE idsesradky = 311;
   UPDATE usesradky SET nazeva = 'Credit establishment liables' WHERE idsesradky = 312;
   UPDATE usesradky SET nazeva = 'Long term advances received' WHERE idsesradky = 313;
   UPDATE usesradky SET nazeva = 'Trade payables' WHERE idsesradky = 314;
   UPDATE usesradky SET nazeva = 'Long-dated bills payable' WHERE idsesradky = 315;
   UPDATE usesradky SET nazeva = 'Liabilities - controlled or controlling entity' WHERE idsesradky = 316;
   UPDATE usesradky SET nazeva = 'Liabilities - entities with a significant interest' WHERE idsesradky = 317;
   UPDATE usesradky SET nazeva = 'Deferred tax liability' WHERE idsesradky = 318;
   UPDATE usesradky SET nazeva = 'Other liabilities' WHERE idsesradky = 319;
   UPDATE usesradky SET nazeva = 'Payables to partners' WHERE idsesradky = 320;
   UPDATE usesradky SET nazeva = 'Anticipated liabilities' WHERE idsesradky = 321;
   UPDATE usesradky SET nazeva = 'Other payables' WHERE idsesradky = 322;
   UPDATE usesradky SET nazeva = 'Short-term liabilities' WHERE idsesradky = 323;
   UPDATE usesradky SET nazeva = 'Debenture bonds issued' WHERE idsesradky = 324;
   UPDATE usesradky SET nazeva = 'Debenture bonds repleceabled' WHERE idsesradky = 325;
   UPDATE usesradky SET nazeva = 'Other debenture bonds' WHERE idsesradky = 326;
   UPDATE usesradky SET nazeva = 'Credit establishment liabilities' WHERE idsesradky = 327;
   UPDATE usesradky SET nazeva = 'Short term advances received' WHERE idsesradky = 328;
   UPDATE usesradky SET nazeva = 'Trade payables' WHERE idsesradky = 329;
   UPDATE usesradky SET nazeva = 'Short-dated bills payable' WHERE idsesradky = 330;
   UPDATE usesradky SET nazeva = 'Liabilities - controlled or controlling entities' WHERE idsesradky = 331;
   UPDATE usesradky SET nazeva = 'Liabilities - entities with a significant interest' WHERE idsesradky = 332;
   UPDATE usesradky SET nazeva = 'Other liabilities' WHERE idsesradky = 333;
   UPDATE usesradky SET nazeva = 'Liabilities to partners' WHERE idsesradky = 334;
   UPDATE usesradky SET nazeva = 'Short-term loans (other than bank loans)' WHERE idsesradky = 335;
   UPDATE usesradky SET nazeva = 'Liabilities to employees' WHERE idsesradky = 336;
   UPDATE usesradky SET nazeva = 'Liabilities for social security and health insurance' WHERE idsesradky = 337;
   UPDATE usesradky SET nazeva = 'State: Taxes payable and subsidies payable' WHERE idsesradky = 338;
   UPDATE usesradky SET nazeva = 'Anticipated liabilities' WHERE idsesradky = 339;
   UPDATE usesradky SET nazeva = 'Other payables' WHERE idsesradky = 340;
   UPDATE usesradky SET nazeva = 'Accruals' WHERE idsesradky = 341;
   UPDATE usesradky SET nazeva = 'Accrued expenses' WHERE idsesradky = 342;
   UPDATE usesradky SET nazeva = 'Deferred revenue' WHERE idsesradky = 343;
   UPDATE usesradky SET nazeva = 'Sale of goods and services' WHERE idsesradky = 344;
   UPDATE usesradky SET nazeva = 'Sale of goods' WHERE idsesradky = 345;
   UPDATE usesradky SET nazeva = 'Cost of sale' WHERE idsesradky = 346;
   UPDATE usesradky SET nazeva = 'Cost of goods sold' WHERE idsesradky = 347;
   UPDATE usesradky SET nazeva = 'Raw materials and consumables' WHERE idsesradky = 348;
   UPDATE usesradky SET nazeva = 'Services' WHERE idsesradky = 349;
   UPDATE usesradky SET nazeva = 'Change in inventory and WIP (+/-)' WHERE idsesradky = 350;
   UPDATE usesradky SET nazeva = 'Own work capitalised (-)' WHERE idsesradky = 351;
   UPDATE usesradky SET nazeva = 'Other costs' WHERE idsesradky = 352;
   UPDATE usesradky SET nazeva = 'Wages and salaries' WHERE idsesradky = 353;
   UPDATE usesradky SET nazeva = 'Social security and health insurance costs and other costs' WHERE idsesradky = 354;
   UPDATE usesradky SET nazeva = 'Social security and health insurance costs', poznam = '' WHERE idsesradky = 355;
   UPDATE usesradky SET nazeva = 'Other costs' WHERE idsesradky = 356;
   UPDATE usesradky SET nazeva = 'Value changes in operating provisions' WHERE idsesradky = 357;
   UPDATE usesradky SET nazeva = 'Intangible fixed assets and tangible fixed assets value changes' WHERE idsesradky = 358;
   UPDATE usesradky SET nazeva = 'Intangible fixed assets and tangible fixed assets value changes - permanent' WHERE idsesradky = 359;
   UPDATE usesradky SET nazeva = 'Intangible fixed assets and tangible fixed assets value changes - temporary' WHERE idsesradky = 360;
   UPDATE usesradky SET nazeva = 'Stock value changes' WHERE idsesradky = 361;
   UPDATE usesradky SET nazeva = 'Receivables value changes' WHERE idsesradky = 362;
   UPDATE usesradky SET nazeva = 'Other operating income' WHERE idsesradky = 363;
   UPDATE usesradky SET nazeva = 'Sale of long-term assets' WHERE idsesradky = 364;
   UPDATE usesradky SET nazeva = 'Sale of material' WHERE idsesradky = 365;
   UPDATE usesradky SET nazeva = 'Other operating income' WHERE idsesradky = 366;
   UPDATE usesradky SET nazeva = 'Other operating charges' WHERE idsesradky = 367;
   UPDATE usesradky SET nazeva = 'Net book value of long-term assets sold' WHERE idsesradky = 368;
   UPDATE usesradky SET nazeva = 'Net book value of material sold' WHERE idsesradky = 369;
   UPDATE usesradky SET nazeva = 'Taxes and charges' WHERE idsesradky = 370;
   UPDATE usesradky SET nazeva = 'Operating provisions and complex prepaid expenses' WHERE idsesradky = 371;
   UPDATE usesradky SET nazeva = 'Other operating income' WHERE idsesradky = 372;
   UPDATE usesradky SET nazeva = 'Operating result (+/-)' WHERE idsesradky = 373;
   UPDATE usesradky SET nazeva = 'Income from long-term investments ' WHERE idsesradky = 374;
   UPDATE usesradky SET nazeva = 'Income from investments - controlled or controlling entity' WHERE idsesradky = 375;
   UPDATE usesradky SET nazeva = 'Other income from investments' WHERE idsesradky = 376;
   UPDATE usesradky SET nazeva = 'Cost of investments sold' WHERE idsesradky = 377;
   UPDATE usesradky SET nazeva = 'Income from other long-term investments' WHERE idsesradky = 378;
   UPDATE usesradky SET nazeva = 'Income from other fixed assets - controlled or controlling entities' WHERE idsesradky = 379;
   UPDATE usesradky SET nazeva = 'Other income from other long-term investments' WHERE idsesradky = 380;
   UPDATE usesradky SET nazeva = 'Costs of other long-term investments' WHERE idsesradky = 381;
   UPDATE usesradky SET nazeva = 'Interest income and similar income' WHERE idsesradky = 382;
   UPDATE usesradky SET nazeva = 'Interest income and similar income - controlled or controlling entities' WHERE idsesradky = 383;
   UPDATE usesradky SET nazeva = 'Other interest income and similar income' WHERE idsesradky = 384;
   UPDATE usesradky SET nazeva = 'Financial value adjustments and provisions' WHERE idsesradky = 385;
   UPDATE usesradky SET nazeva = 'Interest costs and similar costs' WHERE idsesradky = 386;
   UPDATE usesradky SET nazeva = 'Interest costs and similar costs - controlled or controlling entities' WHERE idsesradky = 387;
   UPDATE usesradky SET nazeva = 'Other interest costs and similar costs' WHERE idsesradky = 388;
   UPDATE usesradky SET nazeva = 'Other financial income' WHERE idsesradky = 389;
   UPDATE usesradky SET nazeva = 'Other financial costs' WHERE idsesradky = 390;
   UPDATE usesradky SET nazeva = 'Financial result (+/-)' WHERE idsesradky = 391;
   UPDATE usesradky SET nazeva = 'Profit (loss) before taxation (+/-)' WHERE idsesradky = 392;
   UPDATE usesradky SET nazeva = 'Income tax' WHERE idsesradky = 393;
   UPDATE usesradky SET nazeva = 'Current income tax' WHERE idsesradky = 394;
   UPDATE usesradky SET nazeva = 'Deferred income tax' WHERE idsesradky = 395;
   UPDATE usesradky SET nazeva = 'Profit (loss) after taxation' WHERE idsesradky = 396;
   UPDATE usesradky SET nazeva = 'Share of profit (loss) transferred to partners (+/-)' WHERE idsesradky = 397;
   UPDATE usesradky SET nazeva = 'Profit (loss) for the financial period (+/-)' WHERE idsesradky = 398;
   UPDATE usesradky SET nazeva = 'Net sales for the financial period' WHERE idsesradky = 399;


   
    END IF;
  RETURN;
 END;
 $$ LANGUAGE plpgsql;
 ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;
   
select runupgrade();
drop function runupgrade();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
values (nextval('seq_dbversion'), 1041, 't', %appVersion%, clock_timestamp());