-----------------------------------------------------------------------
-- -- Bug 46722 - Nové kódy přenesení daňové povinnosti od 1.7.2017  
-----------------------------------------------------------------------

CREATE OR REPLACE FUNCTION doplnPrenDph(_kod varchar, _nazev varchar, _omezPrenDanPovK varchar, _platiOd integer, _platiDo integer)
  RETURNS void AS $$
DECLARE
  _uuid varchar;
  _idDphPren integer;
BEGIN
  _uuid = 'CZ_§92_' || _kod || '_' || _platiOd;
  _uuid = upper(_uuid);

  _idDphPren := (select iddphpren from udphpren where kod =_kod and platiod < coalesce(_platiDo, date_part('year', now())) ORDER BY platiod desc limit 1);
  
  if _idDphPren is not null then
    
    update udphpren set uuid = _uuid where iddphpren = _idDphPren and coalesce(uuid, '') <> _uuid;
    update udphpren set omezPrenDanPovK = 'omezPrenDanPov.bezOmezeni' where uuid = _uuid and coalesce(omezPrenDanPovK, '') <> 'omezPrenDanPov.bezOmezeni';
      
    if _platiDo is not null then
      update udphpren set platido = _platiDo where uuid = _uuid and coalesce(platido, 0) <> _platiDo;
    end if;
  else
    insert into udphpren (lastupdate, kod, nazev, omezPrenDanPovK, platiod, platido, uuid)
    values (now(), _kod, _nazev, 'omezPrenDanPov.' || _omezPrenDanPovK, _platiOd, _platiDo, _uuid);
  end if;

END;
$$ LANGUAGE plpgsql;

select doplnPrenDph('1a', '§ 92b – zlato – zprostředkování dodání investičního zlata', 'bezOmezeni', 2017, 9999);
select doplnPrenDph('3a', '§ 92d – dodání nemovité věci v nuceném prodeji', 'bezOmezeni', 2017, 9999);
select doplnPrenDph('4a', '§ 92e – stavební a montážní práce – poskytnutí pracovníků', 'bezOmezeni', 2017, 9999);
select doplnPrenDph('6', '§ 92ea – dodání zboží poskytnutého původně jako záruka', 'bezOmezeni', 2017, 9999);
select doplnPrenDph('7', '§ 92ea – dodání zboží po postoupení výhrady vlastnictví', 'bezOmezeni', 2017, 9999);

drop function doplnPrenDph(varchar,varchar,varchar,integer,integer);

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 1083, 't', %appVersion%, clock_timestamp());
