-----------------------------------
-- FB-309 Neefektivní práce s cenovými hladinami (fa Koláček)
-----------------------------------

DROP VIEW IF EXISTS ccenhladcenikview;
DROP VIEW IF EXISTS ccenhladview;
DROP VIEW IF EXISTS ccenhladusers;

-- pohled spojujici cenove hladiny s skupinami cen/firmami
CREATE VIEW ccenhladusers AS

select cast(null as integer) as idskupcen, cast(null as integer) as idfirmy, H.*
from ccenhlad H
where H.vsechnyfirmy = true

union all

select SC.idskupcen as idskupcen, cast(null as integer) as idfirmy, H.*
from ccenhlad H, cskc_chl SC
where H.vsechnyfirmy = false and H.idcenhlad = SC.idcenhlad

union all

select null as idskupcen, F.idfirmy as idfirmy, H.*
from ccenhlad H, cchl_adr F
where H.vsechnyfirmy = false and H.idcenhlad = F.idcenhlad

union all

-- hladina co neni nikde pouzita
select null as idskupcen, null as idfirmy, H.*
from ccenhlad H left outer join cskc_chl SC on H.idcenhlad = SC.idcenhlad 
left outer join cchl_adr F on H.idcenhlad = F.idcenhlad
where H.vsechnyfirmy = false and F.idfirmy is null and SC.idskupcen is null;

ALTER TABLE ccenhladusers OWNER TO %firmaRole%;

-- pohled spojujici predchozi pohled se skupinami zbozi
CREATE VIEW ccenhladview AS

select cast(null as integer) as idskupzboz, cast(null as integer) as idcenik, H.*
from ccenhladusers H
where H.vsechnyskupzboz = true

union all

select SZ.idskupzboz as idskupzboz, cast(null as integer) as idcenik, H.*
from ccenhladusers H, cchl_skz SZ
where H.vsechnyskupzboz = false and H.idcenhlad = SZ.idcenhlad
union all

select cast(null as integer) as idskupzboz, C.idcenik as idcenik, H.*
from ccenhladusers H, cchl_cen C
where H.vsechnyskupzboz = false and H.idcenhlad = C.idcenhlad

union all

-- hladina co neni nikde pouzita
select cast(null as integer) as idskupzboz, cast(null as integer) as idcenik, H.*
from ccenhladusers H left outer join cchl_skz SZ on H.idcenhlad = SZ.idcenhlad 
left outer join cchl_cen C on H.idcenhlad = C.idcenhlad
where H.vsechnyskupzboz = false and SZ.idskupzboz is null and C.idcenik is null;

ALTER TABLE ccenhladview OWNER TO %firmaRole%;

-- pohled spojujici hladiny s cenikovymi polozkami, cenikove skupiny, skupiny zbozi 
CREATE VIEW ccenhladcenikview as

  select cast(null as integer) as idskupzboz, cast(null as integer) as idcenik, cast(null as integer) as idskupcen, cast(null as integer) as idfirmy, h.*
  from ccenhlad h
  where (h.vsechnyfirmy = true or h.vsechnyskupzboz = true)
  
  union all
  
  select cast(null as integer) as idskupzboz, cast(null as integer) as idcenik, sc.idskupcen    as idskupcen, cast(null as integer) as idfirmy, h.*
  from ccenhlad h, cskc_chl sc
  where ((h.vsechnyfirmy = false and h.vsechnyskupzboz = false) and (h.idcenhlad = sc.idcenhlad))
  
  union all
  
  select sz.idskupzboz   as idskupzboz, cast(null as integer) as idcenik, cast(null as integer) as idskupcen, cast(null as integer) as idfirmy, h.*
  from ccenhlad h, cchl_skz sz
  where ((h.vsechnyfirmy = false and h.vsechnyskupzboz = false) and (h.idcenhlad = sz.idcenhlad))
  
  union all
  
  select cast(null as integer) as idskupzboz, cc.idcenik as idcenik, cast(null as integer) as idskupcen, cast(null as integer) as idfirmy, h.*
  from ccenhlad h, cchl_cen cc
  where ((h.vsechnyfirmy = false and h.vsechnyskupzboz = false) and (h.idcenhlad = cc.idcenhlad))
  
  union all
  
  select sz.idskupzboz as idskupzboz, cc.idcenik as idcenik, sc.idskupcen as idskupcen, cast(null as integer) as idfirmy, h.*
  from ((ccenhlad h
    left join cskc_chl sc on ((h.idcenhlad = sc.idcenhlad))
    left join cchl_skz sz on ((h.idcenhlad = sz.idcenhlad)))
    left join cchl_cen cc on ((h.idcenhlad = cc.idcenhlad)))
  where
    ((h.vsechnyfirmy = false and h.vsechnyskupzboz = false) and (sc.idskupcen is null) and (sz.idskupzboz is null) and (cc.idcenik is null));

ALTER TABLE ccenhladcenikview OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 1118, 't', %appVersion%, clock_timestamp());