----------------------------------------------------------------
-- Bug 13356 – [WinStrom] Přepočet dokladů u průměrných cen nefunguje
----------------------------------------------------------------
-- Function: snastavstavkartydne(integer, date, integer)
--DROP FUNCTION snastavstavkartydne(integer, date, integer, character varying);
CREATE OR REPLACE FUNCTION snastavstavkartydne(i_skladkartaid integer, i_datum date, i_polskladid integer)
  RETURNS void AS
$BODY$    
declare    
  zaznam Record; 
  _idPolSklad integer;
  _typPohybuK character varying;
begin 
  _idPolSklad := i_polskladid; 
  if(_idPolSklad < 0) then 
    _idPolSklad := -1*_idPolSklad; 
  end if;
  select typPohybuK into _typPohybuK from ddoklsklad where idDoklSklad = (select idDoklSklad from dpolsklad where idpolsklad = _idPolSklad);
  for zaznam in select * from (select *, (select typPohybuK from ddoklSklad where idDoklSklad = p.idDoklSklad) as typPohybuK from dPolSklad p) as vysledek
  where ((DatVyst > i_datum) or (DatVyst = i_datum and typpohybuk > _typPohybuK) or (DatVyst = i_datum and typPohybuK = _typPohybuK and idPolSklad > i_polskladid)) 
    and idKarty = i_skladkartaid
  order by DatVyst, typPohybuK, idPolSklad asc
  loop
    execute sOdectiSkladKartu(zaznam.MnozMJ,zaznam.CenaMj,zaznam.DatVyst,zaznam.idKarty,zaznam.idDoklSklad,zaznam.idskladu,-1);    
  end loop;    
end    
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION snastavstavkartydne(integer, date, integer) OWNER TO %firmaRole%;

-- Function: szapoctipolozkyoddata(integer, date, integer)
-- DROP FUNCTION szapoctipolozkyoddata(integer, date, integer);
CREATE OR REPLACE FUNCTION szapoctipolozkyoddata(i_skladkartaid integer, i_datum date, i_polskladid integer)
  RETURNS void AS
$BODY$     
declare     
  zaznam Record; 
  _polskladpomoc Record; 
  _sklfifo boolean;  
  _idPolSklad integer;
  _typPohybuK character varying;
begin    
  _idPolSklad := i_polskladid; 
  if(_idPolSklad < 0) then 
    _idPolSklad := -1*_idPolSklad; 
  end if;    
  select typPohybuK into _typPohybuK from ddoklsklad where idDoklSklad = (select idDoklSklad from dpolsklad where idpolsklad = _idPolSklad);
  for zaznam in select * from (select *, (select typPohybuK from ddoklSklad where idDoklSklad = p.idDoklSklad) as typPohybuK from dPolSklad p) as vysledek
  where ((DatVyst > i_datum) or (DatVyst = i_datum and typpohybuk > _typPohybuK) or (DatVyst = i_datum and typPohybuK = _typPohybuK and idPolSklad > i_polskladid)) 
    and idKarty = i_skladkartaid
  order by DatVyst, typPohybuK, idPolSklad asc
  loop    
    _sklfifo := (select isfifosklad(zaznam.datvyst));  
    if (_sklfifo <> true) then  
      execute sZmenCenyNaPolSklad(zaznam.idPolSklad, i_SkladKartaId, zaznam.iddoklsklad);    
    end if;  
 
    select * into _polskladpomoc from dpolsklad where idpolsklad = zaznam.idpolsklad; 
     
    execute sPrepoctiSkladKartu(_polskladpomoc.MnozMJ,_polskladpomoc.CenaMj,_polskladpomoc.DatVyst,_polskladpomoc.idKarty,_polskladpomoc.idDoklSklad,_polskladpomoc.idSkladu,1);     
  end loop;    
end;    
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION szapoctipolozkyoddata(integer, date, integer) OWNER TO %firmaRole%;

-- Function: sprepoctisklad(integer)
-- DROP FUNCTION sprepoctisklad(integer);
CREATE OR REPLACE FUNCTION sprepoctisklad(i_ucetobd integer)
  RETURNS void AS
$BODY$     
/* Prepocte stavy na skladove karte s id = iSkladKartaId */     
declare     
  /* Deklarace promennych */     
  _zaznam Record; 
  _skladKarta Record; 
  _dPolSkladPomoc Record; 
  _vyrobniCislo Record; 
  _pocatek_ucetobd Date; 
  _konec_ucetobd Date; 
  _typPohybuk character varying(255); 
  _sklfifo boolean; 
  _evidVyrCis boolean; 
  _prumCenaTuz numeric(19,6); 
  tmp_polsklad_exists boolean; 
   
begin 
  -- vytvoreni temporary tabulky na vypnuti triggeru 
  tmp_polsklad_exists := (select istableexist('tmp_polsklad')); 
  if(tmp_polsklad_exists <> true) then 
    CREATE TEMPORARY TABLE tmp_polsklad ( 
      idpolsklad integer 
    ) WITH (OIDS=TRUE); 
  end if; 
 
  -- nacteni datumu zacatku ucetniho obdobi 
  select platioddata, platidodata into _pocatek_ucetobd, _konec_ucetobd from nucetobdobi where iducetobdobi = i_ucetobd; 
 
  -- smazani tabulky fifo vazeb 
  delete from sfifovazby where idpolskladvydej in  
    (select idpolsklad from dpolsklad where  
            datVyst >= _pocatek_ucetobd and datVyst <= _konec_ucetobd); 
 
  delete from sfifovazby f 
    where f.idpolskladvydej not in (select p.idpolsklad from dpolsklad p); 
 
   
  -- nastaveni skladove karty na den zacatku ucetniho obdobi 
  for _skladKarta in select * from skarty where iducetobdobi = i_ucetobd loop 
    _prumCenaTuz := 0; 
    if(_skladKarta.pocatMj <> 0.0) then 
      _prumCenaTuz := _skladKarta.pocatTuz / _skladKarta.pocatMj; 
    end if; 
    update skarty set  
      prumcenatuz = _prumCenaTuz,  
      stavmj = _skladKarta.pocatMj,  
      stavtuz = _skladKarta.pocatTuz, 
      stavmen = _skladKarta.pocatMen 
      where idkarty = _skladKarta.idKarty; 
  end loop; 
 
  -- vypnuti triggeru 
  --alter table dpolsklad disable trigger all; 
  --alter table dpolsklad enable trigger dpolskladupdatezauctovano; 
  alter table dpolsklad disable trigger dpolskladinsert; 
  alter table dpolsklad disable trigger dpolskladupdate; 
  alter table dpolsklad disable trigger dpolskladdelete; 
 
  -- prepocet skladu 
  for _zaznam in select * from (select *, (select typPohybuK from dDoklSklad d where d.idDoklSklad = p.idDoklSklad) as typPohybuK from dPolSklad p) as doplneno  
    where datVyst >= _pocatek_ucetobd and datVyst <= _konec_ucetobd and storno = false 
    order by DatVyst, typPohybuK, idPolSklad asc loop 
    select typpohybuk into _typPohybuk from ddoklsklad where iddoklsklad = _zaznam.iddoklsklad;  
    --pokud výdej, tak fifuju vazby  
    if (_typPohybuk = 'typPohybu.vydej') then  
      select evidVyrCis into _evidVyrCis from ccenik where idcenik = _zaznam.idCenik; 
      if (not _evidVyrCis) then 
        execute sfifoVydej(_zaznam.idPolSklad, _zaznam.idCenik, _zaznam.idSkladu, _zaznam.idKarty, _zaznam.mnozmj); 
      else 
        for _vyrobniCislo in select * from svyrobnicislo where idpolskladvydej = _zaznam.idPolSklad loop 
          update svyrobnicislo set idpolskladvydej = null where idvyrobnicislo = _vyrobniCislo.idvyrobnicislo; 
          update svyrobnicislo set idpolskladvydej = _zaznam.idPolSklad where idvyrobnicislo = _vyrobniCislo.idvyrobnicislo; 
        end loop; 
      end if; 
      execute sPrepoctiSumyDokladu(_zaznam.idDoklSklad);  
    end if; 
 
    -- prumerne ceny  
    _sklfifo := (select isfifosklad(_zaznam.datvyst)); 
    if (_sklfifo <> true) then   
      execute sZmenCenyNaPolSklad(_zaznam.idPolSklad, _zaznam.idkarty, _zaznam.iddoklsklad);     
    end if; 
 
    select * into _dPolSkladPomoc from dpolsklad where idpolsklad = _zaznam.idpolsklad; 
     
    execute sPrepoctiSkladKartu(_dPolSkladPomoc.MnozMJ,_dPolSkladPomoc.CenaMJ,_dPolSkladPomoc.DatVyst,_dPolSkladPomoc.idKarty,_dPolSkladPomoc.idDoklSklad,_dPolSkladPomoc.idskladu,1); 
  end loop;  
 
  -- zapnuti triggeru 
  alter table dpolsklad enable trigger dpolskladinsert; 
  alter table dpolsklad enable trigger dpolskladupdate; 
  alter table dpolsklad enable trigger dpolskladdelete; 
end;     
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION sprepoctisklad(integer) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 179, 't');
