-- Function: createpolskladsada(integer, character varying)

-- DROP FUNCTION createpolskladsada(integer, character varying);

CREATE OR REPLACE FUNCTION createpolskladsada(_idpoldokl integer, _modul character varying)
  RETURNS void AS
$BODY$  
declare 
  _polDokl record; 
  _polozkaSady record; 
  _skladKarta record; 
  _cenik record; 
  _sklad record; 
  _idDoklSklad integer; 
  _idDoklad integer; 
  _idMeny integer; 
  _idUcetObdobi integer; 
  _idKarty integer; 
  _idPolSklad integer; 
  _idZklMdUcet integer; 
  _idZklDalUcet integer; 
  _i integer; 
  _cisRad integer; 
  _typDoklK character varying; 
  _mnozMj numeric(19,6); 
  _sumZkl numeric(19,6); 
  _sumZklMen numeric(19,6); 
  _cenaMj numeric(19,6); 
  _kurz numeric(19,6); 
  _isCiziMena boolean;
  _nasobic integer; 
begin 
 
  if(_modul like 'FAV' or _modul like 'FAP') then  
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl;  
    _idDoklad = _polDokl.idDoklFak;  
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak);  
  else  
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl;  
    _idDoklad = _polDokl.idDoklInt;  
    _typDoklK = null; -- pro pokladnu dobropisy nejsou  
  end if; 
 
  select findParovanyDoklSklad(_idDoklad, _modul) into _idDoklSklad;  
   
  if(_idDoklSklad is null) then  
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad;  
  end if; 
 
  select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz; 
  select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena;  
  select idMeny into _idMeny from dDoklSklad where idDoklSklad = _idDoklSklad; 
 
  select * into _sklad from dTypDokl where idTypDokl = _polDokl.idSkladu;  
 
  _i = 0; 
 
  FOR _polozkaSady IN 
    select * from cSady where idCenikSada = _polDokl.idCenik 
  LOOP 
    select * into _cenik from cCenik where idCenik = _polozkaSady.idCenik; 
 
    if(_cenik.typZasobyK like 'typZasoby.skladem' or _cenik.typZasobyK like 'typZasoby.vyrobek') then 
      _i = _i + 1; 
      _cisRad = 100 * _polDokl.cisRad + _i; 
   
      select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi;  
     
      select * into _skladKarta from skarty  
        where idTypDokl = _polDokl.idSkladu and idCenik = _polozkaSady.idCenik and idUcetObdobi = _idUcetObdobi; 

      _nasobic = 1;
      if(_typDoklK like 'typDokladu.dobropis') then
        _nasobic = -1;
      end if;
      _mnozMj = _polozkaSady.mnozMj * _polDokl.mnozMj * _nasobic; 
      _cenaMj = _skladKarta.prumCenaTuz / _kurz; 
      _sumZkl = _mnozMj * _skladKarta.prumCenaTuz; 
      if(_isCiziMena) then  
        _sumZklMen = _mnozMj * _cenaMj;  
      else  
        _sumZklMen = 0.0;  
      end if; 
     
      -- nastaveni uctu pro polSklad vydej  
      --select findZklMdUcetIfVydej(_idPolDokl, _modul) into _idZklMdUcet;  
      select idProtiUcetSklV into _idZklMdUcet from cSkupZboz where idSkupZboz = _cenik.idSkupZboz;  
      if(_idZklMdUcet is null) then  
        select idProtiUcetV into _idZklMdUcet from uTypUcOp where idTypUcOp = (select idTypUcOpV from dTypDokl where idTypDokl = _polDokl.idSkladu);  
      end if;  
   
      _idZklDalUcet = _sklad.idPrimUcet; 
 
      select nextval('seq_dpolsklad') into _idPolSklad; 
      insert into dpolsklad(idPolSklad, idcenik, idskladu, idkarty, datVyst, datUcto, modul, typPolozkyK, idDoklSklad,     
          mnozMj, cenaMj, sumZkl, sumZklMen, idZklMdUcet, idZklDalUcet, kopZklMdUcet, kopZklDalUcet, baleniid, mnozBaleni,    
          nazev, nazevA, nazevB, nazevC, sarze, expirace, cisRad, ucetni,   
          idStred, idZakazky, idMeny)    
        values (_idPolSklad, _polozkaSady.idcenik, _polDokl.idskladu, _skladKarta.idKarty, _polDokl.datVyst, _polDokl.datVyst, 'SKL', 'typPolozky.katalog', _idDoklSklad,     
          _mnozMj, _cenaMj, _sumZkl, _sumZklMen, _idZklMdUcet, _idZklDalUcet, false, false, _polDokl.baleniid, 0.0, 
          _cenik.nazev, _cenik.nazevA, _cenik.nazevB, _cenik.nazevC, null, null, _cisRad, true,   
          _polDokl.idStred, _polDokl.idZakazky, _idMeny); 
 
      insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK)  
        values (0.0, _idPolDokl, _idPolSklad, _modul, 'SKL', false, 'typVazbyDokl.polozkaSklSada');  
    end if; 
  END LOOP; 
 
  execute sprepoctiSumyDokladu(_idDoklSklad);  
end;  
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION createpolskladsada(integer, character varying) OWNER TO %firmaRole%;


-- Function: deletenavazanepolsklad(integer, character varying)

-- DROP FUNCTION deletenavazanepolsklad(integer, character varying);

CREATE OR REPLACE FUNCTION deletenavazanepolsklad(_idpoldokl integer, _modul character varying)
  RETURNS void AS
$BODY$ 
declare 
  _idPolSklad integer; 
  _idVazbyPolSklad integer; 
  _idPolSkladRozpad integer; 
begin 
  for _idPolSklad in select idTabB from dvazebtab where 
    typVazbyK like 'typVazbyDokl.polozkaSkl'  
    and idTabA = _idPolDokl and modulA = _modul and modulB = 'SKL' 
    loop 
 
    for _idVazbyPolSklad in select idVazbyPolSklad from sVazbyPolSklad where idPolSkladZdroj = _idPolSklad loop  
      select idPolSkladCil into _idPolSkladRozpad from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;  
      delete from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;  
      delete from dPolSklad where idPolSklad = _idPolSkladRozpad;  
    end loop; 
 
    delete from dVazebTab where idTabA = _idPolDokl and idTabB = _idPolSklad   
      and modulA like _modul and modulB like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSkl';  
    delete from dVazebTab where idTabB = _idPolDokl and idTabA = _idPolSklad   
      and modulB like _modul and modulA like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSkl';  
    delete from dPolSklad where idPolSklad = _idPolSklad;    
  end loop; 
 
  for _idPolSklad in select idTabA from dvazebtab where 
    typVazbyK like 'typVazbyDokl.polozkaSkl'  
    and idTabB = _idPolDokl and modulB = _modul and modulA = 'SKL' 
    loop 
 
    for _idVazbyPolSklad in select idVazbyPolSklad from sVazbyPolSklad where idPolSkladZdroj = _idPolSklad loop  
      select idPolSkladCil into _idPolSkladRozpad from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;  
      delete from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;  
      delete from dPolSklad where idPolSklad = _idPolSkladRozpad;  
    end loop; 
 
    delete from dVazebTab where idTabA = _idPolDokl and idTabB = _idPolSklad   
      and modulA like _modul and modulB like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSkl';  
    delete from dVazebTab where idTabB = _idPolDokl and idTabA = _idPolSklad   
      and modulB like _modul and modulA like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSkl';  
    delete from dPolSklad where idPolSklad = _idPolSklad;    
  end loop; 

  for _idPolSklad in select idTabB from dvazebtab where 
    typVazbyK like 'typVazbyDokl.polozkaSklSada'  
    and idTabA = _idPolDokl and modulA = _modul and modulB = 'SKL' 
    loop 
 
    for _idVazbyPolSklad in select idVazbyPolSklad from sVazbyPolSklad where idPolSkladZdroj = _idPolSklad loop  
      select idPolSkladCil into _idPolSkladRozpad from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;  
      delete from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;  
      delete from dPolSklad where idPolSklad = _idPolSkladRozpad;  
    end loop; 
 
    delete from dVazebTab where idTabA = _idPolDokl and idTabB = _idPolSklad   
      and modulA like _modul and modulB like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSklSada';  
    delete from dVazebTab where idTabB = _idPolDokl and idTabA = _idPolSklad   
      and modulB like _modul and modulA like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSklSada';  
    delete from dPolSklad where idPolSklad = _idPolSklad;    
  end loop; 

  for _idPolSklad in select idTabA from dvazebtab where 
    typVazbyK like 'typVazbyDokl.polozkaSklSada'  
    and idTabB = _idPolDokl and modulB = _modul and modulA = 'SKL' 
    loop 
 
    for _idVazbyPolSklad in select idVazbyPolSklad from sVazbyPolSklad where idPolSkladZdroj = _idPolSklad loop  
      select idPolSkladCil into _idPolSkladRozpad from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;  
      delete from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;  
      delete from dPolSklad where idPolSklad = _idPolSkladRozpad;  
    end loop; 
 
    delete from dVazebTab where idTabA = _idPolDokl and idTabB = _idPolSklad   
      and modulA like _modul and modulB like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSklSada';  
    delete from dVazebTab where idTabB = _idPolDokl and idTabA = _idPolSklad   
      and modulB like _modul and modulA like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSklSada';  
    delete from dPolSklad where idPolSklad = _idPolSklad;    
  end loop; 

  for _idPolSklad in select idTabB from dvazebtab where 
    typVazbyK like 'typVazbyDokl.polozkaSklKus'  
    and idTabA = _idPolDokl and modulA = _modul and modulB = 'SKL' 
    loop 
 
    for _idVazbyPolSklad in select idVazbyPolSklad from sVazbyPolSklad where idPolSkladZdroj = _idPolSklad loop  
      select idPolSkladCil into _idPolSkladRozpad from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;  
      delete from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;  
      delete from dPolSklad where idPolSklad = _idPolSkladRozpad;  
    end loop; 
 
    delete from dVazebTab where idTabA = _idPolDokl and idTabB = _idPolSklad   
      and modulA like _modul and modulB like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSklKus'; 
    delete from dVazebTab where idTabB = _idPolDokl and idTabA = _idPolSklad   
      and modulB like _modul and modulA like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSklKus'; 
    delete from dPolSklad where idPolSklad = _idPolSklad;    
  end loop; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION deletenavazanepolsklad(integer, character varying) OWNER TO %firmaRole%;



-- Function: findparovanypolsklad(integer, character varying)

-- DROP FUNCTION findparovanypolsklad(integer, character varying);

CREATE OR REPLACE FUNCTION findparovanypolsklad(_idpoldokl integer, _modul character varying)
  RETURNS integer AS
$BODY$ 
declare 
  _idPolSklad integer; 
begin 
  select idTabB into _idPolSklad from dvazebtab where 
    typVazbyK like 'typVazbyDokl.polozkaSkl' 
    and idTabA = _idPolDokl and modulA = _modul; 
  if(_idPolSklad is null) then 
    select idTabB into _idPolSklad from dvazebtab where 
      typVazbyK like 'typVazbyDokl.polozkaSklSada' 
      and idTabA = _idPolDokl and modulA = _modul; 
  end if; 
  if(_idPolSklad is null) then 
    select idTabA into _idPolSklad from dvazebtab where 
      typVazbyK like 'typVazbyDokl.polozkaSkl' 
      and idTabB = _idPolDokl and modulB = _modul; 
  end if; 
  if(_idPolSklad is null) then 
    select idTabA into _idPolSklad from dvazebtab where 
      typVazbyK like 'typVazbyDokl.polozkaSklSada' 
      and idTabB = _idPolDokl and modulB = _modul; 
  end if; 
  return _idPolSklad; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION findparovanypolsklad(integer, character varying) OWNER TO %firmaRole%;



-- Function: fillpolskladsada(integer, character varying)

-- DROP FUNCTION fillpolskladsada(integer, character varying);

CREATE OR REPLACE FUNCTION fillpolskladsada(_idpoldokl integer, _modul character varying)
  RETURNS void AS
$BODY$  
declare  
  _polDokl record;  
  _polSklad record;  
  _idDoklad integer;  
  _typPohybuK character varying;  
  _typPohybuSklad character varying;  
  _cenaMj numeric(19,6);  
  _cenaMjTuz numeric(19,6);  
  _mnozMj numeric(19,6);  
  _sumZkl numeric(19,6);  
  _sumZklMen numeric(19,6);  
  _idDoklSklad integer;  
  _idUcetObdobi integer;  
  _idKarty integer;  
  _sklad record;  
  _kurz numeric(19,6);  
  _prumCenaTuz numeric(19,6);  
  _isCiziMena boolean;  
  _typDoklK character varying;  
  _idZklMdUcet integer;  
  _idZklDalUcet integer;  
begin 
  if(_modul like 'POK') then  
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl;  
    select idDoklInt, typPohybuK into _idDoklad, _typPohybuK from dDoklInt where idDoklInt = _polDokl.idDoklInt;  
    _typDoklK = null; -- pro pokladnu dobropisy nejsou  
  else  
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl;  
    select idDoklFak, typPohybuK into _idDoklad, _typPohybuK from dDoklFak where idDoklFak = _polDokl.idDoklFak;  
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak);  
  end if;  
 
  select findParovanyDoklSklad(_idDoklad, _modul) into _idDoklSklad;  
  if(_idDoklSklad is null) then  
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad;  
  end if;  
 
  for _polSklad in  
    select * from dPolSklad where idPolSklad in ( 
      select idTabB from dvazebtab where 
        typVazbyK like 'typVazbyDokl.polozkaSklSada'  
        and idTabA = _idPolDokl and modulA = _modul and modulB = 'SKL' 
    ) 
  loop 
    select typPohybuK into _typPohybuSklad from dDoklSklad where idDoklSklad = _polSklad.idDoklSklad;  
  
    select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi;  
    select idkarty into _idkarty from skarty where idcenik = _polDokl.idcenik and idtypdokl = _polDokl.idskladu and iducetobdobi = _iducetobdobi;  
    select * into _sklad from dTypDokl where idTypDokl = _polDokl.idSkladu;  
    
    select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz;  
    select prumCenaTuz into _prumCenaTuz from sKarty where idKarty = _idKarty;  
    select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena;  
  
    -- pokud vydavam ze skladu tak ma byt pouzita prumerna cena  
    _cenaMj = _polSklad.cenaMj;  
    _mnozMj = _polSklad.mnozMj;  
    _sumZkl = _polSklad.sumZkl;  
    _sumZklMen = _polSklad.sumZklMen;  
    -- nastaveni uctu pro polSklad vydej  
    --TODO doresit zklMdUcet; 
    --select findZklMdUcetIfVydej(_idPolDokl, _modul) into _idZklMdUcet;  
    _idZklDalUcet = _sklad.idPrimUcet;  
    
    update dPolSklad set   
      cenaMj = _cenaMj,   
      mnozMj = _mnozMj,   
      sumZkl = _sumZkl,   
      sumZklMen = _sumZklMen,   
      --nazev = _polDokl.nazev,   
      --nazevA = _polDokl.nazevA,   
      --nazevB = _polDokl.nazevB,   
      --nazevC = _polDokl.nazevC,   
      datVyst = _polDokl.datVyst,   
      baleniId = _polDokl.baleniId,   
      mnozBaleni = _polDokl.mnozBaleni,   
      --sarze = _polDokl.sarze,   
      --expirace = _polDokl.expirace,   
      --cisRad = _polDokl.cisRad,   
      --eankod = _polDokl.eanKod,   
      --idmj = _polDokl.idmj,   
      idStred = _polDokl.idStred,   
      idMeny = _polSklad.idMeny,   
      idZakazky = _polDokl.idZakazky,   
      --idZklMdUcet = _idZklMdUcet,   
      idZklDalUcet = _idZklDalUcet,  
      ucetni = true  
      where idPolSklad = _polSklad.idPolSklad;  
  end loop; 
  --return _idPolSklad;  
end;  
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION fillpolskladsada(integer, character varying) OWNER TO %firmaRole%;


-- zvyseni cisla verze db
insert into dbversion(iddbversion, dbversion, needreimport)
        values (nextval('seq_dbversion'), 206, 't');
