--------------------------------------------------------------------------------
-- Bug 17557 – [WinStrom] Aktualizace kalkulačky na rok 2010
--------------------------------------------------------------------------------

-- trigger prenasejici zmeny na ciselniku i na slozky
CREATE OR REPLACE FUNCTION pcismzdslozupdatemzdsloz()
  RETURNS trigger AS $$
begin
  -- neresi zmenu pole naOsobu, je treba osetrit ve scriptu protoze to je slozitejsi
  if (NEW.kod <> OLD.kod or NEW.nazev <> OLD.nazev or NEW.pracovni <> OLD.pracovni or NEW.typSlozkyK <> OLD.typSlozkyK or NEW.skupSlozkyK <> OLD.skupSlozkyK) then
    UPDATE pmzdsloz SET kod = NEW.kod, nazev = NEW.nazev, pracovni = NEW.pracovni, typSlozkyK = NEW.typSlozkyK, skupSlozkyK = NEW.skupSlozkyK
      WHERE idCisMzdSloz = NEW.idCisMzdSloz;
  end if;

  return NEW;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.pcismzdslozupdatemzdsloz() OWNER TO %firmaRole%;

CREATE TRIGGER pcismzdslozupdatemzdsloz AFTER UPDATE ON pcismzdsloz
  FOR EACH ROW EXECUTE PROCEDURE pcismzdslozupdatemzdsloz();

-- uprava aby se smeny generovali i mimo ucetni obdobi, slouzi pro pripad, kdy byl nemocnej jeste pred tim nez my mame prvni obdobi
CREATE OR REPLACE FUNCTION pgeneratemzdslozforpracpom(_idpracpom integer)
  RETURNS void AS $$
declare
  _od date;
  _do date;
  _odAkt date;
  rokod integer;
  rokdo integer;
  mesicod integer;
  mesicdo integer;
  rokOdAkt integer;
  mesicOdAkt integer;
  
  mesforod integer;
  mesfordo integer;
  aktrok integer;
  aktmesic integer;
  aktdatum date;
begin
  select min(platioddata), max(platidodata) into _od, _do from nucetobdobi;
  rokod = date_part('year', _od);
  rokdo = date_part('year', _do);
  mesicod = date_part('month', _od);
  mesicdo = date_part('month', _do);
  
  if  (_idpracpom > -1) then        -- pokud delame jenom jeden pracovni pomer delame smeny i mimo obdobi
    select aktivniod into _odAkt from ppracpomhlav where idpracpomhlav = _idpracpom;
    rokOdAkt = date_part('year', _odAkt);
    mesicOdAkt = date_part('month', _odAkt);
    
    for aktrok in rokOdAkt..rokod loop
      mesforod = 1;
      mesfordo = 12;
      if (aktrok = rokOdAkt) then
        mesforod = mesicOdAkt;
      end if;  
      if (aktrok = rokod) then
        mesfordo = mesicod - 1;
      end if;
    
      -- a mesice
      for aktmesic in mesforod..mesfordo loop
        -- smeny
        perform pgeneratesmenyforpracpom(_idpracpom, aktrok, aktmesic);
      end loop;
    end loop;
  end if; 
  
  -- vymazeme nadbytecne
  delete from pmzdsloz where (rok < rokod or (rok = rokod and mesic < mesicod)) or (rok > rokdo or (rok = rokdo and mesic > mesicdo));
  delete from psmeny where (rok > rokdo or (rok = rokdo and mesic > mesicdo));
  
  -- prochazime roky
  for aktrok in rokod..rokdo loop
    mesforod = 1;
    mesfordo = 12;
    if (aktrok = rokod) then
      mesforod = mesicod;
    end if;  
    if (aktrok = rokdo) then
      mesfordo = mesicdo;
    end if;
    
    -- a mesice
    for aktmesic in mesforod..mesfordo loop
      aktdatum = date (aktrok || '-' || aktmesic || '-01');
      
      perform pgeneratemzdslozforpracpomandmesic(idpracpomhlav, aktrok, aktmesic) from ppracpomhlav where
        (_idpracpom = -1 or idpracpomhlav = _idpracpom) and (aktivnido is null or aktdatum <= aktivnido) and 
        (aktivniod is null or date_part('year', aktivniod) < aktrok or (date_part('year', aktivniod) = aktrok and date_part('month', aktivniod) <= aktmesic));
    end loop;
  end loop;
end; 
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.pgeneratemzdslozforpracpom(integer) OWNER TO %firmaRole%;

-- update kalkulacky
create or replace function runupgrade()
    returns void as $$
declare
    stat character varying(10);
    pocet integer;
begin
  select a.uuid into stat from nnastav n  left join utyporg u on u.idtyporg = n.idtyporg left join astaty a on a.idstatu = u.idstatu
    where ((select max(platioddata) from nnastav) is null or (select max(platioddata) from nnastav) = platioddata);
  
  -- kalkulacku aktualizujeme jen pro cechy
  if (stat = 'CZ_CZ') then
-- zacatek ceskeho bloku
-- update slozek
UPDATE pcismzdsloz SET nazev = 'Dovolená' WHERE IdCisMzdSloz = 2;
UPDATE pcismzdsloz SET nazev = 'Neodpracovaná doba' WHERE IdCisMzdSloz = 16;
UPDATE pcismzdsloz SET nazev = 'Náhrada za nemoc' WHERE IdCisMzdSloz = 70;
UPDATE pcismzdsloz SET pracovni = false WHERE IdCisMzdSloz = 108;
UPDATE pcismzdsloz SET nazev = 'Mateřská dovolená ', popis = '(vstupuje do vyloučených dob v ELDP) ' WHERE IdCisMzdSloz = 150;
UPDATE pcismzdsloz SET nazev = 'Rodičovská dovolená', popis = '(nevstupuje do vyloučených dob v ELDP) ' WHERE IdCisMzdSloz = 151;
UPDATE pcismzdsloz SET nazev = 'Náhrada za karanténu' WHERE IdCisMzdSloz = 177;
UPDATE pcismzdsloz SET nazev = 'Vybraná dovolená' WHERE IdCisMzdSloz = 185;
UPDATE pcismzdsloz SET nazev = 'Zbývající dovolená' WHERE IdCisMzdSloz = 186;
UPDATE pcismzdsloz SET nazev = 'Celková náhrada za nemoc' WHERE IdCisMzdSloz = 226;


-- update inicializacnich radek kalkulacky
UPDATE pmzdcalcinit SET platnostk = 'mzdCalcPlatnost.vzdy' WHERE IdMzdCalcInit = 2;

-- update radek kalkulacky
UPDATE pmzdcalc SET cisrad = 215, zaokrjakk = null, zaokrnak = null WHERE IdMzdCalc = 96;
UPDATE pmzdcalc SET cisrad = 220 WHERE IdMzdCalc = 97;
UPDATE pmzdcalc SET cisrad = 221 WHERE IdMzdCalc = 98;
UPDATE pmzdcalc SET cisrad = 261 WHERE IdMzdCalc = 99;
UPDATE pmzdcalc SET cisrad = 231 WHERE IdMzdCalc = 100;
UPDATE pmzdcalc SET cisrad = 260 WHERE IdMzdCalc = 101;
UPDATE pmzdcalc SET cisrad = 232 WHERE IdMzdCalc = 103;
UPDATE pmzdcalc SET cisrad = 238 WHERE IdMzdCalc = 104;
UPDATE pmzdcalc SET cisrad = 239 WHERE IdMzdCalc = 106;
UPDATE pmzdcalc SET cisrad = 240 WHERE IdMzdCalc = 107;
UPDATE pmzdcalc SET cisrad = 241 WHERE IdMzdCalc = 108;
UPDATE pmzdcalc SET cisrad = 242 WHERE IdMzdCalc = 109;
UPDATE pmzdcalc SET cisrad = 243 WHERE IdMzdCalc = 110;
UPDATE pmzdcalc SET cisrad = 249 WHERE IdMzdCalc = 111;
UPDATE pmzdcalc SET cisrad = 267 WHERE IdMzdCalc = 112;
UPDATE pmzdcalc SET cisrad = 268 WHERE IdMzdCalc = 113;
UPDATE pmzdcalc SET cisrad = 265 WHERE IdMzdCalc = 114;
UPDATE pmzdcalc SET cisrad = 269 WHERE IdMzdCalc = 117;
UPDATE pmzdcalc SET cisrad = 235, polein = 'zaklMzd;zaklMzd', poleout = 'zaklMzd;procMzd' WHERE IdMzdCalc = 123;
UPDATE pmzdcalc SET cisrad = 222 WHERE IdMzdCalc = 124;
UPDATE pmzdcalc SET cisrad = 248 WHERE IdMzdCalc = 125;
UPDATE pmzdcalc SET cisrad = 233 WHERE IdMzdCalc = 130;
UPDATE pmzdcalc SET cisrad = 236 WHERE IdMzdCalc = 131;
UPDATE pmzdcalc SET cisrad = 245 WHERE IdMzdCalc = 136;
UPDATE pmzdcalc SET cisrad = 263 WHERE IdMzdCalc = 139;
UPDATE pmzdcalc SET cisrad = 264 WHERE IdMzdCalc = 140;
UPDATE pmzdcalc SET cisrad = 262 WHERE IdMzdCalc = 145;
UPDATE pmzdcalc SET cisrad = 266 WHERE IdMzdCalc = 146;
UPDATE pmzdcalc SET cisrad = 271 WHERE IdMzdCalc = 147;
UPDATE pmzdcalc SET cisrad = 274 WHERE IdMzdCalc = 172;
UPDATE pmzdcalc SET cisrad = 275 WHERE IdMzdCalc = 173;
UPDATE pmzdcalc SET cisrad = 276 WHERE IdMzdCalc = 174;
UPDATE pmzdcalc SET cisrad = 277 WHERE IdMzdCalc = 175;
UPDATE pmzdcalc SET cisrad = 272 WHERE IdMzdCalc = 193;
UPDATE pmzdcalc SET cisrad = 273 WHERE IdMzdCalc = 194;
UPDATE pmzdcalc SET cisrad = 283 WHERE IdMzdCalc = 195;
UPDATE pmzdcalc SET cisrad = 292 WHERE IdMzdCalc = 196;
UPDATE pmzdcalc SET cisrad = 278 WHERE IdMzdCalc = 197;
UPDATE pmzdcalc SET cisrad = 284 WHERE IdMzdCalc = 198;
UPDATE pmzdcalc SET cisrad = 294 WHERE IdMzdCalc = 200;
UPDATE pmzdcalc SET cisrad = 286 WHERE IdMzdCalc = 201;
UPDATE pmzdcalc SET cisrad = 285 WHERE IdMzdCalc = 202;
UPDATE pmzdcalc SET cisrad = 293 WHERE IdMzdCalc = 206;
UPDATE pmzdcalc SET cisrad = 295 WHERE IdMzdCalc = 207;
UPDATE pmzdcalc SET cisrad = 297 WHERE IdMzdCalc = 213;
UPDATE pmzdcalc SET cisrad = 298 WHERE IdMzdCalc = 214;
UPDATE pmzdcalc SET cisrad = 299 WHERE IdMzdCalc = 215;
UPDATE pmzdcalc SET cisrad = 310 WHERE IdMzdCalc = 221;
UPDATE pmzdcalc SET cisrad = 305 WHERE IdMzdCalc = 222;
UPDATE pmzdcalc SET cisrad = 309 WHERE IdMzdCalc = 223;
UPDATE pmzdcalc SET cisrad = 251 WHERE IdMzdCalc = 227;
UPDATE pmzdcalc SET cisrad = 253 WHERE IdMzdCalc = 238;
UPDATE pmzdcalc SET cisrad = 250 WHERE IdMzdCalc = 239;
UPDATE pmzdcalc SET cisrad = 254 WHERE IdMzdCalc = 240;
UPDATE pmzdcalc SET cisrad = 256 WHERE IdMzdCalc = 241;
UPDATE pmzdcalc SET cisrad = 257 WHERE IdMzdCalc = 245;
UPDATE pmzdcalc SET cisrad = 258 WHERE IdMzdCalc = 247;
UPDATE pmzdcalc SET cisrad = 259 WHERE IdMzdCalc = 249;
UPDATE pmzdcalc SET cisrad = 306 WHERE IdMzdCalc = 256;
UPDATE pmzdcalc SET cisrad = 356 WHERE IdMzdCalc = 307;
UPDATE pmzdcalc SET cisrad = 358 WHERE IdMzdCalc = 308;
UPDATE pmzdcalc SET cisrad = 311 WHERE IdMzdCalc = 310;
UPDATE pmzdcalc SET cisrad = 312 WHERE IdMzdCalc = 311;
UPDATE pmzdcalc SET cisrad = 313 WHERE IdMzdCalc = 328;
UPDATE pmzdcalc SET cisrad = 314 WHERE IdMzdCalc = 329;
UPDATE pmzdcalc SET cisrad = 315 WHERE IdMzdCalc = 330;
UPDATE pmzdcalc SET cisrad = 316 WHERE IdMzdCalc = 331;
UPDATE pmzdcalc SET cisrad = 296 WHERE IdMzdCalc = 333;
UPDATE pmzdcalc SET cisrad = 237 WHERE IdMzdCalc = 353;
UPDATE pmzdcalc SET cisrad = 255 WHERE IdMzdCalc = 356;
UPDATE pmzdcalc SET cisrad = 355 WHERE IdMzdCalc = 358;
UPDATE pmzdcalc SET cisrad = 357 WHERE IdMzdCalc = 359;
UPDATE pmzdcalc SET cisrad = 223 WHERE IdMzdCalc = 361;
UPDATE pmzdcalc SET cisrad = 224 WHERE IdMzdCalc = 362;
UPDATE pmzdcalc SET cisrad = 225 WHERE IdMzdCalc = 363;
UPDATE pmzdcalc SET cisrad = 226 WHERE IdMzdCalc = 364;
UPDATE pmzdcalc SET cisrad = 228 WHERE IdMzdCalc = 365;
UPDATE pmzdcalc SET cisrad = 229 WHERE IdMzdCalc = 367;
UPDATE pmzdcalc SET cisrad = 230 WHERE IdMzdCalc = 368;
UPDATE pmzdcalc SET cisrad = 246 WHERE IdMzdCalc = 369;
UPDATE pmzdcalc SET cisrad = 247 WHERE IdMzdCalc = 370;
UPDATE pmzdcalc SET cisrad = 279 WHERE IdMzdCalc = 379;
UPDATE pmzdcalc SET cisrad = 280 WHERE IdMzdCalc = 380;
UPDATE pmzdcalc SET cisrad = 281 WHERE IdMzdCalc = 381;
UPDATE pmzdcalc SET cisrad = 282 WHERE IdMzdCalc = 382;
UPDATE pmzdcalc SET cisrad = 287 WHERE IdMzdCalc = 383;
UPDATE pmzdcalc SET cisrad = 288 WHERE IdMzdCalc = 384;
UPDATE pmzdcalc SET cisrad = 289 WHERE IdMzdCalc = 385;
UPDATE pmzdcalc SET cisrad = 291 WHERE IdMzdCalc = 386;
UPDATE pmzdcalc SET cisrad = 290 WHERE IdMzdCalc = 387;
UPDATE pmzdcalc SET cisrad = 317 WHERE IdMzdCalc = 388;
UPDATE pmzdcalc SET cisrad = 308 WHERE IdMzdCalc = 405;
UPDATE pmzdcalc SET cisrad = 217 WHERE IdMzdCalc = 408;
UPDATE pmzdcalc SET cisrad = 307 WHERE IdMzdCalc = 410;
UPDATE pmzdcalc SET cisrad = 318 WHERE IdMzdCalc = 413;
UPDATE pmzdcalc SET cisrad = 319 WHERE IdMzdCalc = 414;
UPDATE pmzdcalc SET cisrad = 320 WHERE IdMzdCalc = 415;
UPDATE pmzdcalc SET cisrad = 321 WHERE IdMzdCalc = 416;
UPDATE pmzdcalc SET cisrad = 322 WHERE IdMzdCalc = 418;
UPDATE pmzdcalc SET cisrad = 323 WHERE IdMzdCalc = 420;
UPDATE pmzdcalc SET cisrad = 326 WHERE IdMzdCalc = 421;
UPDATE pmzdcalc SET cisrad = 327 WHERE IdMzdCalc = 422;
UPDATE pmzdcalc SET cisrad = 341 WHERE IdMzdCalc = 423;
UPDATE pmzdcalc SET cisrad = 331 WHERE IdMzdCalc = 424;
UPDATE pmzdcalc SET cisrad = 334 WHERE IdMzdCalc = 425;
UPDATE pmzdcalc SET cisrad = 324 WHERE IdMzdCalc = 426;
UPDATE pmzdcalc SET cisrad = 325 WHERE IdMzdCalc = 427;
UPDATE pmzdcalc SET cisrad = 328 WHERE IdMzdCalc = 428;
UPDATE pmzdcalc SET cisrad = 333 WHERE IdMzdCalc = 429;
UPDATE pmzdcalc SET cisrad = 340 WHERE IdMzdCalc = 430;
UPDATE pmzdcalc SET cisrad = 335 WHERE IdMzdCalc = 431;
UPDATE pmzdcalc SET cisrad = 336 WHERE IdMzdCalc = 432;
UPDATE pmzdcalc SET cisrad = 337 WHERE IdMzdCalc = 433;
UPDATE pmzdcalc SET cisrad = 338 WHERE IdMzdCalc = 434;
UPDATE pmzdcalc SET cisrad = 339 WHERE IdMzdCalc = 435;
UPDATE pmzdcalc SET cisrad = 342 WHERE IdMzdCalc = 436;
UPDATE pmzdcalc SET cisrad = 345 WHERE IdMzdCalc = 454;
UPDATE pmzdcalc SET cisrad = 332 WHERE IdMzdCalc = 455;
UPDATE pmzdcalc SET cisrad = 302 WHERE IdMzdCalc = 456;
UPDATE pmzdcalc SET cisrad = 303 WHERE IdMzdCalc = 457;
UPDATE pmzdcalc SET cisrad = 304 WHERE IdMzdCalc = 458;
UPDATE pmzdcalc SET cisrad = 227 WHERE IdMzdCalc = 471;
UPDATE pmzdcalc SET cisrad = 244 WHERE IdMzdCalc = 472;
UPDATE pmzdcalc SET cisrad = 234 WHERE IdMzdCalc = 477;
UPDATE pmzdcalc SET cisrad = 270 WHERE IdMzdCalc = 478;
UPDATE pmzdcalc SET cisrad = 346 WHERE IdMzdCalc = 488;
UPDATE pmzdcalc SET cisrad = 343 WHERE IdMzdCalc = 495;
UPDATE pmzdcalc SET cisrad = 344 WHERE IdMzdCalc = 496;
UPDATE pmzdcalc SET cisrad = 252 WHERE IdMzdCalc = 513;
UPDATE pmzdcalc SET cisrad = 301 WHERE IdMzdCalc = 514;
UPDATE pmzdcalc SET cisrad = 347 WHERE IdMzdCalc = 516;
UPDATE pmzdcalc SET cisrad = 348 WHERE IdMzdCalc = 517;
UPDATE pmzdcalc SET cisrad = 349 WHERE IdMzdCalc = 518;
UPDATE pmzdcalc SET cisrad = 350 WHERE IdMzdCalc = 519;
UPDATE pmzdcalc SET cisrad = 351 WHERE IdMzdCalc = 520;
UPDATE pmzdcalc SET cisrad = 352 WHERE IdMzdCalc = 521;
UPDATE pmzdcalc SET cisrad = 300 WHERE IdMzdCalc = 522;
UPDATE pmzdcalc SET cisrad = 330 WHERE IdMzdCalc = 523;
UPDATE pmzdcalc SET cisrad = 329 WHERE IdMzdCalc = 524;
UPDATE pmzdcalc SET cisrad = 359 WHERE IdMzdCalc = 530;
UPDATE pmzdcalc SET cisrad = 218 WHERE IdMzdCalc = 535;
UPDATE pmzdcalc SET cisrad = 219 WHERE IdMzdCalc = 536;
UPDATE pmzdcalc SET cisrad = 353 WHERE IdMzdCalc = 537;
UPDATE pmzdcalc SET cisrad = 354 WHERE IdMzdCalc = 538;
INSERT INTO pmzdcalc (idmzdcalc, lastUpdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (540, '2010-02-09 00:00:00.000', 'ZDR.DOPL.MIN.ZAKL.', 'Doplatek do minimílního  vyměřovacího základu zdravotního pojištění', true, 213, 0.09, 0.0, 0.0, 'zaklMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, 1, 93, 93);
INSERT INTO pmzdcalc (idmzdcalc, lastUpdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (541, '2010-02-09 00:00:00.000', 'ZDRAV.POJ.PRAC.', 'Doplatek do minimílního  vyměřovacího základu zdravotního pojištění', true, 214, 1.0, 1.0, 0.0, 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, 1, 93, 103);
INSERT INTO pmzdcalc (idmzdcalc, lastUpdate, kod, nazev, show, cisrad, koeficient, koeficient2, koeficient3, zaokrjakk, zaokrnak, polein, poleout, odhodnoty, dohodnoty, operacek, vyhodnotrocne, summesicu, idmzdcalchlav, idmzdslozin, idmzdslozout)
 VALUES (542, '2010-02-09 00:00:00.000', 'ZDRAV.POJ.PRAC.', 'Zdrav. pojištění - pracovník', true, 216, 1.0, 0.0, 0.0, 'zaokrJak.nahoru', 'zaokrNa.jednotky', 'castMzd', 'castMzd', 0.0, 0.0, 'mzdCalcOper.plus', false, 0, 1, 103, 103);

PERFORM pg_catalog.setval('seq_pmzdcalc', 542, true);

-- parametry pro typ prac pom
UPDATE ptyppracpomparam SET kod = 'ZÁKL.SRÁŽKOVÉ DANĚ', nazev = 'Základ pro výpočet srážkové daně' WHERE IdTypPracPomParam = 7;
UPDATE ptyppracpomparam SET kod = 'ZÁKL.SRÁŽKOVÉ DANĚ', nazev = 'Základ pro výpočet srážkové daně' WHERE IdTypPracPomParam = 8;
UPDATE ptyppracpomparam SET poletest = 'procMzd', polenuluj = 'zaklMzd;procMzd' WHERE IdTypPracPomParam = 9;


-- konec ceskeho bloku
  end if; 
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();

drop function runupgrade();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 247, 't');
