--------------------------------------------------------------------------------
-- Bug 19242 – [winstrom] 8. Převod zboží mezi sklady, naskladnění polotovaru, naskladnění výrobku
--------------------------------------------------------------------------------

ALTER TABLE ddoklsklad ADD COLUMN typPohybuSkladK character varying(50);

update ddoklsklad set typPohybuSkladK = 'typPohybuSklad.prijemPoFak'
  where (stavSkladK = 'stavSklad.vygenFakt' or stavSkladK = 'stavSklad.vygenPokl') and typPohybuK = 'typPohybu.prijem';
update ddoklsklad set typPohybuSkladK = 'typPohybuSklad.prijemProFak'
  where (stavSkladK = 'stavSklad.uhrazen' or stavSkladK = 'stavSklad.vyfakt' or stavSkladK = 'stavSklad.uhrazenHrom' or stavSkladK = 'stavSklad.vyfaktHrom') and typPohybuK = 'typPohybu.prijem';
update ddoklsklad set typPohybuSkladK = 'typPohybuSklad.prijemPrevod'
  where stavSkladK = 'stavSklad.prevodka' and typPohybuK = 'typPohybu.prijem';
update ddoklsklad set typPohybuSkladK = 'typPohybuSklad.prijemVyrob'
  where stavSkladK = 'stavSklad.vyroba' and typPohybuK = 'typPohybu.prijem';
update ddoklsklad set typPohybuSkladK = 'typPohybuSklad.prijemHoly'
  where typPohybuSkladK is null and typPohybuK = 'typPohybu.prijem';

update ddoklsklad set typPohybuSkladK = 'typPohybuSklad.vydejPoFak'
  where (stavSkladK = 'stavSklad.vygenFakt' or stavSkladK = 'stavSklad.vygenPokl') and typPohybuK = 'typPohybu.vydej';
update ddoklsklad set typPohybuSkladK = 'typPohybuSklad.vydejProFakCenik'
  where (stavSkladK = 'stavSklad.uhrazen' or stavSkladK = 'stavSklad.vyfakt' or stavSkladK = 'stavSklad.uhrazenHrom' or stavSkladK = 'stavSklad.vyfaktHrom') and typPohybuK = 'typPohybu.vydej';
update ddoklsklad set typPohybuSkladK = 'typPohybuSklad.vydejPrevod'
  where stavSkladK = 'stavSklad.prevodka' and typPohybuK = 'typPohybu.vydej';
update ddoklsklad set typPohybuSkladK = 'typPohybuSklad.vydejVyrob'
  where stavSkladK = 'stavSklad.vyroba' and typPohybuK = 'typPohybu.vydej';
update ddoklsklad set typPohybuSkladK = 'typPohybuSklad.vydejHoly'
  where typPohybuSkladK is null and typPohybuK = 'typPohybu.vydej';

-- Function: createdoklsklad(integer, integer, character varying)

-- DROP FUNCTION createdoklsklad(integer, integer, character varying);

CREATE OR REPLACE FUNCTION createdoklsklad(_idpoldokl integer, _iddoklad integer, _modul character varying)
  RETURNS integer AS
$BODY$
declare
  _doklad record;
  _polDokl record;
  _doklSklad record;
  _idDoklSklad integer;
  _cisDoklad character varying;
  _idrada integer;
  _rada record;
  _sklad record;
  _idUcetObd integer;
  _radaRok record;
  _typPohybuSklad character varying;
  _idTypUcOp integer;
  _cisloDokladuCursor refCursor;
  _typDoklFak record;
  _idUcetSklad integer;
  _idProtiUcet integer;
  _typUcOp record;
  _kurz numeric(19,6);
  _idMenyTuzemsko integer;
  _idMenySklad integer;
  _kurzMnozstvi integer;
  _typVazby character varying;
  _stavSklad character varying;
  _typPohybuSkladK character varying;
begin
  if(_modul like 'POK') then
    select * into _doklad from dDoklInt where idDoklInt = _idDoklad;
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl;
    _stavSklad = 'stavSklad.vygenPokl';
  elsif (_modul like 'FAV' or _modul like 'FAP') then
    select * into _doklad from dDoklFak where idDoklFak = _idDoklad;
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl;
    _stavSklad = 'stavSklad.vygenFakt';
  else
    select * into _doklad from dDoklSklad where idDoklSklad = _idDoklad;
    select * into _polDokl from dPolSklad where idPolSklad = _idPolDokl;
    _stavSklad = 'stavSklad.vyroba';
  end if;

  select * into _sklad from dTypDokl where idTypDokl = _polDokl.idskladu;
  select * into _typDoklFak from dTypDokl where idTypDokl = _doklad.idTypDokl;

  -- urceni spravneho typu pohybu
  if((_typDoklFak.modul like 'FAV') and (_typDoklFak.typDoklK like 'typDokladu.dobropis')) then
    _typPohybuSklad = _doklad.typPohybuK;
  else
    if(_doklad.typPohybuK like 'typPohybu.prijem') then
      _typPohybuSklad = 'typPohybu.vydej';
    else
      _typPohybuSklad = 'typPohybu.prijem';
    end if;
  end if;

  -- doplneni zbyvajicich veci zavislich na typu pohybu
  if(_typPohybuSklad like 'typPohybu.prijem') then
    _idrada = _sklad.idRadyPrijem;
    _idTypUcOp = _sklad.idTypUcOpP;
    if(_modul = 'FAV' or _modul = 'FAP' or _modul = 'POK') then
      _typPohybuSkladK = 'typPohybuSklad.prijemPoFak';
    else
      _typPohybuSkladK = 'typPohybuSklad.prijemVyrob';
    end if;
  else
    _idrada = _sklad.idRadyVydej;
    _idTypUcOp = _sklad.idTypUcOpV;
    if(_modul = 'FAV' or _modul = 'FAP' or _modul = 'POK') then
      _typPohybuSkladK = 'typPohybuSklad.vydejPoFak';
    else
      _typPohybuSkladK = 'typPohybuSklad.vydejVyrob';
    end if;
  end if;

  _idUcetSklad = _sklad.idPrimUcet;
  select * into _typUcOp from utypucop where idtypucop = _idTypUcOp;
  if(_typPohybuSklad like 'typPohybu.prijem') then
    _idProtiUcet = _typUcOp.idProtiucetP;
  else
    _idProtiUcet = _typUcOp.idProtiucetV;
  end if;

  select * into _rada from drady where idRady = _idrada;
  select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _idUcetObd;
  select * into _radaRok from dRadyRok where iducetobdobi = _idUcetObd and idrady = _idrada;

  select nextval('seq_ddoklsklad') into _idDoklSklad;
  select dgetcisdokl(null, _idrada, _idUcetObd, 'SKL', _typPohybuSklad) into _cisloDokladuCursor;
  fetch _cisloDokladuCursor into _cisDoklad;

  -- ziskani kurzu pro menu skladu
  -- select getKurzFromSklad(_polDokl.idSkladu, _polDokl.datVyst) into _kurz;
  -- nejde pouzit protoze potrebuju jak kurz tak kurzove mnozstvi a ne prepocteny nna kurzove mnozstvi 1
  select idMeny into _idMenyTuzemsko from nNastav where _polDokl.datVyst >= PlatiOdData order by PlatiOdData desc limit 1;
  if (_idMenyTuzemsko is null) then
    select idMeny into _idMenyTuzemsko from nNastav where PlatiOdData is null limit 1;
  end if;
  --select idMeny into _idMenySklad from dTypDokl where idTypDokl = _polDokl.idSkladu;

  if(_sklad.idMeny is null or _sklad.idMeny = _idMenyTuzemsko) then
    _kurz = 0.0;
    _kurzMnozstvi = 1;
  else
    select nbStred, kurzMnozstvi into _kurz, _kurzMnozstvi from uKurzy
      where idMeny = _sklad.idMeny and _polDokl.datVyst >= PlatiOdData and cenotvorba = false
      order by PlatiOdData desc limit 1;
    if(_kurz is null) then
      select nbStred, kurzMnozstvi into _kurz, _kurzMnozstvi from uKurzy
        where idMeny = _sklad.idMeny and PlatiOdData is null and cenotvorba = false
        limit 1;
    end if;
    if(_kurz is null) then
      raise exception '0001:getKurzFromSklad : neexistuje kurz!';
    end if;
  end if;

  -- vytvoreni noveho skladoveho dokladu
  insert into dDoklSklad (idDoklSklad, datVyst, datUcto, kod, modul, typPohybuK, idTypDokl, ucetni,
         idFirmy, nazFirmy, ulice, mesto, psc, idStatu, ic, dic, vatId,
         idMur, idKrajUrc, idStatUrc, idTypUcOp, cisObj, cisDodak, doprava, idDruhDopr, popis, poznam,
         idStred, idZakazky, idMeny, kurz, kurzMnozstvi,
         eanKod, idstatpuvod, idstatodesl,
         idPrimUcet, idProtiUcet, idRady, idPolRady, zdrojProFak, stavSkladK , typPohybuSkladK
         )
       values (_idDoklSklad, _doklad.datVyst, _doklad.datVyst, _cisDoklad, 'SKL', _typPohybuSklad, _sklad.idTypDokl, _sklad.ucetni,
         _doklad.idFirmy, _doklad.nazFirmy, _doklad.ulice, _doklad.mesto, _doklad.psc, _doklad.idStatu, _doklad.ic, _doklad.dic, _doklad.vatId,
         _doklad.idMur, _doklad.idKrajUrc, _doklad.idStatUrc, _idTypUcOp, _doklad.cisObj, null, _doklad.doprava, _doklad.idDruhDopr, _doklad.popis, _doklad.poznam,
         _doklad.idStred, _doklad.idZakazky, _sklad.idMeny, _kurz, _kurzMnozstvi,
         _doklad.eanKod, _doklad.idstatpuvod, _doklad.idstatodesl,
         _idUcetSklad, _idProtiUcet, _idRada, _radaRok.idRadyRok, false, _stavSklad, _typPohybuSkladK
         );


  if (_modul = 'SKL') then
    _typVazby = 'typVazbyDokl.hlavaSklKus';
  else
    _typVazby = 'typVazbyDokl.hlavaSkl';
  end if;

  insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK)
       values (0.0, _idDoklad, _idDoklSklad, _doklad.modul, 'SKL', false, _typVazby);

  return _idDoklSklad;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION createdoklsklad(integer, integer, character varying) OWNER TO %firmaRole%;


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 316, 't');
