-----------------------------------------------------------------------------------------
-- Bug 19736 – [WinStrom] Na generovanych prijemkach a vydejkach se nevyplnuje lastUpdate
-----------------------------------------------------------------------------------------

-- Function: createpolsklad(integer, character varying)
-- DROP FUNCTION createpolsklad(integer, character varying);
CREATE OR REPLACE FUNCTION createpolsklad(_idpoldokl integer, _modul character varying)
  RETURNS integer AS
$BODY$ 
declare 
  _idDoklSklad integer; 
  _idDoklad integer; 
  _polDokl record; 
  _iducetobdobi integer; 
  _idkarty integer; 
  _idPolSklad integer; 
  _cenaMj numeric(19,6); 
  _cenaMjTuz numeric(19,6); 
  _typPohybuK character varying; 
  _prumCenaTuz numeric(19,6); 
  _sumZkl numeric(19,6); 
  _sumZklMen numeric(19,6); 
  _kurz numeric(19,6); 
  _idZklMdUcet integer; 
  _idZklDalUcet integer; 
  _kopZklMdUcet boolean; 
  _kopZklDalUcet boolean; 
  _sklad record; 
  _typDoklK character varying; 
  _mnozMj numeric(19,6); 
  _isCiziMena boolean; 
  _idMeny integer;   
begin 
  if(_modul like 'FAV' or _modul like 'FAP') then 
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl; 
    _idDoklad = _polDokl.idDoklFak; 
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak); 
  else 
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl; 
    _idDoklad = _polDokl.idDoklInt; 
    _typDoklK = null; -- pro pokladnu dobropisy nejsou 
  end if; 
 
  select findParovanyDoklSklad(_idDoklad, _modul) into _idDoklSklad; 
   
  if(_idDoklSklad is null) then 
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad; 
  end if; 
 
  select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi; 
  select idkarty into _idkarty from skarty where idcenik = _polDokl.idcenik and idtypdokl = _polDokl.idskladu and iducetobdobi = _iducetobdobi; 
  select * into _sklad from dTypDokl where idTypDokl = _polDokl.idSkladu; 
   
  select typPohybuK into _typPohybuK from dDoklSklad where idDoklSklad = _idDoklSklad; 
  select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz; 
  select prumCenaTuz into _prumCenaTuz from sKarty where idKarty = _idKarty; 
  select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena; 
  select idMeny into _idMeny from dDoklSklad where idDoklSklad = _idDoklSklad; 
       
  if(_typPohybuK like 'typPohybu.vydej') then 
    -- vsechny dobropisy generuji prijemky 
    --if(_typDoklK like 'typDokladu.dobropis') then 
    --  _mnozMj = -_polDokl.mnozMj; 
    --else 
      _mnozMj = _polDokl.mnozMj; 
    --end if; 
    -- pokud vydavam ze skladu tak ma byt pouzita prumerna cena 
    _cenaMj = _prumCenaTuz / _kurz; 
    _sumZkl = _prumCenaTuz * _mnozMj; 
    if(_isCiziMena) then 
      _sumZklMen = _mnozMj * _cenaMj; 
    else 
      _sumZklMen = 0.0; 
    end if; 
    -- nastaveni uctu pro polSklad vydej 
    select findZklMdUcetIfVydej(_idPolDokl, _modul) into _idZklMdUcet; 
    _idZklDalUcet = _sklad.idPrimUcet; 
  else 
    if(_typDoklK like 'typDokladu.dobropis' and _modul like 'FAV') then 
      -- pokud se jedna o dobropis tak doplnuji nakupni ceny; 
      _mnozMj = -_polDokl.mnozMj; 
      --_cenaMjTuz = _prumCenaTuz; 
      _cenaMjTuz = _polDokl.cenaMjNakup; 
      if(_cenaMjTuz = 0.0) then 
        _cenaMjTuz = (select nakupCena from ccenik where idCenik = _polDokl.idCenik); 
        if(_cenaMj = 0.0) then 
          _cenaMj = _polDokl.cenaMj * _kurz; 
        end if; 
      end if; 
      _cenaMj = _cenaMjTuz / _kurz; 
      _sumZkl = _mnozMj * _cenaMjTuz; 
      if(_isCiziMena) then 
        _sumZklMen = _mnozMj * _cenaMj; 
      else 
        _sumZklMen = 0.0; 
      end if; 
    else 
      -- pokud na sklad prijmam zkopiruji se ceny z faktury 
      _mnozMj = _polDokl.mnozMj; 
      _sumZkl = _polDokl.sumZkl; 
      if(_mnozMj <> 0.0) then 
        _cenaMj = _sumZkl / _mnozMj; 
      else 
        _cenaMj = _sumZkl; 
      end if; 
      _cenaMj = _cenaMj / _kurz; 
      if(_isCiziMena) then 
        if(_mnozMj <> 0.0) then 
          _sumZklMen = _cenaMj * _mnozMj;   
        else 
          _sumZklMen = _cenaMj; 
        end if; 
      else 
        _sumZklMen = 0.0;   
      end if; 
    end if; 
    -- nastaveni uctu pro polSklad prijem 
    _idZklMdUcet = _sklad.idPrimUcet; 
    _idZklDalUcet = _polDokl.idZklMdUcet; 
  end if; 
   
  select nextval('seq_dpolsklad') into _idPolSklad;   
  insert into dpolsklad(idPolSklad, lastUpdate, idcenik, idskladu, idkarty, datVyst, datUcto, modul, typPolozkyK, idDoklSklad,    
        mnozMj, cenaMj, sumZkl, sumZklMen, idZklMdUcet, idZklDalUcet, kopZklMdUcet, kopZklDalUcet, baleniid, mnozBaleni,   
        nazev, nazevA, nazevB, nazevC, sarze, expirace, cisRad, ucetni,  
        idStred, idZakazky, idMeny, zdrojProFak)   
      values (_idPolSklad, LOCALTIMESTAMP, _polDokl.idcenik, _polDokl.idskladu, _idkarty, _polDokl.datVyst, _polDokl.datUcto, 'SKL', 'typPolozky.katalog', _idDoklSklad,    
        _mnozMj, _cenaMj, _sumZkl, _sumZklMen, _idZklMdUcet, _idZklDalUcet, false, false, _polDokl.baleniid, _polDokl.mnozBaleni,    
        _polDokl.nazev, _polDokl.nazevA, _polDokl.nazevB, _polDokl.nazevC, _polDokl.sarze, _polDokl.expirace, _polDokl.cisRad, true,  
        _polDokl.idStred, _polDokl.idZakazky, _idMeny, false);   
  
  insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK) 
       values (0.0, _idPolDokl, _idPolSklad, _modul, 'SKL', false, 'typVazbyDokl.polozkaSkl'); 
 
  -- prepocteni sum na dokladu 
  execute sprepoctiSumyDokladu(_idDoklSklad); 
 
  return _idPolSklad; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION createpolsklad(integer, character varying) OWNER TO %firmaRole%;



-- Function: createpolskladsada(integer, character varying)
-- DROP FUNCTION createpolskladsada(integer, character varying);
CREATE OR REPLACE FUNCTION createpolskladsada(_idpoldokl integer, _modul character varying)
  RETURNS void AS
$BODY$  
declare 
  _polDokl record; 
  _polozkaSady record; 
  _skladKarta record; 
  _cenik record; 
  _sklad record; 
  _idDoklSklad integer; 
  _idDoklad integer; 
  _idMeny integer; 
  _idUcetObdobi integer; 
  _idKarty integer; 
  _idPolSklad integer; 
  _idZklMdUcet integer; 
  _idZklDalUcet integer; 
  _i integer; 
  _cisRad integer; 
  _typDoklK character varying; 
  _mnozMj numeric(19,6); 
  _sumZkl numeric(19,6); 
  _sumZklMen numeric(19,6); 
  _cenaMj numeric(19,6); 
  _kurz numeric(19,6); 
  _isCiziMena boolean; 
  _nasobic integer; 
  _idSkladu integer;  
begin 
 
  if(_modul like 'FAV' or _modul like 'FAP') then  
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl;  
    _idDoklad = _polDokl.idDoklFak;  
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak);  
  else  
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl;  
    _idDoklad = _polDokl.idDoklInt;  
    _typDoklK = null; -- pro pokladnu dobropisy nejsou  
  end if; 
 
  select findParovanyDoklSklad(_idDoklad, _modul) into _idDoklSklad;  
   
  if(_idDoklSklad is null) then  
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad;  
  end if; 
 
  select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz; 
  select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena;  
  select idMeny into _idMeny from dDoklSklad where idDoklSklad = _idDoklSklad; 
 
  select * into _sklad from dTypDokl where idTypDokl = _polDokl.idSkladu;  
 
  _i = 0; 
 
  FOR _polozkaSady IN 
    select * from cSady where idCenikSada = _polDokl.idCenik 
  LOOP 
    select * into _cenik from cCenik where idCenik = _polozkaSady.idCenik; 
 
    if(_cenik.typZasobyK like 'typZasoby.skladem' or _cenik.typZasobyK like 'typZasoby.vyrobek') then 
      _i = _i + 1; 
      _cisRad = 100 * _polDokl.cisRad + _i; 
   
      select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi;  
 
      _idSkladu = _polDokl.idSkladu; 
 
      select * into _skladKarta from skarty  
        where idTypDokl = _idSkladu and idCenik = _polozkaSady.idCenik and idUcetObdobi = _idUcetObdobi;  
 
      -- pokud neexistuje skladova karta pokusim se ji najit pomoci mapovani skladu 
      if(_skladKarta is null) then 
        select getPrefIdSkladu(_polDokl.idStred, _cenik.idSkupZboz, _cenik.idCenik) into _idSkladu; 
        select * into _skladKarta from skarty 
          where idTypDokl = _idSkladu and idCenik = _cenik.idCenik and idUcetObdobi = _idUcetObdobi; 
        if(_skladKarta is null) then 
          -- pokud ani podle mapovani skladu se skladova karta nenajde tak vyhazuju vyjimku 
          raise exception '0007:Skladová karta neexistuje pro ceník % a sklad % a nebo je špatně nastaveno mapovaní skladu.', _cenik.nazev, _sklad.nazev; 
        end if; 
      end if; 
        
      _nasobic = 1; 
      if(_typDoklK like 'typDokladu.dobropis') then 
        _nasobic = -1; 
      end if; 
      _mnozMj = _polozkaSady.mnozMj * _polDokl.mnozMj * _nasobic; 
      _cenaMj = _skladKarta.prumCenaTuz / _kurz; 
      _sumZkl = _mnozMj * _skladKarta.prumCenaTuz; 
      if(_isCiziMena) then  
        _sumZklMen = _mnozMj * _cenaMj;  
      else  
        _sumZklMen = 0.0;  
      end if; 
     
      -- nastaveni uctu pro polSklad vydej  
      --select findZklMdUcetIfVydej(_idPolDokl, _modul) into _idZklMdUcet;  
      select idProtiUcetSklV into _idZklMdUcet from cSkupZboz where idSkupZboz = _cenik.idSkupZboz;  
      if(_idZklMdUcet is null) then  
        select idProtiUcetV into _idZklMdUcet from uTypUcOp where idTypUcOp = (select idTypUcOpV from dTypDokl where idTypDokl = _polDokl.idSkladu);  
      end if;  
   
      _idZklDalUcet = _sklad.idPrimUcet; 
 
      select nextval('seq_dpolsklad') into _idPolSklad; 
      insert into dpolsklad(idPolSklad, lastUpdate, idcenik, idskladu, idkarty, datVyst, datUcto, modul, typPolozkyK, idDoklSklad,     
          mnozMj, cenaMj, sumZkl, sumZklMen, idZklMdUcet, idZklDalUcet, kopZklMdUcet, kopZklDalUcet, baleniid, mnozBaleni,    
          nazev, nazevA, nazevB, nazevC, sarze, expirace, cisRad, ucetni,   
          idStred, idZakazky, idMeny, zdrojProFak)    
        values (_idPolSklad, LOCALTIMESTAMP, _polozkaSady.idcenik, _idSkladu, _skladKarta.idKarty, _polDokl.datVyst, _polDokl.datVyst, 'SKL', 'typPolozky.katalog', _idDoklSklad,     
          _mnozMj, _cenaMj, _sumZkl, _sumZklMen, _idZklMdUcet, _idZklDalUcet, false, false, _polDokl.baleniid, 0.0, 
          _cenik.nazev, _cenik.nazevA, _cenik.nazevB, _cenik.nazevC, null, null, _cisRad, true,   
          _polDokl.idStred, _polDokl.idZakazky, _idMeny, false); 
 
      insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK)   
        values (0.0, _idPolDokl, _idPolSklad, _modul, 'SKL', false, 'typVazbyDokl.polozkaSklSada');   
    end if;  
  END LOOP;  
 
  execute sprepoctiSumyDokladu(_idDoklSklad);  
end;  
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION createpolskladsada(integer, character varying) OWNER TO %firmaRole%;


-- Function: createdoklsklad(integer, integer, character varying)
-- DROP FUNCTION createdoklsklad(integer, integer, character varying);
CREATE OR REPLACE FUNCTION createdoklsklad(_idpoldokl integer, _iddoklad integer, _modul character varying)
  RETURNS integer AS
$BODY$ 
declare 
  _doklad record; 
  _polDokl record; 
  _doklSklad record; 
  _idDoklSklad integer; 
  _cisDoklad character varying; 
  _idrada integer; 
  _rada record; 
  _sklad record; 
  _idUcetObd integer; 
  _radaRok record; 
  _typPohybuSklad character varying; 
  _idTypUcOp integer; 
  _cisloDokladuCursor refCursor; 
  _typDoklFak record; 
  _idUcetSklad integer; 
  _idProtiUcet integer; 
  _typUcOp record; 
  _kurz numeric(19,6); 
  _idMenyTuzemsko integer; 
  _idMenySklad integer; 
  _kurzMnozstvi integer; 
  _typVazby character varying; 
  _stavSklad character varying; 
  _typPohybuSkladK character varying; 
begin 
  if(_modul like 'POK') then 
    select * into _doklad from dDoklInt where idDoklInt = _idDoklad; 
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl; 
    _stavSklad = 'stavSklad.vygenPokl'; 
  elsif (_modul like 'FAV' or _modul like 'FAP') then 
    select * into _doklad from dDoklFak where idDoklFak = _idDoklad; 
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl; 
    _stavSklad = 'stavSklad.vygenFakt'; 
  else 
    select * into _doklad from dDoklSklad where idDoklSklad = _idDoklad; 
    select * into _polDokl from dPolSklad where idPolSklad = _idPolDokl; 
    _stavSklad = 'stavSklad.vyroba'; 
  end if; 
 
  select * into _sklad from dTypDokl where idTypDokl = _polDokl.idskladu; 
  select * into _typDoklFak from dTypDokl where idTypDokl = _doklad.idTypDokl; 
 
  -- urceni spravneho typu pohybu 
  if((_typDoklFak.modul like 'FAV') and (_typDoklFak.typDoklK like 'typDokladu.dobropis')) then 
    _typPohybuSklad = _doklad.typPohybuK; 
  else 
    if(_doklad.typPohybuK like 'typPohybu.prijem') then 
      _typPohybuSklad = 'typPohybu.vydej'; 
    else 
      _typPohybuSklad = 'typPohybu.prijem'; 
    end if; 
  end if; 
 
  -- doplneni zbyvajicich veci zavislich na typu pohybu 
  if(_typPohybuSklad like 'typPohybu.prijem') then 
    _idrada = _sklad.idRadyPrijem; 
    _idTypUcOp = _sklad.idTypUcOpP; 
    if(_modul = 'FAV' or _modul = 'FAP' or _modul = 'POK') then 
      _typPohybuSkladK = 'typPohybuSklad.prijemPoFak'; 
    else 
      _typPohybuSkladK = 'typPohybuSklad.prijemVyrob'; 
    end if; 
  else 
    _idrada = _sklad.idRadyVydej; 
    _idTypUcOp = _sklad.idTypUcOpV; 
    if(_modul = 'FAV' or _modul = 'FAP' or _modul = 'POK') then 
      _typPohybuSkladK = 'typPohybuSklad.vydejPoFak'; 
    else 
      _typPohybuSkladK = 'typPohybuSklad.vydejVyrob'; 
    end if; 
  end if; 
 
  _idUcetSklad = _sklad.idPrimUcet; 
  select * into _typUcOp from utypucop where idtypucop = _idTypUcOp; 
  if(_typPohybuSklad like 'typPohybu.prijem') then 
    _idProtiUcet = _typUcOp.idProtiucetP; 
  else 
    _idProtiUcet = _typUcOp.idProtiucetV; 
  end if; 
 
  select * into _rada from drady where idRady = _idrada; 
  select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _idUcetObd; 
  select * into _radaRok from dRadyRok where iducetobdobi = _idUcetObd and idrady = _idrada; 
 
  select nextval('seq_ddoklsklad') into _idDoklSklad; 
  select dgetcisdokl(null, _idrada, _idUcetObd, 'SKL', _typPohybuSklad) into _cisloDokladuCursor; 
  fetch _cisloDokladuCursor into _cisDoklad; 
 
  -- ziskani kurzu pro menu skladu 
  -- select getKurzFromSklad(_polDokl.idSkladu, _polDokl.datVyst) into _kurz; 
  -- nejde pouzit protoze potrebuju jak kurz tak kurzove mnozstvi a ne prepocteny nna kurzove mnozstvi 1 
  select idMeny into _idMenyTuzemsko from nNastav where _polDokl.datVyst >= PlatiOdData order by PlatiOdData desc limit 1; 
  if (_idMenyTuzemsko is null) then 
    select idMeny into _idMenyTuzemsko from nNastav where PlatiOdData is null limit 1; 
  end if; 
  --select idMeny into _idMenySklad from dTypDokl where idTypDokl = _polDokl.idSkladu; 
 
  if(_sklad.idMeny is null or _sklad.idMeny = _idMenyTuzemsko) then 
    _kurz = 0.0; 
    _kurzMnozstvi = 1; 
  else 
    select nbStred, kurzMnozstvi into _kurz, _kurzMnozstvi from uKurzy 
      where idMeny = _sklad.idMeny and _polDokl.datVyst >= PlatiOdData and cenotvorba = false 
      order by PlatiOdData desc limit 1; 
    if(_kurz is null) then 
      select nbStred, kurzMnozstvi into _kurz, _kurzMnozstvi from uKurzy 
        where idMeny = _sklad.idMeny and PlatiOdData is null and cenotvorba = false 
        limit 1; 
    end if; 
    if(_kurz is null) then 
      raise exception '0001:getKurzFromSklad : neexistuje kurz!'; 
    end if; 
  end if; 
 
  -- vytvoreni noveho skladoveho dokladu 
  insert into dDoklSklad (idDoklSklad, lastUpdate, datVyst, datUcto, kod, modul, typPohybuK, idTypDokl, ucetni, 
         idFirmy, nazFirmy, ulice, mesto, psc, idStatu, ic, dic, vatId, 
         idMur, idKrajUrc, idStatUrc, idTypUcOp, cisObj, cisDodak, doprava, idDruhDopr, popis, poznam, 
         idStred, idZakazky, idMeny, kurz, kurzMnozstvi, 
         eanKod, idstatpuvod, idstatodesl, 
         idPrimUcet, idProtiUcet, idRady, idPolRady, zdrojProFak, stavSkladK , typPohybuSkladK 
         ) 
       values (_idDoklSklad, LOCALTIMESTAMP, _doklad.datVyst, _doklad.datVyst, _cisDoklad, 'SKL', _typPohybuSklad, _sklad.idTypDokl, _sklad.ucetni, 
         _doklad.idFirmy, _doklad.nazFirmy, _doklad.ulice, _doklad.mesto, _doklad.psc, _doklad.idStatu, _doklad.ic, _doklad.dic, _doklad.vatId, 
         _doklad.idMur, _doklad.idKrajUrc, _doklad.idStatUrc, _idTypUcOp, _doklad.cisObj, null, _doklad.doprava, _doklad.idDruhDopr, _doklad.popis, _doklad.poznam, 
         _doklad.idStred, _doklad.idZakazky, _sklad.idMeny, _kurz, _kurzMnozstvi, 
         _doklad.eanKod, _doklad.idstatpuvod, _doklad.idstatodesl, 
         _idUcetSklad, _idProtiUcet, _idRada, _radaRok.idRadyRok, false, _stavSklad, _typPohybuSkladK 
         ); 
 
 
  if (_modul = 'SKL') then 
    _typVazby = 'typVazbyDokl.hlavaSklKus'; 
  else 
    _typVazby = 'typVazbyDokl.hlavaSkl'; 
  end if; 
 
  insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK) 
       values (0.0, _idDoklad, _idDoklSklad, _doklad.modul, 'SKL', false, _typVazby); 
 
  return _idDoklSklad; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION createdoklsklad(integer, integer, character varying) OWNER TO %firmaRole%;


-- Function: fillpolsklad(integer, integer, character varying)
-- DROP FUNCTION fillpolsklad(integer, integer, character varying);
CREATE OR REPLACE FUNCTION fillpolsklad(_idpolsklad integer, _idpoldokl integer, _modul character varying)
  RETURNS integer AS
$BODY$ 
declare 
  _polDokl record; 
  _polSklad record; 
  _idDoklad integer; 
  _typPohybuK character varying; 
  _typPohybuSklad character varying; 
  _cenaMj numeric(19,6); 
  _cenaMjTuz numeric(19,6); 
  _mnozMj numeric(19,6); 
  _sumZkl numeric(19,6); 
  _sumZklMen numeric(19,6); 
  _idDoklSklad integer; 
  _idUcetObdobi integer; 
  _idKarty integer; 
  _sklad record; 
  _kurz numeric(19,6); 
  _prumCenaTuz numeric(19,6); 
  _isCiziMena boolean; 
  _typDoklK character varying; 
  _idZklMdUcet integer; 
  _idZklDalUcet integer; 
begin 
  if(_modul like 'POK') then 
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl; 
    select idDoklInt, typPohybuK into _idDoklad, _typPohybuK from dDoklInt where idDoklInt = _polDokl.idDoklInt; 
    _typDoklK = null; -- pro pokladnu dobropisy nejsou 
  else 
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl; 
    select idDoklFak, typPohybuK into _idDoklad, _typPohybuK from dDoklFak where idDoklFak = _polDokl.idDoklFak; 
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak); 
  end if; 
 
  select findParovanyDoklSklad(_idDoklad, _modul) into _idDoklSklad; 
   
  if(_idDoklSklad is null) then 
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad; 
  end if; 
 
  select * into _polSklad from dPolSklad where idPolSklad = _idPolSklad; 
  select typPohybuK into _typPohybuSklad from dDoklSklad where idDoklSklad = _polSklad.idDoklSklad; 
 
  select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi; 
  select idkarty into _idkarty from skarty where idcenik = _polDokl.idcenik and idtypdokl = _polDokl.idskladu and iducetobdobi = _iducetobdobi; 
  select * into _sklad from dTypDokl where idTypDokl = _polDokl.idSkladu; 
   
  select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz; 
  select prumCenaTuz into _prumCenaTuz from sKarty where idKarty = _idKarty; 
  select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena; 
 
  if(_typPohybuSklad like 'typPohybu.vydej') then 
    -- vsechny dobropisy generuji prijemky 
    --if(_typDoklK like 'typDokladu.dobropis') then 
    --  _mnozMj = -_polDokl.mnozMj; 
    --else 
      _mnozMj = _polDokl.mnozMj; 
    --end if; 
    -- pokud vydavam ze skladu tak ma byt pouzita prumerna cena 
    _cenaMj = _polSklad.cenaMj; 
    _sumZkl = _polSklad.sumZkl; 
    _sumZklMen = _polSklad.sumZklMen; 
    -- nastaveni uctu pro polSklad vydej 
    select findZklMdUcetIfVydej(_idPolDokl, _modul) into _idZklMdUcet; 
    _idZklDalUcet = _sklad.idPrimUcet; 
  else 
    if(_typDoklK like 'typDokladu.dobropis' and _modul like 'FAV') then 
      -- pokud se jedna o dobropis tak doplnuji nakupni ceny; 
      _mnozMj = -_polDokl.mnozMj; 
      _cenaMjTuz = _polDokl.cenaMjNakup;  
      if(_cenaMjTuz = 0.0) then 
        _cenaMjTuz = (select nakupCena from ccenik where idCenik = _polDokl.idCenik); 
        if(_cenaMj = 0.0) then 
          _cenaMj = _polDokl.cenaMj * _kurz; 
        end if; 
      end if; 
      _cenaMj = _cenaMjTuz / _kurz; 
      _sumZkl = _mnozMj * _cenaMjTuz; 
      if(_isCiziMena) then 
        _sumZklMen = _mnozMj * _cenaMj; 
      else 
        _sumZklMen = 0.0; 
      end if; 
    else 
      -- pokud na sklad prijmam zkopiruji se ceny z faktury 
      _mnozMj = _polDokl.mnozMj; 
      _sumZkl = _polDokl.sumZkl; 
      if(_mnozMj <> 0.0) then 
        _cenaMj = _sumZkl / _mnozMj; 
      else 
        _cenaMj = _sumZkl; 
      end if; 
      _cenaMj = _cenaMj / _kurz; 
      if(_isCiziMena) then 
        if(_mnozMj <> 0.0) then 
          _sumZklMen = _cenaMj * _mnozMj;   
        else 
          _sumZklMen = _cenaMj; 
        end if; 
      else 
        _sumZklMen = 0.0;   
      end if;  
    end if; 
    -- nastaveni uctu pro polSklad prijem 
    _idZklMdUcet = _sklad.idPrimUcet; 
    _idZklDalUcet = _polDokl.idZklMdUcet; 
  end if; 
   
  update dPolSklad set
    lastUpdate = LOCALTIMESTAMP,  
    cenaMj = _cenaMj,  
    --mnozMj = _mnozMj,  
    sumZkl = _sumZkl,  
    sumZklMen = _sumZklMen,  
    nazev = _polDokl.nazev,  
    nazevA = _polDokl.nazevA,  
    nazevB = _polDokl.nazevB,  
    nazevC = _polDokl.nazevC,  
    datVyst = _polDokl.datVyst,  
    datUcto = _polDokl.datVyst, 
    baleniId = _polDokl.baleniId,  
    mnozBaleni = _polDokl.mnozBaleni,  
    sarze = _polDokl.sarze,  
    expirace = _polDokl.expirace,  
    cisRad = _polDokl.cisRad,  
    eankod = _polDokl.eanKod,  
    idmj = _polDokl.idmj,  
    idStred = _polDokl.idStred,  
    idMeny = _polSklad.idMeny,  
    idZakazky = _polDokl.idZakazky,  
    idZklMdUcet = _idZklMdUcet,  
    idZklDalUcet = _idZklDalUcet, 
    ucetni = true 
    where idPolSklad = _idPolSklad; 
 
  return _idPolSklad; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION fillpolsklad(integer, integer, character varying) OWNER TO %firmaRole%;


-- Function: fillpolskladsada(integer, character varying)
-- DROP FUNCTION fillpolskladsada(integer, character varying);
CREATE OR REPLACE FUNCTION fillpolskladsada(_idpoldokl integer, _modul character varying)
  RETURNS void AS
$BODY$  
declare  
  _polDokl record;  
  _polSklad record;  
  _idDoklad integer;  
  _typPohybuK character varying;  
  _typPohybuSklad character varying;  
  _cenaMj numeric(19,6);  
  _cenaMjTuz numeric(19,6);  
  _mnozMj numeric(19,6);  
  _sumZkl numeric(19,6);  
  _sumZklMen numeric(19,6);  
  _idDoklSklad integer;  
  _idUcetObdobi integer;  
  _idKarty integer;  
  _sklad record;  
  _kurz numeric(19,6);  
  _prumCenaTuz numeric(19,6);  
  _isCiziMena boolean;  
  _typDoklK character varying;  
  _idZklMdUcet integer;  
  _idZklDalUcet integer;  
begin 
  if(_modul like 'POK') then  
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl;  
    select idDoklInt, typPohybuK into _idDoklad, _typPohybuK from dDoklInt where idDoklInt = _polDokl.idDoklInt;  
    _typDoklK = null; -- pro pokladnu dobropisy nejsou  
  else  
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl;  
    select idDoklFak, typPohybuK into _idDoklad, _typPohybuK from dDoklFak where idDoklFak = _polDokl.idDoklFak;  
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak);  
  end if;  
 
  select findParovanyDoklSklad(_idDoklad, _modul) into _idDoklSklad;  
  if(_idDoklSklad is null) then  
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad;  
  end if;  
 
  for _polSklad in   
    select * from dPolSklad where idPolSklad in (  
      select idTabB from dvazebtab where  
        typVazbyK like 'typVazbyDokl.polozkaSklSada'   
        and idTabA = _idPolDokl and modulA = _modul and modulB = 'SKL'  
    )  
  loop  
    select typPohybuK into _typPohybuSklad from dDoklSklad where idDoklSklad = _polSklad.idDoklSklad;   
  
    select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi;  
    select idkarty into _idkarty from skarty where idcenik = _polDokl.idcenik and idtypdokl = _polDokl.idskladu and iducetobdobi = _iducetobdobi;  
    select * into _sklad from dTypDokl where idTypDokl = _polDokl.idSkladu;  
    
    select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz;  
    select prumCenaTuz into _prumCenaTuz from sKarty where idKarty = _idKarty;  
    select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena;  
  
    -- pokud vydavam ze skladu tak ma byt pouzita prumerna cena  
    _cenaMj = _polSklad.cenaMj;  
    _mnozMj = _polSklad.mnozMj;  
    _sumZkl = _polSklad.sumZkl;  
    _sumZklMen = _polSklad.sumZklMen;  
    -- nastaveni uctu pro polSklad vydej  
    --TODO doresit zklMdUcet; 
    --select findZklMdUcetIfVydej(_idPolDokl, _modul) into _idZklMdUcet;  
    _idZklDalUcet = _sklad.idPrimUcet;  
    
    update dPolSklad set 
      lastUpdate = LOCALTIMESTAMP,  
      cenaMj = _cenaMj,   
      mnozMj = _mnozMj,   
      sumZkl = _sumZkl,   
      sumZklMen = _sumZklMen,   
      --nazev = _polDokl.nazev,   
      --nazevA = _polDokl.nazevA,   
      --nazevB = _polDokl.nazevB,   
      --nazevC = _polDokl.nazevC,   
      datVyst = _polDokl.datVyst,   
      datUcto = _polDokl.datVyst, 
      baleniId = _polDokl.baleniId,   
      mnozBaleni = _polDokl.mnozBaleni,   
      --sarze = _polDokl.sarze,   
      --expirace = _polDokl.expirace,   
      --cisRad = _polDokl.cisRad,   
      --eankod = _polDokl.eanKod,   
      --idmj = _polDokl.idmj,   
      idStred = _polDokl.idStred,   
      idMeny = _polSklad.idMeny,   
      idZakazky = _polDokl.idZakazky,   
      --idZklMdUcet = _idZklMdUcet,   
      idZklDalUcet = _idZklDalUcet,  
      ucetni = true  
      where idPolSklad = _polSklad.idPolSklad;  
  end loop; 
  --return _idPolSklad;  
end;  
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION fillpolskladsada(integer, character varying) OWNER TO %firmaRole%;


-- Function: sprepoctisumydokladu(integer, date)
-- DROP FUNCTION sprepoctisumydokladu(integer, date);
CREATE OR REPLACE FUNCTION sprepoctisumydokladu(i_iddoklsklad integer, i_datvyst date)
  RETURNS void AS
$BODY$ 
declare 
 _sumZkl numeric(15,2); 
 _sumZklMen numeric(15,2); 
begin 
 select sum(sumZkl), sum(sumZklMen) into _sumZkl, _sumZklMen from dPolSklad where idDoklSklad = i_idDoklSklad and stornoPol = false; 
 if(_sumZkl is null) then _sumZkl = 0.0; end if; 
 if(_sumZklMen is null) then _sumZklMen = 0.0; end if; 
 update dDoklSklad set lastUpdate = LOCALTIMESTAMP, sumCelkem = _sumZkl, sumCelkemMen = _sumZklMen, datVyst = i_datVyst, datUcto = i_datVyst where idDoklSklad = i_idDoklSklad; 
end 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION sprepoctisumydokladu(integer, date) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 338, 't');
