--------------------------------------------------------------------------------
-- Bug none Optimalizace funkce pro přepočet obratů položek dokladů
--------------------------------------------------------------------------------

/*
-- PostgreSQL 8.x SQL does not allow triggers to fire on updates to specific columns (e.g., AFTER UPDATE OF col1, col2)
-- PostgreSQL 9.x už je podporuje
DROP TRIGGER dpoldoklupdateucto ON dpolfak;
CREATE TRIGGER dpoldoklupdateucto
    BEFORE UPDATE OF ucetni, storno, datUcto,
      idzklmducet, idzkldalucet, iddphmducet, iddphdalucet,
      idmeny, idstred, idcinnost,
      sumzkl, sumzklmen, sumdph, sumdphmen
    ON dpolfak
    FOR EACH ROW
    EXECUTE PROCEDURE dpoldoklupdateucto();

DROP TRIGGER dpoldoklupdateucto ON dpolint;
CREATE TRIGGER dpoldoklupdateucto
    BEFORE UPDATE OF ucetni, storno, datUcto,
      idzklmducet, idzkldalucet, iddphmducet, iddphdalucet,
      idmeny, idstred, idcinnost,
      sumzkl, sumzklmen, sumdph, sumdphmen
    ON dpolint
    FOR EACH ROW
    EXECUTE PROCEDURE dpoldoklupdateucto();

DROP TRIGGER dpoldoklupdateucto ON dpolsklad;
CREATE TRIGGER dpoldoklupdateucto
    BEFORE UPDATE OF ucetni, storno, datUcto,
      idzklmducet, idzkldalucet, iddphmducet, iddphdalucet,
      idmeny, idstred, idcinnost,
      sumzkl, sumzklmen, sumdph, sumdphmen
    ON dpolsklad
    FOR EACH ROW
    EXECUTE PROCEDURE dpoldoklupdateucto();
*/

CREATE OR REPLACE FUNCTION dpoldoklupdateucto() RETURNS trigger AS $$
begin

 IF ( NEW.Ucetni <> OLD.Ucetni OR
      NEW.Storno <> OLD.Storno OR
      comparedate(NEW.DatUcto, OLD.DatUcto) OR

      compareid(NEW.idZklMdUcet, OLD.idZklMdUcet) = false OR
      compareid(NEW.idZklDalUcet, OLD.idZklDalUcet) = false OR
      compareid(NEW.idDphMdUcet, OLD.idDphMdUcet) = false OR
      compareid(NEW.idDphDalUcet, OLD.idDphDalUcet) = false OR

      compareid(NEW.idMeny, OLD.idMeny) = false OR
      compareid(NEW.idStred, OLD.idStred) = false OR
      compareid(NEW.idCinnost, OLD.idCinnost) = false OR

      NEW.sumZkl <> OLD.sumZkl OR
      NEW.sumZklMen <> OLD.sumZklMen OR
      NEW.sumDph <> OLD.sumDph OR
      NEW.sumDphMen <> OLD.sumDphMen ) THEN

  execute createOrUpdateObraty(OLD.Ucetni, OLD.Storno, OLD.DatUcto, OLD.idZklMdUcet, OLD.idZklDalUcet,
      OLD.idMeny, OLD.idStred, OLD.idCinnost, -OLD.sumZkl, -OLD.sumZklMen);

  execute createOrUpdateObraty(OLD.Ucetni, OLD.Storno, OLD.DatUcto, OLD.idDphMdUcet, OLD.idDphDalUcet,
      OLD.idMeny, OLD.idStred, OLD.idCinnost, -OLD.sumDph, -OLD.sumDphMen);

  execute createOrUpdateObraty(NEW.Ucetni, NEW.Storno, NEW.DatUcto, NEW.idZklMdUcet, NEW.idZklDalUcet,
      NEW.idMeny, NEW.idStred, NEW.idCinnost, NEW.sumZkl, NEW.sumZklMen);

  execute createOrUpdateObraty(NEW.Ucetni, NEW.Storno, NEW.DatUcto, NEW.idDphMdUcet, NEW.idDphDalUcet,
      NEW.idMeny, NEW.idStred, NEW.idCinnost, NEW.sumDph, NEW.sumDphMen);

 END IF;

  return NEW;
end;
$$ LANGUAGE plpgsql;

ALTER FUNCTION public.dpoldoklupdateucto() OWNER TO %firmaRole%;


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 348, 't');
