--------------------------------------------------------------------------------
-- Bug 20377 – [WinStrom] Pridat moznost dedeni pristupovych prav
--------------------------------------------------------------------------------

ALTER TABLE wrole
    ADD COLUMN idstandardrole integer,
    ADD COLUMN idotecrole integer,
    ADD CONSTRAINT wrole_idstandardrole_fk FOREIGN KEY (idstandardrole)
        REFERENCES wrole (idrole) MATCH SIMPLE
        ON UPDATE NO ACTION ON DELETE NO ACTION,
    ADD CONSTRAINT wrole_idotecrole_fk FOREIGN KEY (idotecrole)
        REFERENCES wrole (idrole) MATCH SIMPLE
        ON UPDATE NO ACTION ON DELETE NO ACTION;

CREATE INDEX wrole_idstandardrole_index ON wrole USING btree (idstandardrole);
CREATE INDEX wrole_idotecrole_index ON wrole USING btree (idotecrole);

create or replace function updatevazbyrole()
    returns void as $$
declare
    _iduzivatelrole integer;
begin
    -- pro cechy
    if ((select max(idstatuleg) from nnastav) = (select idstatu from astaty where uuid = 'CZ_CZ')) then
        SELECT idrole into _iduzivatelrole FROM wrole where uuid = 'CZ_uzivatel';

        UPDATE wrole
                set idstandardrole = _iduzivatelrole, idotecrole = _iduzivatelrole
                where standard = false;
    end if;

    -- pro slovaky
    if ((select max(idstatuleg) from nnastav) = (select idstatu from astaty where uuid = 'SK_SK')) then
        SELECT idrole into _iduzivatelrole FROM wrole where uuid = 'SK_uzivatel';

        UPDATE wrole
                set idstandardrole = _iduzivatelrole, idotecrole = _iduzivatelrole
                where standard = false;
    end if;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION updatevazbyrole() OWNER TO %firmaRole%;

select updatevazbyrole();

drop function updatevazbyrole();


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 369, 't');
