--------------------------------------------------------------------------------
-- Bug 21220 – [WinStrom] Přidat funkci objednání pro výrobu
--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION findmnozzkusovniku(_idoteccenik integer, _idstred integer, _objmnoz numeric, leavesonly boolean, maxlevel integer, aktlevel integer)
  RETURNS SETOF cenikmnoz AS
$BODY$
declare
  _cenikmnoz cenikmnoz%rowtype;
  _subcenikmnoz cenikmnoz%rowtype;
  _kus record;
  _idsklad integer;
  _hasleaves boolean;
  _mnozotec numeric;
begin
  select mnoz into _mnozotec from ckusovnik where idoteccenik = _idoteccenik and idcenik = _idoteccenik;

  -- pro vsechny kusovniky majici za otce _idoteccenik
  for _kus in (select * from ckusovnik where idoteccenik = _idoteccenik and idcenik != idoteccenik) loop
    _hasleaves = false;
      
    -- a pokud neni aktualni uroven urovni posledni (tj kdyz se zada maxlevel = 0 pojede se do konce, protoze rovnost nenastane)
    if (maxlevel <> aktlevel) then
      -- projdeme jeho kusovniky, ze kterych se sklada, pridame si je mezi vysledky
      for _subcenikmnoz in select * from findmnozzkusovniku(_kus.idcenik, _idstred, _kus.mnoz * _objmnoz / _mnozotec, leavesonly, maxlevel, aktlevel + 1) loop
        _hasleaves = true;
        _subcenikmnoz.idcenikpuv := _idoteccenik;
        return next _subcenikmnoz;
      end loop;
    end if;

    -- jedna se o surovinu a chceme jenom suroviny
    -- nebo chceme vsechny
    if ((_hasleaves = false and leavesonly)
        or leavesonly = false) then
      _cenikmnoz.idcenik := _kus.idcenik;
      _cenikmnoz.mnoz := _kus.mnoz * _objmnoz / _mnozotec;
      _cenikmnoz.idcenikpuv := _idoteccenik;
      _cenikmnoz.idstred := _idstred;
      _cenikmnoz.leaf = not _hasleaves;
      _cenikmnoz.uroven = aktlevel;
      -- nalezneme preferovany sklad
      _idsklad = getprefidskladu(_idstred, (select idskupzboz from ccenik c where c.idcenik = _kus.idcenik), _kus.idcenik);
      _cenikmnoz.idsklad = _idsklad;
      return next _cenikmnoz;
    end if;
  end loop;
  return;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100
  ROWS 1000;
ALTER FUNCTION findmnozzkusovniku(integer, integer, numeric, boolean, integer, integer) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 402, 't');
