-- Bug 12561 – [WinStrom] Úpravy modelu pro DE

-- Odstranění nadbytečného sloupce danevidpojk z ddoklfak a z ddoklint
ALTER TABLE ddoklfak
  DROP COLUMN danevidpojk;
ALTER TABLE ddoklint
  DROP COLUMN danevidpojk;

-- Přidán sloupec danevidk do dpolfak a dpolint
ALTER TABLE dpolfak
  ADD COLUMN kopdanevid boolean DEFAULT true NOT NULL;
ALTER TABLE dpolfak
  ADD COLUMN danevidk character varying(50);

ALTER TABLE dpolint
  ADD COLUMN kopdanevid boolean DEFAULT true NOT NULL;
ALTER TABLE dpolint
  ADD COLUMN danevidk character varying(50);


CREATE OR REPLACE FUNCTION isDokladZuctovan(idDokl integer, doklPostfix varchar(100))
  RETURNS boolean AS $$
declare
  _podvojucto boolean;
  _ucetni boolean;
  _storno boolean;
  _bezpol boolean;
  _datUcto date; 
  _doklOk integer;
  _polozek integer;
  _polOk integer;
  idDoklColumn varchar(100);
  doklTable varchar(100);
  polTable varchar(100);
begin
  idDoklColumn := 'idDokl' || doklPostfix;
  doklTable := 'dDokl' || doklPostfix;
  polTable := 'dPol' || doklPostfix;

  execute 'select datUcto, ucetni, bezpolozek, storno from ' || doklTable || ' where ' || idDoklColumn || ' = ' || idDokl
   into _datUcto, _ucetni, _bezpol, _storno;
  execute 'select count(*) from ' || polTable || ' where ' || idDoklColumn || ' = ' || idDokl into _polozek;
  _doklOk := 0;

  if (_ucetni = true and _storno = false) then
    -- zjistime zda firma vede ucetnictvi
    select podvojucto into _podvojucto from nNastav where PlatiOdData <= _datUcto order by PlatiOdData desc limit 1;
    if (_podvojucto is null) then
      select podvojucto into _podvojucto from nNastav where PlatiOdData is null limit 1; 
    end if;

    if (_podvojucto = true) then
      -- ucetnictvi
      if (_bezpol = true or _polozek = 0) then
        execute
          'select count(*) from ' || doklTable || ' where ' || idDoklColumn || ' = ' || idDokl || ' and idstred is not null and
            datucto is not null and idprimucet is not null and idprotiucet is not null and
            (sumdphsniz = 0 or iddphsnizucet is not null) and (sumdphzakl = 0 or iddphzaklucet is not null)'
          into _doklOk;
      else
        execute
          'select count(*) from ' || polTable || ' where ' || idDoklColumn || ' = ' || idDokl || ' and
            (ucetni = false or 
            (idstred is not null and datucto is not null and idzkldalucet is not null and idzklmducet is not null and
              (modul = ''SKL'' or typszbdphk is null or typszbdphk = ''typSzbDph.dphOsv'' or (
                iddphmducet is not null and iddphdalucet is not null))))'
          into _polOk;
        if (_polOk = _polozek) then
          _doklOk := 1;
        end if;
      end if;
    else
      -- danova evidence
      if (doklTable = 'dDoklFak' or doklTable = 'dDoklInt') then
        if (_bezpol = true or _polozek = 0) then
          execute 'select count(*) from ' || doklTable || ' where ' || idDoklColumn || ' = ' || idDokl || '
            and datucto is not null and danevidk is not null' into _doklOk;
        else
          execute 'select count(*) from ' || polTable || ' where ' || idDoklColumn || ' = ' || idDokl || '
            and (ucetni = false or (datucto is not null and danevidk is not null))' into _polOk;
        end if;
      end if;
    end if;
  end if;
  
  return (_doklOk = 1);
end; 
$$ LANGUAGE plpgsql;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 43, 't');