-- odebrani prebytecnych dat z databaze
-- typy dokladu
DELETE FROM dtypdokl WHERE idtyporg <> (select idtyporg from nnastav where platioddata is null);
-- typy majetku
DELETE FROM mtypmaj WHERE idtyporg <> (select idtyporg from nnastav where platioddata is null);
-- skupiny firem
DELETE FROM askupfir WHERE idtyporg <> (select idtyporg from nnastav where platioddata is null);
-- skupiny zbozi
DELETE FROM cskupzboz WHERE idtyporg <> (select idtyporg from nnastav where platioddata is null);
-- sumace v sestavach
DELETE FROM usessumace WHERE idsesradky in (SELECT idsesradky FROM usesradky WHERE idsestavy in 
     (select idsestavy from usestavy where idtyporg <> (select idtyporg from nnastav where platioddata is null)));
-- standartni predpisy sestavy
DELETE FROM usesstdpred WHERE idsesradky in (SELECT idsesradky FROM usesradky WHERE idsestavy in 
     (select idsestavy from usestavy where idtyporg <> (select idtyporg from nnastav where platioddata is null)));
-- uzivatelske predpisy sestavy
DELETE FROM usesuzivpred WHERE idsesradky in (SELECT idsesradky FROM usesradky WHERE idsestavy in
     (select idsestavy from usestavy where idtyporg <> (select idtyporg from nnastav where platioddata is null)));
-- rozpady na ucty
DELETE FROM usesrozpaduce WHERE idsesradky in (SELECT idsesradky FROM usesradky WHERE idsestavy in
     (select idsestavy from usestavy where idtyporg <> (select idtyporg from nnastav where platioddata is null)));
-- vynulovani vazeb mezi sestavami
UPDATE usestavy SET idradcil = null, idseszdroj = null, idradzdroj = null WHERE idtyporg <> (select idtyporg from nnastav where platioddata is null);
-- radky sestavy
DELETE FROM usesradky WHERE idsestavy in 
 (select idsestavy from usestavy where idtyporg <> (select idtyporg from nnastav where platioddata is null));
-- sestavy
DELETE FROM usestavy WHERE idtyporg <> (select idtyporg from nnastav where platioddata is null);
-- ucty
DELETE FROM uucty WHERE idtyporg <> (select idtyporg from nnastav where platioddata is null);
-- standartni ucty
DELETE FROM ustducty WHERE idtyporg <> (select idtyporg from nnastav where platioddata is null);

-- odebrani cestatisk z nastaveni
ALTER TABLE nnastav DROP COLUMN cestatisk;

-- pridani uuid
alter table askupfir add column uuid character varying(50);
alter table asmerkod add column uuid character varying(50);
alter table astaty add column uuid character varying(50);
alter table cmerjed add column uuid character varying(50);
alter table cskupzboz add column uuid character varying(50);
alter table dkonsym add column uuid character varying(50);
alter table drady add column uuid character varying(50);
alter table msazby add column uuid character varying(50);
alter table mtypleas add column uuid character varying(50);
alter table mtypmaj add column uuid character varying(50);
alter table uclendph add column uuid character varying(50);
alter table umeny add column uuid character varying(50);
alter table usazbydph add column uuid character varying(50);
alter table usestavy add column uuid character varying(50);
alter table ustducty add column uuid character varying(50);
alter table ustrediska add column uuid character varying(50);
alter table uucty add column uuid character varying(50);
alter table wvybklice add column uuid character varying(50);


-- skupiny firem
update askupfir set uuid = 'CZ_ODBER_STD' where kod = 'ODBĚRATEL-STANDARD';
update askupfir set uuid = 'CZ_DODAV_STD' where kod = 'DODAVATEL-STANDARD';

-- smerove kody
UPDATE asmerkod SET uuid = 'CZ_' || kod where kod in ('0100','0300','0400','0600','0710','0800','1600','1900',
 '2100','2200','2400','2500','2600','2700','2800','3200','3300','3400','3500','3700','3800','3900','4000','4300',
 '4400','4500','4600','5000','5100','5400','5500','5700','5800','6000','6100','6200','6400','6700','6800','7910',
 '7920','7940','7950','7960','7970','7990','8030','8040','8050','8060','8070','8090','8150','0700', '2020', 
 '6210', '6300', '7980', '2030', '2210', '2010', '2070', '8200', '2040', '2050');
 
-- staty
UPDATE astaty SET uuid = 'CZ_' || kod where kod in ('AF','AL','DZ','AS','VI','AD','AO','AI','AQ','AG','AR','AM',
 'AW','AU','AZ','BS','BH','BD','BB','BE','BZ','BY','BJ','BM','BT','BO','BA','BW','BV','BR','IO','VG','BN','BG',
 'BF','BI','TD','CZ','XC','CL','HR','CN','CK','DK','DM','DO','DJ','EG','EC','ER','EE','ET','EU','FO','FK','FJ',
 'PH','FI','FR','TF','PF','GA','GM','GH','GI','GD','GL','GE','GU','GT','GN','GW','GY','HT','HM','HN','HK','IN',
 'ID','IQ','IR','IE','IS','IT','IL','JM','JP','YE','ZA','GS','JO','KY','KH','CM','CA','CV','QA','KZ','KE','KI',
 'CC','CO','KM','CG','CD','KR','KP','CR','CU','KW','CY','KG','LA','LS','LB','LR','LY','LI','LT','LV','LU','MO',
 'MG','HU','MK','MY','MW','MV','ML','MT','MA','MH','MU','MR','YT','XL','UM','MX','FM','MD','MN','MS','MZ','MM',
 'NA','NR','DE','NP','NE','NG','NI','NU','AN','NL','NF','NO','NC','NZ','PS','OM','PK','PW','PA','PG','PY','PE',
 'PN','CI','PL','PT','AT','GR','QQ','QS','QR','GQ','RO','RU','RW','PM','SB','SV','WS','SM','SA','SN','MP','SC',
 'SL','SG','SK','SI','SO','ES','AE','GB','US','CS','LK','QU','CF','SD','SR','SH','LC','KN','VA','ST','VC','SZ',
 'SE','CH','SY','TJ','TZ','TW','TH','TL','TG','TK','TO','TT','TN','TR','TM','TC','TV','UG','UA','UY','UZ','CX',
 'VU','VE','VN','WF','ZM','QW','QV');

-- merne jednotky
UPDATE cmerjed SET uuid = 'CZ_' || kod where kod in ('KG','M','KS');

-- skupiny zbozi
UPDATE cskupzboz SET uuid = 'CZ_ZBOZI' where kod = 'ZBOŽÍ';
UPDATE cskupzboz SET uuid = 'CZ_SLUZBY' where kod = 'SLUŽBY';

-- konstantni symboly
UPDATE dkonsym SET uuid = 'CZ_' || kod where kod in ('0008','0058','0108','0138','0168','0208','0308','0358',
 '0379','0408','0479','0558','0748','4648','7618');
 
-- dokladove rady
UPDATE drady SET uuid = 'CZ_FAV_STD' where kod = 'FAKTURA-STANDARD';
UPDATE drady SET uuid = 'CZ_FAV_ZAL' where kod = 'ZÁLOHA';
UPDATE drady SET uuid = 'CZ_FAP_STD' where kod = 'FAKTURA';
UPDATE drady SET uuid = 'CZ_POK_MINUS' where kod = 'POKLADNA-';
UPDATE drady SET uuid = 'CZ_POK_PLUS' where kod = 'POKLADNA+';
UPDATE drady SET uuid = 'CZ_BAN_MINUS' where kod = 'BANKA-';
UPDATE drady SET uuid = 'CZ_BAN_PLUS' where kod = 'BANKA+';
UPDATE drady SET uuid = 'CZ_SKL_PLUS' where kod = 'SKLAD+';
UPDATE drady SET uuid = 'CZ_SKL_MINUS' where kod = 'SKLAD-';
UPDATE drady SET uuid = 'CZ_FAP_ZAL' where kod = 'ZÁLOHA-PF';
UPDATE drady SET uuid = 'CZ_INT' where kod = 'INTERNÍ DOKLADY';
UPDATE drady SET uuid = 'CZ_NAV' where kod = 'NAV';
UPDATE drady SET uuid = 'CZ_OBP' where kod = 'OBP';
UPDATE drady SET uuid = 'CZ_PPP' where kod = 'POP';
UPDATE drady SET uuid = 'CZ_PPV' where kod = 'POV';
UPDATE drady SET uuid = 'CZ_NAP' where kod = 'NAP';
UPDATE drady SET uuid = 'CZ_OBV' where kod = 'OBV';
UPDATE drady SET uuid = 'CZ_ZAV' where kod = 'OSTATNÍ ZÁVAZKY';
UPDATE drady SET uuid = 'CZ_PHL' where kod = 'OSTATNÍ POHLEDÁVKY';

-- majetek - sazby
UPDATE msazby SET uuid = 'CZ_' || kod where kod in ('M18','M36','R1','R1_10','Z1','R1A','M72','R1_15','R1_20',
 'R1A_10','R2','R2_10','R2_15','R2_20','R3','R3_10','R3_15','R3_20','R4','R5','R5N','Z1A','Z2','Z3','Z5','Z4',
 'Z5N','M60');

-- typ majetku
UPDATE mtypmaj SET uuid = 'CZ_DLOUHODOBY' where kod = 'DLOUHODOBÝ HM.';
UPDATE mtypmaj SET uuid = 'CZ_NEODEPISOVANY' where kod = 'NEODEPISOVANÝ';

-- cleneni dph
update uclendph set uuid = 'CZ ' || kod where idstatu = (select idstatu from astaty where uuid = 'CZ_CZ');
update uclendph set uuid = 'SK ' || kod where idstatu = (select idstatu from astaty where uuid = 'CZ_SK');

-- meny
UPDATE umeny SET uuid = 'CZ_' || kod where kod in ('ATS', 'AUD', 'BEF', 'BGN', 'CAD', 'CHF', 'DEM', 'DIN',
 'DKK', 'ESP', 'EUR', 'FIM', 'FRF', 'GBP', 'GRD', 'HRK', 'HUF', 'IEP', 'ITL', 'JPY', 'LUF', 'NLG', 'NOK',
 'NZD', 'PTE', 'SEK', 'SKK', 'USD', 'XDR', 'XEU', 'CZK', 'BRL', 'CNY', 'EEK', 'PHP', 'HKD', 'IDR', 'ISK',
 'ZAR', 'KRW', 'LTL', 'LVL', 'MYR', 'MXN', 'PLN', 'RON', 'RUB', 'SGD', 'THB', 'TRY');
 
-- sazby dph
update usazbydph set uuid = 'CZ_0_1993' where szbdph = 0.00 and idstatu = (select idstatu from astaty where kod = 'CZ');
update usazbydph set uuid = 'CZ_5_1993' where szbdph = 5.00 and idstatu = (select idstatu from astaty where kod = 'CZ');
update usazbydph set uuid = 'CZ_23_1993' where szbdph = 23.00 and idstatu = (select idstatu from astaty where kod = 'CZ');
update usazbydph set uuid = 'CZ_22_1995' where szbdph = 22.00 and idstatu = (select idstatu from astaty where kod = 'CZ');
update usazbydph set uuid = 'CZ_19_2004' where szbdph = 19.00 and idstatu = (select idstatu from astaty where kod = 'CZ');
update usazbydph set uuid = 'CZ_9_2008' where szbdph = 9.00 and idstatu = (select idstatu from astaty where kod = 'CZ');
update usazbydph set uuid = 'SK_5_1993'  where szbdph = 5.00  and idstatu = (select idstatu from astaty where kod = 'SK');
update usazbydph set uuid = 'SK_6_1993'  where szbdph = 6.00  and idstatu = (select idstatu from astaty where kod = 'SK');
update usazbydph set uuid = 'SK_10_1999' where szbdph = 10.00 and platidodata is not null and idstatu = (select idstatu from astaty where kod = 'SK');
update usazbydph set uuid = 'SK_14_2003' where szbdph = 14.00 and idstatu = (select idstatu from astaty where kod = 'SK');
update usazbydph set uuid = 'SK_10_2007' where szbdph = 10.00 and platidodata is null and idstatu = (select idstatu from astaty where kod = 'SK');
update usazbydph set uuid = 'SK_23_1993' where szbdph = 23.00 and platioddata <= '1993-07-31' and idstatu = (select idstatu from astaty where kod = 'SK');
update usazbydph set uuid = 'SK_25_1993' where szbdph = 25.00 and idstatu = (select idstatu from astaty where kod = 'SK');
update usazbydph set uuid = 'SK_23_1996' where szbdph = 23.00 and platioddata > '1993-07-31' and idstatu = (select idstatu from astaty where kod = 'SK');
update usazbydph set uuid = 'SK_20_2003' where szbdph = 20.00 and idstatu = (select idstatu from astaty where kod = 'SK');
update usazbydph set uuid = 'SK_19_2004' where szbdph = 19.00 and idstatu = (select idstatu from astaty where kod = 'SK');
update usazbydph set uuid = 'SK_0_1993'  where szbdph = 0.00  and idstatu = (select idstatu from astaty where kod = 'SK');

--sestavy
UPDATE usestavy SET uuid = 'CZ_PODNIKATELE_ROZVAHA' where kod = 'ROZVAHA2006' and standard = true;
UPDATE usestavy SET uuid = 'CZ_PODNIKATELE_VYSLEDOVKA' where kod = 'VÝSLEDOVKA2003' and standard = true;
UPDATE usestavy SET uuid = 'CZ_ROZPOCTOVE_ROZVAHA' where kod = 'ROZ_K' and standard = true;
UPDATE usestavy SET uuid = 'CZ_ROZPOCTOVE_VYSLEDOVKA' where kod = 'VYS_K' and standard = true;

-- strediska
UPDATE ustrediska SET uuid = 'CZ_CENTRALA' where kod = 'C';

-- vyberove klice
UPDATE wvybklice SET uuid = 'CZ_KONT' where kod = 'KONT';
UPDATE wvybklice SET uuid = 'CZ_DULEZITE' where kod = 'DULEZITE';
UPDATE wvybklice SET uuid = 'CZ_VIP' where kod = 'VIP';

-- ucty
-- podnikatele
UPDATE uucty SET uuid = 'CZ_POD_' || kod where idtyporg = 1 and kod in (
  '343009', '343019', '010001', '013001', '021001', '022001', '041001', '042001', '070001', '073001', '081001', 
  '082001', '111001', '112001', '119001', '131001', '132001', '211001', '261001', '311001', '314001', '321001', 
  '324001', '331001', '336001', '325001', '428001', '431001', '501001', '503001', '504001', '518001', '521001', 
  '523001', '531001', '532001', '542001', '551001', '562001', '563001', '602001', '662001', '702000', '710000', 
  '648001', '548001', '374001', '411001', '502001', '524001', '527001', '591001', '601001', '701000', '604001', 
  '221001', '030001', '461001', '663001', '378001', '379001', '511001', '512001', '513001');
-- rozpotovky
UPDATE uucty SET uuid = 'CZ_ROZ_' || kod where idtyporg = 2 and kod in (
  '021001', '343009', '343019', '010001', '013001', '022001', '041001', '042001', '070001', '073001', '081001', 
  '082001', '111001', '112001', '119001', '131001', '132001', '211001', '261001', '314001', '324001', '331001', 
  '336001', '325001', '428001', '431001', '501001', '503001', '504001', '518001', '521001', '523001', '531001', 
  '532001', '542001', '551001', '562001', '563001', '602001', '662001', '702000', '710000', '648001', '548001', 
  '374001', '411001', '502001', '524001', '461001', '663001', '378001', '379001', '527001', '591001', '601001', 
  '701000', '604001', '221001', '030001', '321001', '511001', '512001', '513001', '311001', '645001', '545001', 
  '549001', '649001');

-- standartni ucty
-- podnikatele
UPDATE ustducty SET uuid = 'CZ_POD_' || kod where idtyporg = 1 and kod in (
  '010', '011', '012', '013', '014', '015', '019', '020', '021', '022', '025', '026', '029', '030', '031', '032', 
  '040', '041', '042', '043', '050', '051', '052', '053', '060', '061', '062', '063', '065', '066', '067', '069', 
  '070', '071', '072', '073', '074', '075', '079', '080', '081', '082', '085', '086', '089', '090', '091', '092', 
  '093', '094', '095', '096', '097', '098', '110', '111', '112', '118', '119', '120', '121', '122', '123', '124', 
  '128', '130', '131', '132', '138', '139', '150', '151', '152', '153', '190', '191', '192', '193', '194', '195', 
  '196', '197', '198', '199', '210', '211', '213', '220', '221', '230', '231', '232', '240', '241', '249', '250', 
  '251', '252', '253', '255', '256', '257', '259', '260', '261', '290', '291', '310', '311', '312', '313', '314', 
  '315', '320', '321', '322', '324', '325', '330', '331', '333', '335', '336', '340', '341', '342', '343', '345', 
  '346', '347', '350', '351', '352', '353', '354', '355', '358', '360', '361', '362', '364', '365', '366', '367', 
  '368', '370', '371', '372', '373', '374', '375', '376', '377', '378', '379', '380', '381', '382', '383', '384', 
  '386', '385', '387', '388', '389', '390', '391', '395', '398', '410', '411', '412', '413', '414', '418', '419', 
  '420', '421', '422', '423', '427', '428', '429', '430', '431', '450', '451', '453', '459', '460', '461', '470', 
  '471', '472', '473', '474', '475', '478', '479', '480', '481', '490', '491', '500', '501', '502', '503', '504', 
  '510', '511', '512', '513', '518', '520', '521', '522', '523', '524', '525', '526', '527', '528', '530', '531', 
  '532', '538', '540', '541', '542', '543', '544', '545', '546', '548', '549', '550', '551', '552', '554', '555', 
  '557', '558', '559', '560', '561', '562', '563', '564', '566', '567', '568', '569', '570', '574', '579', '580', 
  '581', '582', '584', '588', '589', '590', '591', '592', '593', '594', '595', '596', '597', '598', '600', '601', 
  '602', '604', '610', '611', '612', '613', '614', '620', '621', '622', '623', '624', '640', '641', '642', '644', 
  '646', '648', '658', '659', '660', '661', '662', '663', '664', '665', '666', '667', '668', '674', '680', '681', 
  '688', '690', '697', '698', '701', '702', '710', '700', '750', '760', '770', '780');
-- rozpotovky
UPDATE ustducty SET uuid = 'CZ_ROZ_' || kod where idtyporg = 2 and kod in (
  '012', '013', '014', '018', '019', '021', '022', '025', '026', '028', '029', '031', '041', '042', '043', '051', 
  '052', '061', '062', '063', '066', '067', '069', '072', '073', '074', '078', '079', '081', '082', '085', '086', 
  '088', '089', '091', '092', '093', '094', '095', '096', '111', '112', '119', '121', '122', '123', '124', '131', 
  '132', '139', '191', '192', '193', '194', '195', '196', '201', '202', '203', '204', '205', '206', '211', '212', 
  '213', '214', '215', '216', '217', '218', '221', '222', '231', '232', '233', '234', '235', '236', '237', '238', 
  '241', '243', '245', '251', '253', '255', '259', '261', '262', '263', '271', '272', '273', '274', '275', '277', 
  '281', '282', '283', '289', '291', '293', '311', '312', '313', '314', '315', '316', '321', '322', '324', '325', 
  '331', '333', '335', '336', '341', '342', '343', '345', '346', '347', '348', '349', '358', '367', '373', '375', 
  '378', '379', '381', '382', '383', '384', '385', '386', '387', '388', '389', '391', '395', '398', '400', '410', 
  '420', '430', '440', '450', '460', '500', '501', '502', '503', '504', '510', '511', '512', '513', '518', '520', 
  '521', '524', '525', '527', '528', '530', '531', '532', '538', '540', '541', '542', '543', '544', '545', '546', 
  '548', '549', '550', '551', '552', '553', '554', '556', '558', '559', '591', '595', '600', '601', '602', '604', 
  '610', '611', '612', '613', '614', '620', '621', '622', '623', '624', '640', '641', '643', '644', '645', '649', 
  '650', '651', '652', '653', '654', '655', '656', '659', '691', '901', '902', '903', '911', '912', '914', '916', 
  '917', '918', '921', '922', '931', '932', '933', '941', '951', '953', '954', '955', '958', '959', '961', '962', 
  '963', '964', '965', '999');
  
  
-- oprava statu
update astaty set nazev = 'Bosna a Hercegovina' where uuid = 'CZ_BA';
update astaty set nazev = 'Kongo' where uuid = 'CZ_CG';
update astaty set nazev = 'Kongo, demokratická republika' where uuid = 'CZ_CD';
update astaty set nazev = 'Mongolsko' where uuid = 'CZ_MN';
update astaty set nazev = 'Togo' where uuid = 'CZ_TG';
update astaty set nazev = 'Trinidad a Tobago' where uuid = 'CZ_TT';


-- nastaveni sekvenci sestav vysoko aby jsme meli do budoucna revervu v id
select setval('seq_usestavy', 10000);
select setval('seq_usesradky', 1000000);
select setval('seq_usesstdpred', 1000000);
select setval('seq_usessumace', 1000000);

-- nastaveni spravne hodnoty sekvence pro cleneni dph
select setval('seq_uclendph', (select max(idclendph) from uclendph));

-- pridany cleneni pro bug 12613
insert into uclendph (lastupdate, kod, nazev, nazeva, nazevb, nazevc, platido, platiod, popis, poznam, show, jedph, kodplnenik, typobchoduk, typplnenik, idstatu, uuid)
 values ('2009-01-01 0:00', '40-41, 48', 'Z přijatých zdanitelných plnění od plátců + z toho hodnota pořízeného majetku vymezeného v § 78 odst. 2', NULL, NULL, NULL, 9999, 2009,NULL, NULL, true, true, NULL, 'typObchodu.tuzem', 'typPlneni.prijata',
         (select idstatu from astaty where uuid like '%_CZ'), 'CZ 40-41, 48');
insert into uclendph (lastupdate, kod, nazev, nazeva, nazevb, nazevc, platido, platiod, popis, poznam, show, jedph, kodplnenik, typobchoduk, typplnenik, idstatu, uuid)
 values ('2009-01-01 0:00', '40-41, 48 KR', 'Z přijatých zdanitelných plnění od plátců + z toho hodnota pořízeného majetku vymezeného v § 78 odst. 2 - krácený nárok na odpočet', NULL, NULL, NULL, 9999, 2009,NULL, NULL, true, true, NULL, 'typObchodu.tuzem', 'typPlneni.prijata',
         (select idstatu from astaty where uuid like '%_CZ'), 'CZ 40-41, 48 KR');
insert into uclendph (lastupdate, kod, nazev, nazeva, nazevb, nazevc, platido, platiod, popis, poznam, show, jedph, kodplnenik, typobchoduk, typplnenik, idstatu, uuid)
 values ('2008-01-01 0:00', '42-43, 48', 'Při dovozu zboží, kdy je správcem daně celní úřad + z toho hodnota pořízeného majetku vymezeného v § 78 odst. 2', NULL, NULL, NULL, 9999, 2009, NULL, NULL, true, true, 'kodPlneni.0', 'typObchodu.EUplatce', 'typPlneni.prijata',
         (select idstatu from astaty where uuid like '%_CZ'), 'CZ 42-43, 48');
insert into uclendph (lastupdate, kod, nazev, nazeva, nazevb, nazevc, platido, platiod, popis, poznam, show, jedph, kodplnenik, typobchoduk, typplnenik, idstatu, uuid)
 values ('2008-01-01 0:00', '42-43, 48 KR', 'Při dovozu zboží, kdy je správcem daně celní úřad + z toho hodnota pořízeného majetku vymezeného v § 78 odst. 2 - krácený nárok na odpočet', NULL, NULL, NULL, 9999, 2009,NULL, NULL, true, true, 'kodPlneni.0', 'typObchodu.EUplatce', 'typPlneni.prijata',
         (select idstatu from astaty where uuid like '%_CZ'), 'CZ 42-43, 48 KR');
insert into uclendph (lastupdate, kod, nazev, nazeva, nazevb, nazevc, platido, platiod, popis, poznam, show, jedph, kodplnenik, typobchoduk, typplnenik, idstatu, uuid)
 values ('2008-01-01 0:00', '03-04, 44-45, 48', 'Pořízení zboží z jiného členského státu(§ 16; § 17 odst. 6 písm. e); § 19 odst. 3) + z toho hodnota pořízeného majetku vymezeného v § 78 odst. 2', NULL, NULL, NULL, 9999, 2009,NULL, NULL, true, true, 'kodPlneni.0', 'typObchodu.EUplatce', 'typPlneni.obojiRCH',
         (select idstatu from astaty where uuid like '%_CZ'), 'CZ 03-04, 44-45, 48');
insert into uclendph (lastupdate, kod, nazev, nazeva, nazevb, nazevc, platido, platiod, popis, poznam, show, jedph, kodplnenik, typobchoduk, typplnenik, idstatu, uuid)
 values ('2008-01-01 0:00', '03-04, 44-45, 48 KR', 'Pořízení zboží z jiného členského státu(§ 16; § 17 odst. 6 písm. e); § 19 odst. 3) + z toho hodnota pořízeného majetku vymezeného v § 78 odst. 2 - krácený nárok na odpočet', NULL, NULL, NULL, 9999, 2009,NULL, NULL, true, true, 'kodPlneni.0', 'typObchodu.EUplatce', 'typPlneni.obojiRCH',
         (select idstatu from astaty where uuid like '%_CZ'), 'CZ 03-04, 44-45, 48 KR');
insert into uclendph (lastupdate, kod, nazev, nazeva, nazevb, nazevc, platido, platiod, popis, poznam, show, jedph, kodplnenik, typobchoduk, typplnenik, idstatu, uuid)
 values ('2008-01-01 0:00', '07-08, 44-45, 48', 'Dovoz zboží (§ 23 odst. 3 a 4) + z toho hodnota pořízeného majetku vymezeného v § 78 odst. 2', NULL, NULL, NULL, 9999, 2009,NULL, NULL, true, true, 'kodPlneni.0', 'typObchodu.cizina', 'typPlneni.obojiRCH',
         (select idstatu from astaty where uuid like '%_CZ'), 'CZ 07-08, 44-45, 48');
insert into uclendph (lastupdate, kod, nazev, nazeva, nazevb, nazevc, platido, platiod, popis, poznam, show, jedph, kodplnenik, typobchoduk, typplnenik, idstatu, uuid)
 values ('2008-01-01 0:00', '07-08, 44-45, 48 KR', 'Dovoz zboží (§ 23 odst. 3 a 4) + z toho hodnota pořízeného majetku vymezeného v § 78 odst. 2 - krácený nárok na odpočet', NULL, NULL, NULL, 9999, 2009,NULL, NULL, true, true, 'kodPlneni.0', 'typObchodu.cizina', 'typPlneni.obojiRCH',
         (select idstatu from astaty where uuid like '%_CZ'), 'CZ 07-08, 44-45, 48 KR');
insert into uclendph (lastupdate, kod, nazev, nazeva, nazevb, nazevc, platido, platiod, popis, poznam, show, jedph, kodplnenik, typobchoduk, typplnenik, idstatu, uuid)
 values ('2008-01-01 0:00', '09, 44, 48', 'Pořízení nového dopravního prostředku (§ 19 odst. 4) + z toho hodnota pořízeného majetku vymezeného v § 78 odst. 2', NULL, NULL, NULL, 9999, 2009,NULL, NULL, true, true, 'kodPlneni.0', 'typObchodu.EUplatce', 'typPlneni.obojiRCH',
         (select idstatu from astaty where uuid like '%_CZ'), 'CZ 09, 44, 48');
insert into uclendph (lastupdate, kod, nazev, nazeva, nazevb, nazevc, platido, platiod, popis, poznam, show, jedph, kodplnenik, typobchoduk, typplnenik, idstatu, uuid)
 values ('2008-01-01 0:00', '09, 44, 48 KR', 'Pořízení nového dopravního prostředku (§ 19 odst. 4) + z toho hodnota pořízeného majetku vymezeného v § 78 odst. 2 - krácený nárok na odpočet', NULL, NULL, NULL, 9999, 2009,NULL, NULL, true, true, 'kodPlneni.0', 'typObchodu.EUplatce', 'typPlneni.obojiRCH',
         (select idstatu from astaty where uuid like '%_CZ'), 'CZ 09, 44, 48 KR');
insert into uclendph (lastupdate, kod, nazev, nazeva, nazevb, nazevc, platido, platiod, popis, poznam, show, jedph, kodplnenik, typobchoduk, typplnenik, idstatu, uuid)
 values ('2008-01-01 0:00', '10, 44, 48', 'Dodání zlata podle zvláštního režimu (§ 92a odst. 2) + z toho hodnota pořízeného majetku vymezeného v § 78 odst. 2', NULL, NULL, NULL, 9999, 2009,NULL, NULL, true, true, 'kodPlneni.0', 'typObchodu.EUplatce', 'typPlneni.obojiRCH',
         (select idstatu from astaty where uuid like '%_CZ'), 'CZ 10, 44, 48');
insert into uclendph (lastupdate, kod, nazev, nazeva, nazevb, nazevc, platido, platiod, popis, poznam, show, jedph, kodplnenik, typobchoduk, typplnenik, idstatu, uuid)
 values ('2008-01-01 0:00', '10, 44, 48 KR', 'Dodání zlata podle zvláštního režimu (§ 92a odst. 2)) + z toho hodnota pořízeného majetku vymezeného v § 78 odst. 2 - krácený nárok na odpočet', NULL, NULL, NULL, 9999, 2009,NULL, NULL, true, true, 'kodPlneni.0', 'typObchodu.EUplatce', 'typPlneni.obojiRCH',
         (select idstatu from astaty where uuid like '%_CZ'), 'CZ 10, 44, 48 KR');

-- pridani slovenskych cleneni pokud neexistujou
INSERT INTO uclendph (lastupdate, kod, nazev, nazeva, nazevb, nazevc, platido, platiod, popis, poznam, show, jedph, kodplnenik, typobchoduk, typplnenik, idstatu, uuid)
 (select '2008-01-04 00:00:00''', '000P', 'Výdaje bez vplyvu na DPH', NULL, NULL, NULL,9999,0,NULL, NULL, true, false, NULL, NULL, 'typPlneni.prijata', (select idstatu from astaty where uuid like '%_SK'), 'SK 000P'
  where (select count(*) from uclendph where uuid like 'SK 000P') = 0);
INSERT INTO uclendph (lastupdate, kod, nazev, nazeva, nazevb, nazevc, platido, platiod, popis, poznam, show, jedph, kodplnenik, typobchoduk, typplnenik, idstatu, uuid)
 (select '2008-01-04 00:00:00''', '000U', 'Príjmy bez vplyvu na DPH', NULL, NULL, NULL,9999,0,NULL, NULL, true, false, NULL, NULL, 'typPlneni.uskutecnena', (select idstatu from astaty where uuid like '%_SK'), 'SK 000U'
  where (select count(*) from uclendph where uuid like 'SK 000U') = 0);
INSERT INTO uclendph (lastupdate, kod, nazev, nazeva, nazevb, nazevc, platido, platiod, popis, poznam, show, jedph, kodplnenik, typobchoduk, typplnenik, idstatu, uuid)
 (select '2008-01-04 00:00:00''', '001-003', 'Dodanie tovaru a služby podľa § 8 a 9 zákona', NULL, NULL, NULL,9999,0,NULL, NULL, true, true, NULL, 'typObchodu.tuzem', 'typPlneni.uskutecnena', (select idstatu from astaty where uuid like '%_SK'), 'SK 001-003'
  where (select count(*) from uclendph where uuid like 'SK 001-003') = 0);
INSERT INTO uclendph (lastupdate, kod, nazev, nazeva, nazevb, nazevc, platido, platiod, popis, poznam, show, jedph, kodplnenik, typobchoduk, typplnenik, idstatu, uuid)
 (select '2008-01-04 00:00:00''', '005-007', 'EÚ tovar nadobudnutý z iného členského štátu  -  Nadobudnutie tovaru v tuzemsku podľa § 11 a 11a zákona', NULL, NULL, NULL,9999,0,NULL, NULL, true, true, NULL, 'typObchodu.EUplatce', 'typPlneni.uskutecnena', (select idstatu from astaty where uuid like '%_SK'), 'SK 005-007'
  where (select count(*) from uclendph where uuid like 'SK 005-007') = 0);
INSERT INTO uclendph (lastupdate, kod, nazev, nazeva, nazevb, nazevc, platido, platiod, popis, poznam, show, jedph, kodplnenik, typobchoduk, typplnenik, idstatu, uuid)
 (select '2008-01-04 00:00:00''', '009', 'EÚ dododaný  od neplátca  za služby a tovar  s inštalácou  v SR  -  Tovary a služby, pri ktorých príjemca platí daň podľa § 69 ods. 2 až 4 a 9 zákona', NULL, NULL, NULL,9999,0,NULL, NULL, true, true, NULL, 'typObchodu.EUneplat', 'typPlneni.uskutecnena', (select idstatu from astaty where uuid like '%_SK'), 'SK 009'
  where (select count(*) from uclendph where uuid like 'SK 009') = 0);
INSERT INTO uclendph (lastupdate, kod, nazev, nazeva, nazevb, nazevc, platido, platiod, popis, poznam, show, jedph, kodplnenik, typobchoduk, typplnenik, idstatu, uuid)
 (select '2008-01-04 00:00:00''', '011', 'EÚ tovar trojstranný obchod - druhý odberateľ  -  Tovary, pri ktorých druhý odberateľ platí daň podľa § 69 ods. 7 zákona', NULL, NULL, NULL,9999,0,NULL, NULL, true, true, 'kodPlneni.2', NULL, 'typPlneni.uskutecnena', (select idstatu from astaty where uuid like '%_SK'), 'SK 011'
  where (select count(*) from uclendph where uuid like 'SK 011') = 0);
INSERT INTO uclendph (lastupdate, kod, nazev, nazeva, nazevb, nazevc, platido, platiod, popis, poznam, show, jedph, kodplnenik, typobchoduk, typplnenik, idstatu, uuid)
 (select '2008-01-04 00:00:00''', '013', 'Oslobod. dod. tov. a služieb bez možn. odpočí.dane  -  Dodanie tovarov a služieb s oslobodením od dane', NULL, NULL, NULL,9999,0,NULL, NULL, true, true, NULL, NULL, 'typPlneni.uskutecnena', (select idstatu from astaty where uuid like '%_SK'), 'SK 013'
  where (select count(*) from uclendph where uuid like 'SK 013') = 0);
INSERT INTO uclendph (lastupdate, kod, nazev, nazeva, nazevb, nazevc, platido, platiod, popis, poznam, show, jedph, kodplnenik, typobchoduk, typplnenik, idstatu, uuid)
 (select '2008-01-04 00:00:00''', '014', 'Oslobod. dod. tov. a služieb s možnos. odpočí.dane  -  Dodanie tovarov a služieb s oslobodením od dane podľa § 43 ods. 1, 2 a 4 zákona', NULL, NULL, NULL,9999,0,NULL, NULL, true, true, NULL, NULL, 'typPlneni.uskutecnena', (select idstatu from astaty where uuid like '%_SK'), 'SK 014'
  where (select count(*) from uclendph where uuid like 'SK 014') = 0);
INSERT INTO uclendph (lastupdate, kod, nazev, nazeva, nazevb, nazevc, platido, platiod, popis, poznam, show, jedph, kodplnenik, typobchoduk, typplnenik, idstatu, uuid)
 (select '2008-01-04 00:00:00''', '015', 'Vývoz tovaru a služieb  -  Dodanie tovarov a služieb s oslobodením od dane podľa  § 46, 47a§48ods. 8 zákona', NULL, NULL, NULL,9999,0,NULL, NULL, true, true, NULL, NULL, 'typPlneni.uskutecnena', (select idstatu from astaty where uuid like '%_SK'), 'SK 015'
  where (select count(*) from uclendph where uuid like 'SK 015') = 0);
INSERT INTO uclendph (lastupdate, kod, nazev, nazeva, nazevb, nazevc, platido, platiod, popis, poznam, show, jedph, kodplnenik, typobchoduk, typplnenik, idstatu, uuid)
 (select '2008-01-04 00:00:00''', '016', 'Daňová povinnosť pri zrušení registrácie podľa § 81 zákona', NULL, NULL, NULL,9999,0,NULL, NULL, true, true, NULL, NULL, 'typPlneni.uskutecnena', (select idstatu from astaty where uuid like '%_SK'), 'SK 016'
  where (select count(*) from uclendph where uuid like 'SK 016') = 0);
INSERT INTO uclendph (lastupdate, kod, nazev, nazeva, nazevb, nazevc, platido, platiod, popis, poznam, show, jedph, kodplnenik, typobchoduk, typplnenik, idstatu, uuid)
 (select '2008-01-04 00:00:00''', '018-019', 'Prijaté zdan. plnenia (okrem tuzemska a dovozu)  - Odpočítanie dane celkom podľa § 49 – 54 zákona', NULL, NULL, NULL,9999,0,NULL, NULL, true, true, NULL, NULL, 'typPlneni.prijata', (select idstatu from astaty where uuid like '%_SK'), 'SK 018-019'
  where (select count(*) from uclendph where uuid like 'SK 018-019') = 0);
INSERT INTO uclendph (lastupdate, kod, nazev, nazeva, nazevb, nazevc, platido, platiod, popis, poznam, show, jedph, kodplnenik, typobchoduk, typplnenik, idstatu, uuid)
 (select '2008-01-04 00:00:00''', '020-021', 'Daň z tovarov a služieb z tuzemska  -  z toho podľa § 51 ods.1 písm. a) zákona', NULL, NULL, NULL,9999,0,NULL, NULL, true, true, NULL, NULL, 'typPlneni.prijata', (select idstatu from astaty where uuid like '%_SK'), 'SK 020-021'
  where (select count(*) from uclendph where uuid like 'SK 020-021') = 0);
INSERT INTO uclendph (lastupdate, kod, nazev, nazeva, nazevb, nazevc, platido, platiod, popis, poznam, show, jedph, kodplnenik, typobchoduk, typplnenik, idstatu, uuid)
 (select '2008-01-04 00:00:00''', '022-023', 'Daň zaplatená pri dovoze tovaru  -  podľa § 51 ods. 1 písm. d) zákona', NULL, NULL, NULL,9999,0,NULL, NULL, true, true, NULL, NULL, 'typPlneni.prijata', (select idstatu from astaty where uuid like '%_SK'), 'SK 022-023'
  where (select count(*) from uclendph where uuid like 'SK 022-023') = 0);
INSERT INTO uclendph (lastupdate, kod, nazev, nazeva, nazevb, nazevc, platido, platiod, popis, poznam, show, jedph, kodplnenik, typobchoduk, typplnenik, idstatu, uuid)
 (select '2008-01-04 00:00:00''', '024', 'Odpočítanie dane pri registrácii  -  platiteľa dane podľa § 55 zákona', NULL, NULL, NULL,9999,0,NULL, NULL, true, true, NULL, NULL, 'typPlneni.prijata', (select idstatu from astaty where uuid like '%_SK'), 'SK 024'
  where (select count(*) from uclendph where uuid like 'SK 024') = 0);
INSERT INTO uclendph (lastupdate, kod, nazev, nazeva, nazevb, nazevc, platido, platiod, popis, poznam, show, jedph, kodplnenik, typobchoduk, typplnenik, idstatu, uuid)
 (select '2008-01-04 00:00:00''', '025', 'Vrátenie dane cestujúcim pri vývoze tovaru podľa § 60 zákona', NULL, NULL, NULL,9999,0,NULL, NULL, true, true, NULL, NULL, 'typPlneni.prijata', (select idstatu from astaty where uuid like '%_SK'), 'SK 025'
  where (select count(*) from uclendph where uuid like 'SK 025') = 0);
INSERT INTO uclendph (lastupdate, kod, nazev, nazeva, nazevb, nazevc, platido, platiod, popis, poznam, show, jedph, kodplnenik, typobchoduk, typplnenik, idstatu, uuid)
 (select '2008-01-04 00:00:00''', '026', 'Preddavok na daň za zdaňovacie obdobie podľa § 78a zákona', NULL, NULL, NULL,9999,0,NULL, NULL, true, true, NULL, NULL, 'typPlneni.prijata', (select idstatu from astaty where uuid like '%_SK'), 'SK 026'
  where (select count(*) from uclendph where uuid like 'SK 026') = 0);
INSERT INTO uclendph (lastupdate, kod, nazev, nazeva, nazevb, nazevc, platido, platiod, popis, poznam, show, jedph, kodplnenik, typobchoduk, typplnenik, idstatu, uuid)
 (select '2008-01-04 00:00:00''', '033', 'EÚ tovar trojst. obchod - nadobudnutie prvým odb.  -  Trojstranný obchod podľa § 45 zákona   -  Nadobudnutie tovaru prvým odberateľom', NULL, NULL, NULL,9999,0,NULL, NULL, true, true, 'kodPlneni.2', NULL, 'typPlneni.prijata', (select idstatu from astaty where uuid like '%_SK'), 'SK 033'
  where (select count(*) from uclendph where uuid like 'SK 033') = 0);
INSERT INTO uclendph (lastupdate, kod, nazev, nazeva, nazevb, nazevc, platido, platiod, popis, poznam, show, jedph, kodplnenik, typobchoduk, typplnenik, idstatu, uuid)
 (select '2008-01-04 00:00:00''', '034', 'EÚ tovar trojst. obchod - dodanie prvým odb.  -  Trojstranný obchod podľa § 45 zákona  -  Dodanie tovaru prvým odberateľom', NULL, NULL, NULL,9999,0,NULL, NULL, true, true, 'kodPlneni.2', NULL, 'typPlneni.uskutecnena', (select idstatu from astaty where uuid like '%_SK'), 'SK 034'
  where (select count(*) from uclendph where uuid like 'SK 034') = 0);

-- pridani slovenskych sazeb dph pokud neexistujou
INSERT INTO usazbydph (lastupdate, platidodata, platioddata, popis, poznam, szbdph, typszbdphk, idstatu, uuid)
 (select '2006-12-04 13:31:43.783', '1993-07-31', '1993-01-01', NULL, NULL, 5.00, 'typSzbDph.dphSniz', (select idstatu from astaty where uuid like '%_SK'), 'SK_5_1993'
  where (select count(*) from usazbydph where uuid like 'SK_5_1993') = 0); 
INSERT INTO usazbydph (lastupdate, platidodata, platioddata, popis, poznam, szbdph, typszbdphk, idstatu, uuid)
 (select '2006-12-04 13:32:04.779', '1999-06-30', '1993-08-01', NULL, NULL, 6.00, 'typSzbDph.dphSniz', (select idstatu from astaty where uuid like '%_SK'), 'SK_6_1993'
  where (select count(*) from usazbydph where uuid like 'SK_6_1993') = 0); 
INSERT INTO usazbydph (lastupdate, platidodata, platioddata, popis, poznam, szbdph, typszbdphk, idstatu, uuid)
 (select '2006-12-04 13:33:11.612', '2002-12-31', '1999-07-01', NULL, NULL, 10.00, 'typSzbDph.dphSniz', (select idstatu from astaty where uuid like '%_SK'), 'SK_10_1999'
  where (select count(*) from usazbydph where uuid like 'SK_10_1999') = 0); 
INSERT INTO usazbydph (lastupdate, platidodata, platioddata, popis, poznam, szbdph, typszbdphk, idstatu, uuid)
 (select '2006-12-04 13:33:35.931', '2003-12-31', '2003-01-01', NULL, NULL, 14.00, 'typSzbDph.dphSniz', (select idstatu from astaty where uuid like '%_SK'), 'SK_14_2003'
  where (select count(*) from usazbydph where uuid like 'SK_14_2003') = 0); 
INSERT INTO usazbydph (lastupdate, platidodata, platioddata, popis, poznam, szbdph, typszbdphk, idstatu, uuid)
 (select '2006-12-04 13:33:35.934', NULL, '2007-01-01', NULL, NULL, 10.00, 'typSzbDph.dphSniz', (select idstatu from astaty where uuid like '%_SK'), 'SK_10_2007'
  where (select count(*) from usazbydph where uuid like 'SK_10_2007') = 0); 
INSERT INTO usazbydph (lastupdate, platidodata, platioddata, popis, poznam, szbdph, typszbdphk, idstatu, uuid)
 (select '2006-12-04 13:35:39.961', '1993-07-31', '1993-01-01', NULL, NULL, 23.00, 'typSzbDph.dphZakl', (select idstatu from astaty where uuid like '%_SK'), 'SK_23_1993'
  where (select count(*) from usazbydph where uuid like 'SK_23_1993') = 0); 
INSERT INTO usazbydph (lastupdate, platidodata, platioddata, popis, poznam, szbdph, typszbdphk, idstatu, uuid)
 (select '2006-12-04 13:36:09.305', '1995-12-31', '1993-08-01', NULL, NULL, 25.00, 'typSzbDph.dphZakl', (select idstatu from astaty where uuid like '%_SK'), 'SK_25_1993'
  where (select count(*) from usazbydph where uuid like 'SK_25_1993') = 0); 
INSERT INTO usazbydph (lastupdate, platidodata, platioddata, popis, poznam, szbdph, typszbdphk, idstatu, uuid)
 (select '2006-12-04 13:36:40.123', '2002-12-31', '1996-01-01', NULL, NULL, 23.00, 'typSzbDph.dphZakl', (select idstatu from astaty where uuid like '%_SK'), 'SK_23_1996'
  where (select count(*) from usazbydph where uuid like 'SK_23_1996') = 0); 
INSERT INTO usazbydph (lastupdate, platidodata, platioddata, popis, poznam, szbdph, typszbdphk, idstatu, uuid)
 (select '2006-12-04 13:37:41.693', '2003-12-31', '2003-01-01', NULL, NULL, 20.00, 'typSzbDph.dphZakl', (select idstatu from astaty where uuid like '%_SK'), 'SK_20_2003'
  where (select count(*) from usazbydph where uuid like 'SK_20_2003') = 0); 
INSERT INTO usazbydph (lastupdate, platidodata, platioddata, popis, poznam, szbdph, typszbdphk, idstatu, uuid)
 (select '2006-12-04 13:37:41.706', NULL, '2004-01-01', NULL, NULL, 19.00, 'typSzbDph.dphZakl', (select idstatu from astaty where uuid like '%_SK'), 'SK_19_2004'
  where (select count(*) from usazbydph where uuid like 'SK_19_2004') = 0); 
INSERT INTO usazbydph (lastupdate, platidodata, platioddata, popis, poznam, szbdph, typszbdphk, idstatu, uuid) 
 (select '2006-06-27 17:58:13.578', NULL, '1993-01-01', NULL, NULL, 0.00, 'typSzbDph.dphOsv', (select idstatu from astaty where uuid like '%_SK'), 'SK_0_1993'
  where (select count(*) from usazbydph where uuid like 'SK_0_1993') = 0); 




-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 44, 't');
