--------------------------------------------------------------------------------
-- bug none - pri zmene data vystaveni pres obdobi se nezmeni skladova karta
--------------------------------------------------------------------------------

-- Function: dpoldoklupdatesklad()
-- DROP FUNCTION dpoldoklupdatesklad();
CREATE OR REPLACE FUNCTION dpoldoklupdatesklad()
  RETURNS trigger AS
$BODY$ 
declare 
  _idPolDokl integer; 
  _idDoklad integer; 
  _idPolSklad integer; 
  _idDoklSklad integer; 
  _dokladGenerovatSkl boolean; 
  _typDoklGenerovatSkl boolean; 
  _typZasobyK character varying; 
  _skladove boolean; 
  _vyrobniCislo record; 
  _typPohybuK character varying; 
  _sadaItemCount integer; 
  _vypnutySklad character varying;  
begin 
  select getglotxvariable('vypniSklad') into _vypnutySklad; 
  if(_vypnutySklad is null or _vypnutySklad <> 'true') then 
    --raise exception 'sem sem se nemel dostat'; 
    if(NEW.storno <> OLD.storno or NEW.stornoPol <> OLD.stornoPol) then 
      return NEW; 
    end if; 
 
    if(NEW.modul like 'POK') then 
      _idPolDokl = NEW.idPolInt; 
      _idDoklad = NEW.idDoklInt; 
      select generovatSkl into _dokladGenerovatSkl from dDoklInt where idDoklInt = NEW.idDoklInt; 
      select generovatSkl into _typDoklGenerovatSkl from dTypDokl where idTypDokl = (select idTypDokl from dDoklInt where idDoklInt = NEW.idDoklInt); 
 
      select count(*) into _sadaItemCount from csady where idceniksada = (select idcenik from dpolInt where idpolint = NEW.idPolInt); 
    elsif (NEW.modul like 'FAV' or NEW.modul like 'FAP') then 
      _idPolDokl = NEW.idPolFak; 
      _idDoklad = NEW.idDoklFak; 
      select generovatSkl into _dokladGenerovatSkl from dDoklFak where idDoklFak = NEW.idDoklFak; 
      select generovatSkl into _typDoklGenerovatSkl from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = NEW.idDoklFak); 
 
      select count(*) into _sadaItemCount from csady where idceniksada = (select idcenik from dpolfak where idpolfak = NEW.idPolFak); 
    else  
      return NEW;   
    end if; 
 
    -- pokud se lisi sklad, cenik, typPolozky, mnozMj, sarze, expirace 
    -- tak skladovou polozku musim smazat a vytvorit znovu kvuli fifu 
    if((not compareId(NEW.idBspSkl, OLD.idBspSkl) 
       or not compareId(NEW.idCenik, OLD.idCenik) 
       or not compareVarchar(NEW.typPolozkyK, OLD.typPolozkyK) 
       or NEW.mnozMj <> OLD.mnozMj 
       or not compareVarchar(NEW.sarze, OLD.sarze) 
       or not compareDate(NEW.expirace, OLD.expirace)
       or not compareDate(NEW.datVyst, OLD.datVyst)
       ) 
       and _dokladGenerovatSkl and NEW.zdrojProSkl) then   
      --raise exception 'mazu polSklad'; 
      execute deleteNavazanePolSklad(_idPolDokl, NEW.modul); 
    end if; 
 
    if(NEW.typPolozkyK like 'typPolozky.katalog' and _dokladGenerovatSkl and _typDoklGenerovatSkl and NEW.zdrojProSkl) then   
      select skladove into _skladove from cCenik where idCenik = NEW.idCenik; 
     
      if (_skladove and NEW.idBspSkl is not null) then 
        select findParovanyPolSklad(_idPolDokl, NEW.modul) into _idPolSklad; 
        if(_idPolSklad is null) then 
          --select createPolSklad(_idPolDokl, NEW.modul) into _idPolSklad;  
          if(_sadaItemCount > 0) then 
            execute createPolSkladSada(_idPolDokl, NEW.modul); 
          else 
            select createPolSklad(_idPolDokl, NEW.modul) into _idPolSklad;  
          end if; 
        else 
          if(_sadaItemCount > 0) then 
            execute fillPolSkladSada(_idPolDokl, NEW.modul); 
          else 
            select fillPolSklad(_idPolSklad, _idPolDokl, NEW.modul) into _idPolSklad;  
          end if; 
        end if; 
        -- provedeni upgradu vyrobnich cisel 
        if(NEW.modul like 'FAV') then 
          for _vyrobniCislo in select * from sVyrobniCislo where idPolFakVydej = NEW.idPolFak and (idPolSkladVydej is null or idPolSkladVydej <> _idPolSklad) loop 
            update sVyrobniCislo set idPolSkladVydej = _idPolSklad where idVyrobniCislo = _vyrobniCislo.idVyrobniCislo; 
          end loop; 
        end if; 
        if(NEW.modul like 'FAP') then 
          for _vyrobniCislo in select * from sVyrobniCislo where idPolFakPrijem = NEW.idPolFak and (idPolSkladPrijem is null or idPolSkladPrijem <> _idPolSklad) loop 
            update sVyrobniCislo set idPolSkladPrijem = _idPolSklad where idVyrobniCislo = _vyrobniCislo.idVyrobniCislo; 
          end loop; 
        end if; 
        if(NEW.modul like 'POK') then 
          select typPohybuK into _typPohybuK from dDoklInt where idDoklInt = _idDoklad; 
          if(_typPohybuK like 'typPohybu.prijem') then 
            for _vyrobniCislo in select * from sVyrobniCislo where idPolIntVydej = NEW.idPolInt and (idPolSkladVydej is null or idPolSkladVydej <> _idPolSklad) loop 
              update sVyrobniCislo set idPolSkladVydej = _idPolSklad where idVyrobniCislo = _vyrobniCislo.idVyrobniCislo; 
            end loop; 
          else 
            for _vyrobniCislo in select * from sVyrobniCislo where idPolIntPrijem = NEW.idPolInt and (idPolSkladPrijem is null or idPolSkladPrijem <> _idPolSklad) loop 
              update sVyrobniCislo set idPolSkladPrijem = _idPolSklad where idVyrobniCislo = _vyrobniCislo.idVyrobniCislo; 
            end loop; 
          end if; 
        end if; 
 
      end if; 
      -- prepocteni sum na dokladu 
      select findParovanyDoklSklad(_idDoklad, NEW.modul) into _idDoklSklad; 
      execute sprepoctiSumyDokladu(_idDoklSklad, NEW.datVyst); 
    end if; 
  end if; 
 
  return NEW; 
end 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpoldoklupdatesklad() OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 446, 't', %appVersion%, clock_timestamp());
