------------------------------------------------------------------------------------------------------------------
-- Bug 25546 – [WinStrom] OPrava střediska a činnosti na uložených fakturách se nepromítne do skladových dokladů
------------------------------------------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION fillPolSkladSada(_idpoldokl integer, _modul character varying)
  RETURNS void AS
$BODY$ 
declare 
  _polDokl record; 
  _polSklad record; 
  _idDoklad integer; 
  _typPohybuK character varying; 
  _typPohybuSklad character varying; 
  _cenaMj numeric(19,6); 
  _cenaMjTuz numeric(19,6); 
  _mnozMj numeric(19,6); 
  _sumZkl numeric(19,6); 
  _sumZklMen numeric(19,6); 
  _idDoklSklad integer; 
  _idUcetObdobi integer; 
  _idKarty integer; 
  _sklad record; 
  _kurz numeric(19,6); 
  _prumCenaTuz numeric(19,6); 
  _isCiziMena boolean; 
  _typDoklK character varying; 
  _idZklMdUcet integer; 
  _idZklDalUcet integer; 
  _idStredDoklSklad integer;
  _idCinnostDoklSklad integer;
  _idZakazkyDoklSklad integer;
  _kopStred boolean;
  _kopCinnost boolean;
  _kopZakazku boolean;
begin
  if(_modul like 'POK') then 
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl; 
    select idDoklInt, typPohybuK into _idDoklad, _typPohybuK from dDoklInt where idDoklInt = _polDokl.idDoklInt; 
    _typDoklK = null; -- pro pokladnu dobropisy nejsou 
  else 
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl; 
    select idDoklFak, typPohybuK into _idDoklad, _typPohybuK from dDoklFak where idDoklFak = _polDokl.idDoklFak; 
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak); 
  end if; 

  select findparovanydoklsklad(_iddoklad, _modul, 'typVazbyDokl.hlavaSkl', true) into _idDoklSklad; 
  if(_idDoklSklad is null) then 
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad; 
  end if; 

  for _polSklad in  
    select * from dPolSklad where idPolSklad in ( 
      select idTabB from dvazebtab where 
        typVazbyK like 'typVazbyDokl.polozkaSklSada'  
        and idTabA = _idPolDokl and modulA = _modul and modulB = 'SKL' 
    ) 
  loop 
    select typPohybuK, idStred, idCinnost, idZakazky
      into _typPohybuSklad, _idStredDoklSklad, _idCinnostDoklSklad, _idZakazkyDoklSklad
      from dDoklSklad where idDoklSklad = _polSklad.idDoklSklad;
 
    select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi; 
    select idkarty into _idkarty from skarty where idcenik = _polDokl.idcenik and idskladu = _polDokl.idbspskl and iducetobdobi = _iducetobdobi; 
    select * into _sklad from dBsp where idBsp = _polDokl.idBspSkl; 
   
    select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz; 
    select prumCenaTuz into _prumCenaTuz from sKarty where idKarty = _idKarty; 
    select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena; 
 
    -- pokud vydavam ze skladu tak ma byt pouzita prumerna cena 
    _cenaMj = _polSklad.cenaMj; 
    _mnozMj = _polSklad.mnozMj; 
    _sumZkl = _polSklad.sumZkl; 
    _sumZklMen = _polSklad.sumZklMen; 
    -- nastaveni uctu pro polSklad vydej 
    --TODO doresit zklMdUcet;
    --select findZklMdUcetIfVydej(_idPolDokl, _modul) into _idZklMdUcet; 
    _idZklDalUcet = _sklad.idPrimUcet; 
   
    _kopStred = _polSklad.kopStred;
    if(not compareId(_idStredDoklSklad, _polDokl.idStred)) then
      _kopStred = false;
    end if;
    _kopCinnost = _polSklad.kopCinnost;
    if(not compareId(_idCinnostDoklSklad, _polDokl.idCinnost)) then
      _kopCinnost = false;
    end if;
    _kopZakazku = _polSklad.kopZakazku;
    if(not compareId(_idZakazkyDoklSklad, _polDokl.idZakazky)) then
      _kopZakazku = false;
    end if;

    update dPolSklad set  
      lastUpdate = LOCALTIMESTAMP,  
      cenaMj = _cenaMj,  
      mnozMj = _mnozMj,  
      sumZkl = _sumZkl,  
      sumZklMen = _sumZklMen,  
      --nazev = _polDokl.nazev,  
      --nazevA = _polDokl.nazevA,  
      --nazevB = _polDokl.nazevB,  
      --nazevC = _polDokl.nazevC,  
      datVyst = _polDokl.datVyst,  
      datUcto = _polDokl.datVyst,
      baleniId = _polDokl.baleniId,  
      mnozBaleni = _polDokl.mnozBaleni,  
      --sarze = _polDokl.sarze,  
      --expirace = _polDokl.expirace,  
      --cisRad = _polDokl.cisRad,  
      --eankod = _polDokl.eanKod,  
      --idmj = _polDokl.idmj,  
      idStred = _polDokl.idStred,  
      kopStred = _kopStred,
      idCinnost = _polDokl.idCinnost,
      kopCinnost = _kopCinnost,   
      idMeny = _polSklad.idMeny,  
      idZakazky = _polDokl.idZakazky,  
      kopZakazku = _kopZakazku,   
      --idZklMdUcet = _idZklMdUcet,  
      --idZklDalUcet = _idZklDalUcet,
      ucetni = true 
      where idPolSklad = _polSklad.idPolSklad; 
  end loop;
  --return _idPolSklad; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION fillpolskladsada(integer, character varying) OWNER TO %firmaRole%;




CREATE OR REPLACE FUNCTION fillPolSklad(_idPolSklad integer, _idPolDokl integer, _modul character varying) RETURNS integer AS
$BODY$
declare
  _polDokl record;
  _polSklad record;
  _idDoklad integer;
  _typPohybuK character varying;
  _typPohybuSklad character varying;
  _cenaMj numeric(19,6);
  _cenaMjPoriz numeric(19,6);
  _cenaMjTuz numeric(19,6);
  _mnozMj numeric(19,6);
  _sumZkl numeric(19,6);
  _sumZklMen numeric(19,6);
  _idDoklSklad integer;
  _idUcetObdobi integer;
  _idKarty integer;
  _sklad record;
  _kurz numeric(19,6);
  _prumCenaTuz numeric(19,6);
  _isCiziMena boolean;
  _typDoklK character varying;
  _idZklMdUcet integer;
  _idZklDalUcet integer;
  _idStredDoklSklad integer;
  _idCinnostDoklSklad integer;
  _idZakazkyDoklSklad integer;
  _kopStred boolean;
  _kopCinnost boolean;
  _kopZakazku boolean;
begin
  if(_modul like 'POK') then
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl;
    select idDoklInt, typPohybuK into _idDoklad, _typPohybuK from dDoklInt where idDoklInt = _polDokl.idDoklInt;
    _typDoklK = null; -- pro pokladnu dobropisy nejsou
  else
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl;
    select idDoklFak, typPohybuK into _idDoklad, _typPohybuK from dDoklFak where idDoklFak = _polDokl.idDoklFak;
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak);
  end if;

  select findparovanydoklsklad(_iddoklad, _modul, 'typVazbyDokl.hlavaSkl', true) into _idDoklSklad;
  
  if(_idDoklSklad is null) then
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad;
  end if;

  select * into _polSklad from dPolSklad where idPolSklad = _idPolSklad;
  select typPohybuK, idStred, idCinnost, idZakazky 
    into _typPohybuSklad, _idStredDoklSklad, _idCinnostDoklSklad, _idZakazkyDoklSklad
    from dDoklSklad where idDoklSklad = _polSklad.idDoklSklad; 

  select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi;
  select idkarty into _idkarty from skarty where idcenik = _polDokl.idcenik and idskladu = _polDokl.idbspskl and iducetobdobi = _iducetobdobi;
  select * into _sklad from dBsp where idBsp = _polDokl.idBspSkl;
  
  select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz;
  select prumCenaTuz into _prumCenaTuz from sKarty where idKarty = _idKarty;
  select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena;

  if(_typPohybuSklad like 'typPohybu.vydej') then
    -- vsechny dobropisy generuji prijemky
    --if(_typDoklK like 'typDokladu.dobropis') then
    --  _mnozMj = -_polDokl.mnozMj;
    --else
      _mnozMj = _polDokl.mnozMj;
    --end if;
    -- pokud vydavam ze skladu tak ma byt pouzita prumerna cena
    _cenaMj = _polSklad.cenaMj;
    _cenaMjPoriz = _polSklad.cenaMjPoriz;
    _sumZkl = _polSklad.sumZkl;
    _sumZklMen = _polSklad.sumZklMen;
    -- nastaveni uctu pro polSklad vydej
    select findZklMdUcetIfVydej(_idPolDokl, _modul) into _idZklMdUcet;
    _idZklDalUcet = _sklad.idPrimUcet;
  else
    if(_typDoklK like 'typDokladu.dobropis' and _modul like 'FAV') then
      -- pokud se jedna o dobropis tak doplnuji nakupni ceny;
      _mnozMj = -_polDokl.mnozMj;
      _cenaMjTuz = _polDokl.cenaMjNakup; 
      if(_cenaMjTuz = 0.0) then
        _cenaMjTuz = (select nakupCena from ccenik where idCenik = _polDokl.idCenik);
        if(_cenaMj = 0.0) then
          _cenaMj = _polDokl.cenaMj * _kurz;
        end if;
      end if;
      _cenaMjPoriz = _cenaMjTuz / _kurz;
      _cenaMj = _polSklad.cenaMjNakl + _cenaMjPoriz;
      _sumZkl = _mnozMj * (_cenaMjTuz + (_polSklad.cenaMjNakl * _kurz));
      if(_isCiziMena) then
        _sumZklMen = _mnozMj * _cenaMj;
      else
        _sumZklMen = 0.0;
      end if;
    else
      -- pokud na sklad prijmam zkopiruji se ceny z faktury
      _mnozMj = _polDokl.mnozMj;
      _sumZkl = _polDokl.sumZkl;
      if(_mnozMj <> 0.0) then
        _cenaMjPoriz = _sumZkl / _mnozMj;
      else
        _cenaMjPoriz = _sumZkl;
      end if;
      _cenaMjPoriz = _cenaMjPoriz / _kurz;
      if(_isCiziMena) then
        if(_mnozMj <> 0.0) then
          _sumZklMen = (_cenaMjPoriz + _polSklad.cenaMjNakl) * _mnozMj;
        else
          _sumZklMen = (_cenaMjPoriz + _polSklad.cenaMjNakl);
        end if;
      else
        _sumZklMen = 0.0;  
      end if;
      _sumZkl = _sumZkl + (_polSklad.cenaMjNakl * _kurz * _mnozMj);
      _cenaMj = _cenaMjPoriz + _polSklad.cenaMjNakl;
    end if;
    -- nastaveni uctu pro polSklad prijem
    _idZklMdUcet = _sklad.idPrimUcet;
    _idZklDalUcet = _polDokl.idZklMdUcet;
  end if;

  if(_polSklad.cenaMj <> _cenaMj
    or _polSklad.cenaMjPoriz <> _cenaMjPoriz
    or _polSklad.sumZkl <> _sumZkl
    or _polSklad.sumZklMen <> _sumZklMen
    or not compareVarchar(_polSklad.nazev, _polDokl.nazev)
    or not compareVarchar(_polSklad.nazevA, _polDokl.nazevA)
    or not compareVarchar(_polSklad.nazevB, _polDokl.nazevB)
    or not compareVarchar(_polSklad.nazevC, _polDokl.nazevC)
    or not compareDate(_polSklad.datVyst, _polDokl.datVyst)
    or not compareDate(_polSklad.datUcto, _polDokl.datVyst)
    or not compareId(_polSklad.baleniId, _polDokl.baleniId)
    or not compareNumeric(_polSklad.mnozBaleni, _polDokl.mnozBaleni)
    or not compareVarchar(_polSklad.sarze, _polDokl.sarze)
    or not compareDate(_polSklad.expirace, _polDokl.expirace)
    or not compareId(_polSklad.cisRad, _polDokl.cisRad)
    or not compareVarchar(_polSklad.eankod, _polDokl.eanKod)
    or not compareId(_polSklad.idmj, _polDokl.idmj)
    or not compareId(_polSklad.idStred, _polDokl.idStred)
    or not compareId(_polSklad.idCinnost, _polDokl.idCinnost)
    or not compareId(_polSklad.idZakazky, _polDokl.idZakazky)
    or not compareId(_polSklad.idZklMdUcet, _idZklMdUcet)
    or not compareId(_polSklad.idZklDalUcet, _idZklDalUcet) )
  then
    _kopStred = _polSklad.kopStred;
    if(not compareId(_idStredDoklSklad, _polDokl.idStred)) then
      _kopStred = false;
    end if;
    _kopCinnost = _polSklad.kopCinnost;
    if(not compareId(_idCinnostDoklSklad, _polDokl.idCinnost)) then
      _kopCinnost = false;
    end if;
    _kopZakazku = _polSklad.kopZakazku;
    if(not compareId(_idZakazkyDoklSklad, _polDokl.idZakazky)) then
      _kopZakazku = false;
    end if;

    update dPolSklad set
      lastUpdate = LOCALTIMESTAMP,
      cenaMj = _cenaMj,
      cenaMjPoriz = _cenaMjPoriz,
      --mnozMj = _mnozMj,
      sumZkl = _sumZkl,
      sumZklMen = _sumZklMen,
      nazev = _polDokl.nazev,
      nazevA = _polDokl.nazevA,
      nazevB = _polDokl.nazevB,
      nazevC = _polDokl.nazevC,
      datVyst = _polDokl.datVyst,
      datUcto = _polDokl.datVyst,
      baleniId = _polDokl.baleniId,
      mnozBaleni = _polDokl.mnozBaleni,
      sarze = _polDokl.sarze,
      expirace = _polDokl.expirace,
      cisRad = _polDokl.cisRad,
      eankod = _polDokl.eanKod,
      idmj = _polDokl.idmj,
      idStred = _polDokl.idStred,
      kopStred = _kopStred,
      idCinnost = _polDokl.idCinnost,
      kopCinnost = _kopCinnost,
      idMeny = _polSklad.idMeny,
      idZakazky = _polDokl.idZakazky,
      kopZakazku = _kopZakazku, 
      --idZklMdUcet = _idZklMdUcet,
      --idZklDalUcet = _idZklDalUcet,
      ucetni = true
      where idPolSklad = _idPolSklad;
  end if;

  return _idPolSklad;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION fillPolSklad(integer, integer, character varying) OWNER TO %firmaRole%;




CREATE OR REPLACE FUNCTION createPolSkladSada(_idPolDokl integer, _modul character varying)
  RETURNS void AS
$BODY$ 
declare
  _polDokl record;
  _doklad record;
  _polozkaSady record;
  _skladKarta record;
  _cenik record;
  _sklad record;
  _idDoklSklad integer;
  _idDoklad integer;
  _idMeny integer;
  _idUcetObdobi integer;
  _idKarty integer;
  _idPolSklad integer;
  _idZklMdUcet integer;
  _idZklDalUcet integer;
  _i integer;
  _cisRad integer;
  _typDoklK character varying;
  _mnozMj numeric(19,6);
  _sumZkl numeric(19,6);
  _sumZklMen numeric(19,6);
  _cenaMj numeric(19,6);
  _kurz numeric(19,6);
  _isCiziMena boolean;
  _nasobic integer;
  _idSkladu integer;
  _kopZklMdUcet boolean;
  _kopZklDalUcet boolean;
  _idTypUcOp integer;
  _datSklad date;
  _kopStred boolean;
  _kopCinnost boolean;
  _kopZakazku boolean;
  _idStredDoklSklad integer;
  _idCinnostDoklSklad integer;
  _idZakazkyDoklSklad integer;
begin

  if(_modul like 'FAV' or _modul like 'FAP') then 
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl; 
    _idDoklad = _polDokl.idDoklFak;
    select * into _doklad from dDoklFak where idDoklFak = _idDoklad;
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak); 
  else 
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl; 
    _idDoklad = _polDokl.idDoklInt;
    select * into _doklad from dDoklInt where idDoklInt = _idDoklad;
    _typDoklK = null; -- pro pokladnu dobropisy nejsou 
  end if;

  select findparovanydoklsklad(_iddoklad, _modul, 'typVazbyDokl.hlavaSkl', true) into _idDoklSklad; 
  
  if(_idDoklSklad is null) then 
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad; 
    if(_idDoklSklad is null) then
      return;
    end if;
  end if;

  select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz;
  select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena; 

  select idMeny, idTypUcOp, idstred, idcinnost, datSklad, idZakazky
   into _idMeny, _idTypUcOp, _idStredDoklSklad, _idCinnostDoklSklad, _datSklad, _idZakazkyDoklSklad 
   from dDoklSklad where idDoklSklad = _idDoklSklad; 

  select * into _sklad from dBsp where idBsp = _polDokl.idBspSkl;

  _i = 0;

  FOR _polozkaSady IN
    select * from cSady where idCenikSada = _polDokl.idCenik
  LOOP
    select * into _cenik from cCenik where idCenik = _polozkaSady.idCenik;

    if(_cenik.skladove) then
      _i = _i + 1;
      _cisRad = 100 * _polDokl.cisRad + _i;
  
      select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi; 

      _idSkladu = _polDokl.idBspSkl;

      select * into _skladKarta from skarty 
        where idSkladu = _idSkladu and idCenik = _polozkaSady.idCenik and idUcetObdobi = _idUcetObdobi;

      -- pokud neexistuje skladova karta pokusim se ji najit pomoci mapovani skladu
      if(_skladKarta is null) then
        select getPrefIdSkladu(_polDokl.idStred, _cenik.idSkupZboz, _cenik.idCenik) into _idSkladu;
        select * into _skladKarta from skarty
          where idSkladu = _idSkladu and idCenik = _cenik.idCenik and idUcetObdobi = _idUcetObdobi;
        if(_skladKarta is null) then
          -- pokud ani podle mapovani skladu se skladova karta nenajde tak vyhazuju vyjimku
          raise exception '0007:Skladová karta neexistuje pro ceník % a sklad % a nebo je špatně nastaveno mapovaní skladu.', _cenik.nazev, _sklad.nazev;
        end if;
      else
        _idSkladu = _skladKarta.idSkladu;
      end if;
      _nasobic = 1;
      if(_typDoklK like 'typDokladu.dobropis') then
        _nasobic = -1;
      end if;
      _mnozMj = _polozkaSady.mnozMj * _polDokl.mnozMj * _nasobic;
      _cenaMj = _skladKarta.prumCenaTuz / _kurz;
      _sumZkl = _mnozMj * _skladKarta.prumCenaTuz;
      if(_isCiziMena) then 
        _sumZklMen = _mnozMj * _cenaMj; 
      else 
        _sumZklMen = 0.0; 
      end if;
    
      -- nastaveni uctu pro polSklad vydej 
      _kopZklMdUcet = false;
      _kopZklDalUcet = false;
      if(_typDoklK like 'typDokladu.dobropis') then
        -- dal ucet je ze skupiny zbozi nebo z hlavicky pokud neni ve skupine zbozi nastaven
        select idProtiUcetSklV into _idZklDalUcet from cSkupZboz where idSkupZboz = _cenik.idSkupZboz;
        if(_idZklDalUcet is null) then
          select idProtiUcet into _idZklDalUcet from dDoklSklad where idDoklSklad = _idDoklSklad;
          --pokud je z hlavicky tak se bude kopirovat
          _kopZklDalUcet = true;
        end if;
        -- md ucet musi byt primarni ucet skladu ze ktereho se kousky sady vydavaji
        select idPrimUcet into _idZklMdUcet from dBsp where idBsp = _idSkladu;
      else
        -- md ucet je ze skupiny zbozi nebo z hlavicky pokud neni ve skupine zbozi nastaven
        select idProtiUcetSklV into _idZklMdUcet from cSkupZboz where idSkupZboz = _cenik.idSkupZboz;
        if(_idZklMdUcet is null) then
          select idProtiUcet into _idZklMdUcet from dDoklSklad where idDoklSklad = _idDoklSklad;
          --pokud je z hlavicky tak se bude kopirovat
          _kopZklMdUcet = true;
        end if;
        -- dal ucet musi byt primarni ucet skladu ze ktereho se kousky sady vydavaji
        select idPrimUcet into _idZklDalUcet from dBsp where idBsp = _idSkladu;
      end if; 
 
      _kopStred = true;
      if(not compareId(_idStredDoklSklad, _polDokl.idStred)) then
        _kopStred = false;
      end if;
      _kopCinnost = true;
      if(not compareId(_idCinnostDoklSklad, _polDokl.idCinnost)) then
        _kopCinnost = false;
      end if;
      _kopZakazku = true;
      if(not compareId(_idZakazkyDoklSklad, _polDokl.idZakazky)) then
        _kopZakazku = false;
      end if;

      select nextval('seq_dpolsklad') into _idPolSklad;
      insert into dpolsklad(idPolSklad, lastUpdate, idcenik, idBspSkl, idkarty, datVyst, datSklad, datUcto, modul, typPolozkyK, idDoklSklad,
          mnozMj, cenaMj, cenaMjPoriz, sumZkl, sumZklMen, idZklMdUcet, idZklDalUcet, kopZklMdUcet, kopZklDalUcet, baleniid, mnozBaleni, idmj,
          nazev, nazevA, nazevB, nazevC, sarze, expirace, cisRad, ucetni,  
          idStred, kopStred, idZakazky, kopZakazku, idMeny, zdrojProFak, idCinnost, kopCinnost, idTypUcOp)
        values (_idPolSklad, LOCALTIMESTAMP, _polozkaSady.idcenik, _idSkladu, _skladKarta.idKarty, _polDokl.datVyst, _datSklad, _polDokl.datVyst, 'SKL', 'typPolozky.katalog', _idDoklSklad,    
          _mnozMj, _cenaMj, _cenaMj, _sumZkl, _sumZklMen, _idZklMdUcet, _idZklDalUcet, _kopZklMdUcet, _kopZklDalUcet, _polDokl.baleniid, 0.0, _cenik.idmj1,
          _cenik.nazev, _cenik.nazevA, _cenik.nazevB, _cenik.nazevC, null, null, _cisRad, true,  
          _polDokl.idStred, _kopStred, _polDokl.idZakazky, _kopZakazku, _idMeny, false, _polDokl.idCinnost, _kopCinnost, _idTypUcOp);

      insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK)  
        values (0.0, _idPolDokl, _idPolSklad, _modul, 'SKL', false, 'typVazbyDokl.polozkaSklSada');  
    end if; 
  END LOOP; 

  execute sprepoctiSumyDokladu(_idDoklSklad); 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION createPolSkladSada(integer, character varying) OWNER TO %firmaRole%;




--drop function createPolSklad(integer, character varying);

CREATE OR REPLACE FUNCTION createPolSklad(_idPolDokl integer, _modul character varying) RETURNS integer AS
$BODY$
declare
  _idDoklSklad integer;
  _idDoklad integer;
  _polDokl record;
  _iducetobdobi integer;
  _idkarty integer;
  _idPolSklad integer;
  _cenaMj numeric(19,6);
  _cenaMjTuz numeric(19,6);
  _typPohybuK character varying;
  _prumCenaTuz numeric(19,6);
  _sumZkl numeric(19,6);
  _sumZklMen numeric(19,6);
  _kurz numeric(19,6);
  _idZklMdUcet integer;
  _idZklDalUcet integer;
  _kopZklMdUcet boolean;
  _kopZklDalUcet boolean;
  _sklad record;
  _typDoklK character varying;
  _mnozMj numeric(19,6);
  _isCiziMena boolean;
  _idMeny integer;  
  _skupZboz record;
  _idTypUcOp integer;
  _datSklad date;
  _kopStred boolean;
  _kopCinnost boolean;
  _kopZakazku boolean;
  _idStredDoklSklad integer;
  _idCinnostDoklSklad integer;
  _idZakazkyDoklSklad integer;
begin
  _kopZklMdUcet =false;
  _kopZklDalUcet = false;
  if(_modul like 'FAV' or _modul like 'FAP') then
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl;
    _idDoklad = _polDokl.idDoklFak;
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak);
  else
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl;
    _idDoklad = _polDokl.idDoklInt;
    _typDoklK = null; -- pro pokladnu dobropisy nejsou
  end if;

  select findparovanydoklsklad(_iddoklad, _modul, 'typVazbyDokl.hlavaSkl', true) into _idDoklSklad; 
  
  if(_idDoklSklad is null) then
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad;
    if(_idDoklSklad is null) then
      return null;
    end if;
  end if;

  select datSklad into _datSklad from ddoklSklad where idDoklSklad = _idDoklSklad;
  select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi;
  select idkarty into _idkarty from skarty where idcenik = _polDokl.idcenik and idskladu = _polDokl.idbspskl and iducetobdobi = _iducetobdobi;
  select * into _sklad from dBsp where idBsp = _polDokl.idBspSkl;
  
  select typPohybuK, idstred, idcinnost, idZakazky
    into _typPohybuK, _idStredDoklSklad, _idCinnostDoklSklad, _idZakazkyDoklSklad
    from dDoklSklad where idDoklSklad = _idDoklSklad; 
  select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz;
  select prumCenaTuz into _prumCenaTuz from sKarty where idKarty = _idKarty;
  select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena;
  select idMeny, idTypUcOp into _idMeny, _idTypUcOp from dDoklSklad where idDoklSklad = _idDoklSklad;
      
  if(_typPohybuK like 'typPohybu.vydej') then
    -- vsechny dobropisy generuji prijemky
    --if(_typDoklK like 'typDokladu.dobropis') then
    --  _mnozMj = -_polDokl.mnozMj;
    --else
      _mnozMj = _polDokl.mnozMj;
    --end if;
    -- pokud vydavam ze skladu tak ma byt pouzita prumerna cena
    _cenaMj = _prumCenaTuz / _kurz;
    _sumZkl = _prumCenaTuz * _mnozMj;
    if(_isCiziMena) then
      _sumZklMen = _mnozMj * _cenaMj;
    else
      _sumZklMen = 0.0;
    end if;
    -- nastaveni uctu pro polSklad vydej
    select * into _skupZboz from cskupzboz where idskupzboz = (select idskupzboz from ccenik where idcenik = _polDokl.idCenik);
    if(_skupZboz.idProtiUcetSklV is not null) then
      -- pokud je ve skupine zbozi nastaven protiucet pro vydej ze skladu pouzije se ten a kopirovani se necha na false;
      _idZklMdUcet = _skupZboz.idProtiUcetSklV;
    else
      -- pokud neni ve skupine zbozi nastaven protiucet tak vemu protiucet z hlavicky a dam kopirovat na true
      select idProtiUcet into _idZklMdUcet from dDoklSklad where idDoklSklad = _idDoklSklad;
      _kopZklMdUcet = true;
    end if;
    _idZklDalUcet = _sklad.idPrimUcet;
  else
    if(_typDoklK like 'typDokladu.dobropis' and _modul like 'FAV') then
      -- pokud se jedna o dobropis tak doplnuji nakupni ceny;
      _mnozMj = -_polDokl.mnozMj;
      --_cenaMjTuz = _prumCenaTuz;
      _cenaMjTuz = _polDokl.cenaMjNakup;
      if(_cenaMjTuz = 0.0) then
        _cenaMjTuz = (select nakupCena from ccenik where idCenik = _polDokl.idCenik);
        if(_cenaMj = 0.0) then
          _cenaMj = _polDokl.cenaMj * _kurz;
        end if;
      end if;
      _cenaMj = _cenaMjTuz / _kurz;
      _sumZkl = _mnozMj * _cenaMjTuz;
      if(_isCiziMena) then
        _sumZklMen = _mnozMj * _cenaMj;
      else
        _sumZklMen = 0.0;
      end if;
      select * into _skupZboz from cskupzboz where idskupzboz = (select idskupzboz from ccenik where idcenik = _polDokl.idCenik);
      if(_skupZboz.idProtiUcetSklV is not null) then
        -- pokud je ve skupine zbozi nastaven protiucet pro vydej ze skladu pouzije se ten a kopirovani se necha na false;
        _idZklDalUcet = _skupZboz.idProtiUcetSklV;
      else
        -- pokud neni ve skupine zbozi nastaven protiucet tak vemu protiucet z hlavicky a dam kopirovat na true
        select idProtiUcet into _idZklDalUcet from dDoklSklad where idDoklSklad = _idDoklSklad;
        _kopZklDalUcet = true;
      end if;
    else
      -- pokud na sklad prijmam zkopiruji se ceny z faktury
      _mnozMj = _polDokl.mnozMj;
      _sumZkl = _polDokl.sumZkl;
      if(_mnozMj <> 0.0) then
        _cenaMj = _sumZkl / _mnozMj;
      else
        _cenaMj = _sumZkl;
      end if;
      _cenaMj = _cenaMj / _kurz;
      if(_isCiziMena) then
        if(_mnozMj <> 0.0) then
          _sumZklMen = _cenaMj * _mnozMj;  
        else
          _sumZklMen = _cenaMj;
        end if;
      else
        _sumZklMen = 0.0;  
      end if;
      _idZklDalUcet = _polDokl.idZklMdUcet;
    end if;
    -- nastaveni uctu pro polSklad prijem
    _idZklMdUcet = _sklad.idPrimUcet;
  end if; 

  _kopStred = true;
  if(not compareId(_idStredDoklSklad, _polDokl.idStred)) then
    _kopStred = false;
  end if;
  _kopCinnost = true;
  if(not compareId(_idCinnostDoklSklad, _polDokl.idCinnost)) then
    _kopCinnost = false;
  end if;
  _kopZakazku = true;
  if(not compareId(_idZakazkyDoklSklad, _polDokl.idZakazky)) then
    _kopZakazku = false;
  end if;
  
  select nextval('seq_dpolsklad') into _idPolSklad;  
  insert into dpolsklad(idPolSklad, lastUpdate, idcenik, idbspskl, idkarty, datVyst, datSklad, datUcto, modul, typPolozkyK, idDoklSklad,
        mnozMj, cenaMj, cenaMjPoriz, sumZkl, sumZklMen, idZklMdUcet, idZklDalUcet, kopZklMdUcet, kopZklDalUcet, baleniid, mnozBaleni, idmj,
        nazev, nazevA, nazevB, nazevC, sarze, expirace, cisRad, ucetni, 
        idStred, kopStred, idZakazky, kopZakazku, idMeny, zdrojProFak, idCinnost, kopCinnost, idTypUcOp)
      values (_idPolSklad, LOCALTIMESTAMP, _polDokl.idcenik, _polDokl.idbspskl, _idkarty, _polDokl.datVyst, _datSklad, _polDokl.datVyst, 'SKL', 'typPolozky.katalog', _idDoklSklad,
        _mnozMj, _cenaMj, _cenaMj, _sumZkl, _sumZklMen, _idZklMdUcet, _idZklDalUcet, _kopZklMdUcet, _kopZklDalUcet, _polDokl.baleniid, _polDokl.mnozBaleni, _polDokl.idmj,
        _polDokl.nazev, _polDokl.nazevA, _polDokl.nazevB, _polDokl.nazevC, _polDokl.sarze, _polDokl.expirace, _polDokl.cisRad, true, 
        _polDokl.idStred, _kopStred, _polDokl.idZakazky, _kopZakazku, _idMeny, false, _polDokl.idCinnost, _kopCinnost, _idTypUcOp);
 
  insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK)
       values (0.0, _idPolDokl, _idPolSklad, _modul, 'SKL', false, 'typVazbyDokl.polozkaSkl');

  -- prepocteni sum na dokladu
  execute sprepoctiSumyDokladu(_idDoklSklad);

  return _idPolSklad;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION createPolSklad(integer, character varying) OWNER TO %firmaRole%;

create or replace function ddokladupdatesklad() returns trigger as
$BODY$
declare
  _polFak record;
  _idPolSklad integer;
  _idDoklSklad integer;
  _idDoklad integer;
  _doklSklad record;
  _pocetPolozek integer;
  _typZasobyK character varying;
  _skladove boolean;
  _sadaItemCount integer;
begin
  if(OLD.generovatSkl <> NEW.generovatSkl) then
    if(NEW.generovatSkl = false and NEW.zdrojProSkl = true) then
      -- pokud se nema podle noveho nastaveni z typu dokladu generovat skladove doklady
      -- a tento doklad je zdrojovy pro generovani skladovych dokladu tak tyto automaticky
      -- vygenerovane doklady musim smazat

      -- nejdriv smazeme polozky navazanych dokladu
      _idDoklad = null;
      if(NEW.modul = 'FAV' or NEW.modul = 'FAP') then
        _idDoklad = NEW.idDoklFak;
        for _polFak in select * from dPolFak where idDoklFak = NEW.idDoklFak loop
          execute deleteNavazanePolSklad(_polFak.idPolFak, _polFak.modul, OLD.generovatSkl);
        end loop;
      elsif(NEW.modul = 'POK') then
        _idDoklad = NEW.idDoklInt;
        for _polFak in select * from dPolInt where idDoklInt = NEW.idDoklInt loop
          execute deleteNavazanePolSklad(_polFak.idPolInt, _polFak.modul, OLD.generovatSkl);
        end loop;
      end if;

      if(_idDoklad is not null) then
        for _idDoklSklad in select idTabB from dVazebTab where idTabA = _idDoklad and modulA = NEW.modul and modulB = 'SKL' and (typVazbyK = 'typVazbyDokl.hlavaSkl') loop
          select * into _doklSklad from dDoklSklad where idDoklSklad = _idDoklSklad;
          select count(idPolSklad) into _pocetPolozek from dPolSklad where idDoklSklad = _idDoklSklad;
          -- smazeme pouze takove doklady, ktere maji pocet polozek = 0 nejsou zdrojove pro generovani faktur
          if(_doklSklad.zdrojProFak = false and _pocetPolozek = 0) then
            delete from dvazebtab where idTabA = _idDoklad and modulA = NEW.modul and idTabB = _idDoklSklad and modulB = 'SKL' and typVazbyK = 'typVazbyDokl.hlavaSkl';
            delete from dDoklSklad where idDoklSklad = _idDoklSklad;
          end if;
        end loop;
      end if;
    elsif (NEW.generovatSkl = true and NEW.zdrojProSkl = true) then
      -- bylo false a nastavi se true tak musime zajistit vygenerovani skladoveho dokladu k polozkam, ktere nejste nejsou vyskladneny
      if(NEW.modul = 'FAV' or NEW.modul = 'FAP') then
        for _polFak in select * from dPolFak where idDoklFak = NEW.idDoklFak loop
          if(_polFak.typPolozkyK like 'typPolozky.katalog' and _polFak.zdrojProSkl) then
            select skladove into _skladove from cCenik where idCenik = _polFak.idCenik;
            if (_skladove and _polFak.idBspSkl is not null) then
              select findParovanyPolSklad(_polFak.idPolFak, NEW.modul) into _idPolSklad;
              if(_idPolSklad is null) then
                select count(*) into _sadaItemCount from csady where idceniksada = _polFak.idCenik;
                if(_sadaItemCount > 0) then
                  execute createPolSkladSada(_polFak.idPolFak, NEW.modul);
                else
                  select createPolSklad(_polFak.idPolFak, NEW.modul) into _idPolSklad;
                end if;
              else
                -- nejspis nebudeme delat nic
              end if;
            end if;
          end if;
        end loop;
      elsif (NEW.modul = 'POK') then
        for _polFak in select * from dPolInt where idDoklInt = NEW.idDoklInt loop
          if(_polFak.typPolozkyK like 'typPolozky.katalog' and _polFak.zdrojProSkl) then
            select skladove into _skladove from cCenik where idCenik = _polFak.idCenik;
            if (_skladove and _polFak.idBspSkl is not null) then
              select findParovanyPolSklad(_polFak.idPolInt, NEW.modul) into _idPolSklad;
              if(_idPolSklad is null) then
                select count(*) into _sadaItemCount from csady where idceniksada = _polFak.idCenik;
                if(_sadaItemCount > 0) then
                  execute createPolSkladSada(_polFak.idPolInt, NEW.modul);
                else
                  select createPolSklad(_polFak.idPolInt, NEW.modul) into _idPolSklad;
                end if;
              else
                -- nejspis nebudeme delat nic
              end if;
            end if;
          end if;
        end loop;
      end if;
    else
    end if;
  end if;

  if(OLD.idtypdoklskl is null and NEW.idtypdoklskl is not null) then
    if (NEW.generovatSkl = true and NEW.zdrojProSkl = true) then
      -- bylo false a nastavi se true tak musime zajistit vygenerovani skladoveho dokladu k polozkam, ktere nejste nejsou vyskladneny
      if(NEW.modul = 'FAV' or NEW.modul = 'FAP') then
        for _polFak in select * from dPolFak where idDoklFak = NEW.idDoklFak loop
          if(_polFak.typPolozkyK like 'typPolozky.katalog' and _polFak.zdrojProSkl) then
            select skladove into _skladove from cCenik where idCenik = _polFak.idCenik;
            if (_skladove and _polFak.idBspSkl is not null) then
              select findParovanyPolSklad(_polFak.idPolFak, NEW.modul) into _idPolSklad;
              if(_idPolSklad is null) then
                select count(*) into _sadaItemCount from csady where idceniksada = _polFak.idCenik;
                if(_sadaItemCount > 0) then
                  execute createPolSkladSada(_polFak.idPolFak, NEW.modul);
                else
                  select createPolSklad(_polFak.idPolFak, NEW.modul) into _idPolSklad;
                end if;
              else
                -- nejspis nebudeme delat nic
              end if;
            end if;
          end if;
        end loop;
      elsif (NEW.modul = 'POK') then
        for _polFak in select * from dPolInt where idDoklInt = NEW.idDoklInt loop
          if(_polFak.typPolozkyK like 'typPolozky.katalog' and _polFak.zdrojProSkl) then
            select skladove into _skladove from cCenik where idCenik = _polFak.idCenik;
            if (_skladove and _polFak.idBspSkl is not null) then
              select findParovanyPolSklad(_polFak.idPolInt, NEW.modul) into _idPolSklad;
              if(_idPolSklad is null) then
                select count(*) into _sadaItemCount from csady where idceniksada = _polFak.idCenik;
                if(_sadaItemCount > 0) then
                  execute createPolSkladSada(_polFak.idPolInt, NEW.modul);
                else
                  select createPolSklad(_polFak.idPolInt, NEW.modul) into _idPolSklad;
                end if;
              else
                -- nejspis nebudeme delat nic
              end if;
            end if;
          end if;
        end loop;
      end if;
    else
    end if;
  end if;

  -- propasovani zmen na dokladu faktury do skladoveho dokladu...
  -- napr. zmena firmy, cinnosti...
  if(NEW.generovatSkl = true and NEW.zdrojProSkl = true) then
    if(not compareId(OLD.idFirmy, NEW.idFirmy)
       or not compareVarchar(OLD.nazFirmy, NEW.nazFirmy)
       or not compareVarchar(OLD.ulice, NEW.ulice)
       or not compareVarchar(OLD.mesto, NEW.mesto)
       or not compareVarchar(OLD.psc, NEW.psc)
       or not compareId(OLD.idStatu, NEW.idStatu)
       or not compareVarchar(OLD.ic, NEW.ic)
       or not compareVarchar(OLD.dic, NEW.dic)
       or not compareVarchar(OLD.vatId, NEW.vatId)
       or not compareId(OLD.idMur, NEW.idMur)
       or not compareId(OLD.idKrajUrc, NEW.idKrajUrc)
       or not compareId(OLD.idStatUrc, NEW.idStatUrc)
       or not compareVarchar(OLD.cisObj, NEW.cisObj)
       or not compareVarchar(OLD.doprava, NEW.doprava)
       or not compareId(OLD.idDruhDopr, NEW.idDruhDopr)
       or not compareVarchar(OLD.popis, NEW.popis)
       or not compareVarchar(OLD.poznam, NEW.poznam)
       or not compareId(OLD.idcinnost, NEW.idCinnost)
       or not compareId(OLD.idStred, NEW.idStred)
       or not compareId(OLD.idZakazky, NEW.idZakazky)
       or not compareVarchar(OLD.eanKod, NEW.eanKod)
       or not compareId(OLD.idstatpuvod, NEW.idStatPuvod)
       or not compareId(OLD.idstatodesl, NEW.idStatOdesl) 
       or not compareId(OLD.idKontaktOsoba, NEW.idKontaktOsoba)
       or not compareId(OLD.idZodpOsoba, NEW.idZodpOsoba)
    ) then
      if(NEW.modul = 'FAV' or NEW.modul = 'FAP') then
        _idDoklad = NEW.idDoklFak;
      elsif(NEW.modul = 'POK') then
        _idDoklad = NEW.idDoklInt;
      else
      end if;
    
      for _doklSklad in select * from dvazebtab vt join ddoklsklad ds on vt.idtabb = ds.iddoklsklad 
        where typVazbyK = 'typVazbyDokl.hlavaSkl' and idTabA = _idDoklad and modulA = NEW.modul loop
          update ddoklsklad set
            lastUpdate = LOCALTIMESTAMP,
            idFirmy = NEW.idFirmy,
            nazFirmy = NEW.nazFirmy,
            ulice = NEW.ulice,
            mesto = NEW.mesto,
            psc = NEW.psc,
            idStatu = NEW.idStatu,
            ic = NEW.ic,
            dic = NEW.dic,
            vatId = NEW.vatId,
            idMur = NEW.idMur,
            idKrajUrc = NEW.idKrajUrc,
            idStatUrc = NEW.idStatUrc,
            cisObj = NEW.cisObj,
            doprava = NEW.doprava,
            idDruhDopr = NEW.idDruhDopr,
            popis = NEW.popis,
            poznam = NEW.poznam,
            idcinnost = NEW.idCinnost,
            idStred = NEW.idStred,
            idZakazky = NEW.idZakazky,
            eanKod = NEW.eanKod,
            idstatpuvod = NEW.idStatPuvod,
            idstatodesl = NEW.idStatOdesl, 
            idKontaktOsoba = NEW.idKontaktOsoba,
            idZodpOsoba = NEW.idZodpOsoba
          where idDoklSklad = _doklSklad.idDoklSklad;
      end loop;
    end if;
  end if;

  return NEW;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION ddokladupdatesklad() OWNER TO %firmaRole%;


--------------------------------------------------------------------------------
-- Bug 24859 – [WinStrom] Mazání výdejky z VF nesmaže vazbu
--------------------------------------------------------------------------------
CREATE OR REPLACE FUNCTION dpoldokldeletesklad() RETURNS trigger AS
$BODY$
declare
  _idPolDokl integer;
  _idDoklad integer;
  _idDoklSklad integer;
  _idPolSklad integer; 
  _pocetPozadavku integer;
  _stavSkladK character varying; 
  _zdrojProFak boolean;
  _pocetPolozek integer;
begin
  if(OLD.modul like 'POK') then
    _idPolDokl = OLD.idPolInt;
    _idDoklad = OLD.idDoklInt;
  elsif(OLD.modul like 'FAP' or OLD.modul like 'FAV') then
    _idPolDokl = OLD.idPolFak;
    _idDoklad = OLD.idDoklFak;
  else
    _idPolDokl = null;
    _idDoklad = null;
  end if;

  _idPolSklad = null;
  _idDoklSklad = null;
  if(_idPolDokl is not null) then
    select findParovanyPolSklad(_idPolDokl, OLD.modul) into _idPolSklad;
    --raise exception 'iddoklsklad neni null ale je %', _idPolSklad; 

    if(_idPolSklad is not null) then
      select idDoklSklad into _idDoklSklad from dPolSklad where idPolSklad = _idPolSklad;
    end if;
  end if;
 
  if(_idPolDokl is not null) then
    execute deleteNavazanePolSklad(_idPolDokl, OLD.modul);
  end if;
 
  if(_idDoklSklad is not null) then
    execute sprepoctiSumyDokladu(_idDoklSklad);

    select stavSkladK, zdrojProFak into _stavSkladK, _zdrojProFak from ddoklsklad where idDoklSklad = _idDoklSklad; 
    select count(*) into _pocetPozadavku from dpolSklad where idDoklSklad = _idDoklSklad and mnozMj = 0.0 and mnozMjPlan != 0.0;
  
    if(_pocetPozadavku = 0) then
      if(compareVarchar(_stavSkladK, 'stavSklad.vygenFaktNeuplny')) then
        update ddoklsklad set stavSkladK = 'stavSklad.vygenFakt' where idDoklSklad = _idDoklSklad;
      end if;
      if(compareVarchar(_stavSkladK, 'stavSklad.vygenPoklNeuplny')) then
        update ddoklsklad set stavSkladK = 'stavSklad.vygenPokl' where idDoklSklad = _idDoklSklad;
      end if;
    end if; 

    if(_zdrojProFak) then
      --select count(*) into _pocetPolozek from dpolsklad where iddoklsklad = _idDoklSklad;
      select count(*) into _pocetPolozek from dpolsklad ps join dvazebtab vt 
        on ps.idpolsklad = vt.idtabb and vt.modulb = 'SKL' and typvazbyk = 'typVazbyDokl.polozkaSkl'
        where ps.iddoklsklad = _idDoklSklad;
      if(compareVarchar(_stavSkladK, 'stavSklad.vyfaktCast')) then
        if(_pocetPolozek > 0) then 
        else
          update ddoklsklad set stavSkladK = null where idDoklSklad = _idDoklSklad; 
        end if;
      end if; 
      if(compareVarchar(_stavSkladK, 'stavSklad.vyfakt')) then 
        if(_pocetPolozek > 0) then 
          update ddoklsklad set stavSkladK = 'stavSklad.vyfaktCast' where idDoklSklad = _idDoklSklad; 
        else
          update ddoklsklad set stavSkladK = null where idDoklSklad = _idDoklSklad; 
        end if;
      end if; 
      if(compareVarchar(_stavSkladK, 'stavSklad.vyfaktHromCast')) then
        if(_pocetPolozek > 0) then 
        else
          update ddoklsklad set stavSkladK = null where idDoklSklad = _idDoklSklad; 
        end if;
      end if; 
      if(compareVarchar(_stavSkladK, 'stavSklad.vyfaktHrom')) then 
        if(_pocetPolozek > 0) then 
          update ddoklsklad set stavSkladK = 'stavSklad.vyfaktHromCast' where idDoklSklad = _idDoklSklad; 
        else
          update ddoklsklad set stavSkladK = null where idDoklSklad = _idDoklSklad; 
        end if;
      end if; 
      if(compareVarchar(_stavSkladK, 'stavSklad.uhrazenCast')) then
        if(_pocetPolozek > 0) then 
        else
          update ddoklsklad set stavSkladK = null where idDoklSklad = _idDoklSklad; 
        end if;
      end if; 
      if(compareVarchar(_stavSkladK, 'stavSklad.uhrazen')) then 
        if(_pocetPolozek > 0) then 
          update ddoklsklad set stavSkladK = 'stavSklad.uhrazenCast' where idDoklSklad = _idDoklSklad; 
        else
          update ddoklsklad set stavSkladK = null where idDoklSklad = _idDoklSklad; 
        end if;
      end if; 
      if(compareVarchar(_stavSkladK, 'stavSklad.uhrazenHromCast')) then
        if(_pocetPolozek > 0) then 
        else
          update ddoklsklad set stavSkladK = null where idDoklSklad = _idDoklSklad; 
        end if;
      end if; 
      if(compareVarchar(_stavSkladK, 'stavSklad.uhrazenHrom')) then 
        if(_pocetPolozek > 0) then 
          update ddoklsklad set stavSkladK = 'stavSklad.uhrazenHromCast' where idDoklSklad = _idDoklSklad; 
        else
          update ddoklsklad set stavSkladK = null where idDoklSklad = _idDoklSklad; 
        end if;
      end if; 

      -- pokud uz neexistuje zadna polozka ktera by byla navazana smazeme i vazbu mezi hlavickama
      if(OLD.modul like 'POK') then
        select count(*) into _pocetPolozek from dpolsklad ps join dvazebtab vt on ps.idpolsklad = vt.idtabb and vt.modulb = 'SKL' and typvazbyk = 'typVazbyDokl.polozkaSkl' 
          join dpolint pf on vt.idtaba = pf.idpolint and vt.modulA = OLD.modul and typvazbyk = 'typVazbyDokl.polozkaSkl'
          where ps.iddoklsklad = _idDoklSklad and pf.iddoklint = _idDoklad; 
      elsif(OLD.modul like 'FAP' or OLD.modul like 'FAV') then
        select count(*) into _pocetPolozek from dpolsklad ps join dvazebtab vt on ps.idpolsklad = vt.idtabb and vt.modulb = 'SKL' and typvazbyk = 'typVazbyDokl.polozkaSkl' 
          join dpolfak pf on vt.idtaba = pf.idpolfak and vt.modulA = OLD.modul and typvazbyk = 'typVazbyDokl.polozkaSkl'
          where ps.iddoklsklad = _idDoklSklad and pf.iddoklfak = _idDoklad; 
      else
        _pocetPolozek = 9999; -- tohle je tady aby se nasledujici delete fakt nepoustel
      end if;
  
      if(_pocetPolozek = 0) then
        delete from dvazebtab where idtaba = _idDoklad and idtabb = _idDoklSklad and typVazbyK = 'typVazbyDokl.hlavaSkl' and modulB = 'SKL' and modulA = OLD.modul;
      end if;
    end if;
  end if;
  
  return OLD;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpoldokldeletesklad() OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 540, 't', %appVersion%, clock_timestamp());
