--------------------------------------------------------------------------------
-- Bug 29948 – [WinStrom] Prepnuti faktury z dobropisu na obycejnou fakturu
--------------------------------------------------------------------------------
create or replace function ddokladupdatesklad() returns trigger as
$BODY$
declare
  _polFak record;
  _idPolSklad integer;
  _idDoklSklad integer;
  _idDoklad integer;
  _doklSklad record;
  _pocetPolozek integer;
  _typZasobyK character varying;
  _skladove boolean;
  _sadaItemCount integer;
  _newDobropis integer;
  _oldDobropis integer;
begin
  if(OLD.generovatSkl = true and NEW.generovatSkl = true and NEW.zdrojProSkl = true and NEW.idTypDokl <> OLD.idTypDokl) then
    select count(*) into _newDobropis from dTypDokl where idTypDokl = NEW.idTypDokl and typDoklK = 'typDokladu.dobropis';
    select count(*) into _oldDobropis from dTypDokl where idTypDokl = OLD.idTypDokl and typDoklK = 'typDokladu.dobropis';
    if(_oldDobropis <> _newDobropis) then
      -- doslo ke zmene z dobropisu na nedobropis nebo naopak -> pregenerovat skladovy doklad
      -- nejprve smazeme doklad kvuli fifu
      _idDoklad = null; 
      if(NEW.modul = 'FAV' or NEW.modul = 'FAP') then 
        _idDoklad = NEW.idDoklFak; 
        for _polFak in select * from dPolFak where idDoklFak = NEW.idDoklFak loop 
          execute deleteNavazanePolSklad(_polFak.idPolFak, _polFak.modul, OLD.generovatSkl); 
        end loop; 
      elsif(NEW.modul = 'POK') then 
        _idDoklad = NEW.idDoklInt; 
        for _polFak in select * from dPolInt where idDoklInt = NEW.idDoklInt loop 
          execute deleteNavazanePolSklad(_polFak.idPolInt, _polFak.modul, OLD.generovatSkl); 
        end loop; 
      end if; 
 
      if(_idDoklad is not null) then 
        for _idDoklSklad in select idTabB from dVazebTab where idTabA = _idDoklad and modulA = NEW.modul and modulB = 'SKL' and (typVazbyK = 'typVazbyDokl.hlavaSkl') loop 
          select * into _doklSklad from dDoklSklad where idDoklSklad = _idDoklSklad; 
          select count(idPolSklad) into _pocetPolozek from dPolSklad where idDoklSklad = _idDoklSklad; 
          -- smazeme pouze takove doklady, ktere maji pocet polozek = 0 nejsou zdrojove pro generovani faktur 
          if(_doklSklad.zdrojProFak = false and _pocetPolozek = 0) then 
            delete from dvazebtab where idTabA = _idDoklad and modulA = NEW.modul and idTabB = _idDoklSklad and modulB = 'SKL' and typVazbyK = 'typVazbyDokl.hlavaSkl'; 
            delete from dDoklSklad where idDoklSklad = _idDoklSklad; 
          end if; 
        end loop; 
      end if; 

      -- pak doklad nagenerujeme znovu
      if(NEW.modul = 'FAV' or NEW.modul = 'FAP') then 
        for _polFak in select * from dPolFak where idDoklFak = NEW.idDoklFak loop 
          if(_polFak.typPolozkyK like 'typPolozky.katalog' and _polFak.zdrojProSkl) then 
            select skladove into _skladove from cCenik where idCenik = _polFak.idCenik; 
            if (_skladove and _polFak.idBspSkl is not null) then 
              select findParovanyPolSklad(_polFak.idPolFak, NEW.modul) into _idPolSklad; 
              if(_idPolSklad is null) then 
                select count(*) into _sadaItemCount from csady where idceniksada = _polFak.idCenik; 
                if(_sadaItemCount > 0) then 
                  execute createPolSkladSada(_polFak.idPolFak, NEW.modul); 
                else 
                  select createPolSklad(_polFak.idPolFak, NEW.modul) into _idPolSklad; 
                end if; 
              else 
                -- nejspis nebudeme delat nic 
              end if; 
            end if; 
          end if; 
        end loop; 
      elsif (NEW.modul = 'POK') then 
        for _polFak in select * from dPolInt where idDoklInt = NEW.idDoklInt loop 
          if(_polFak.typPolozkyK like 'typPolozky.katalog' and _polFak.zdrojProSkl) then 
            select skladove into _skladove from cCenik where idCenik = _polFak.idCenik; 
            if (_skladove and _polFak.idBspSkl is not null) then 
              select findParovanyPolSklad(_polFak.idPolInt, NEW.modul) into _idPolSklad; 
              if(_idPolSklad is null) then 
                select count(*) into _sadaItemCount from csady where idceniksada = _polFak.idCenik; 
                if(_sadaItemCount > 0) then 
                  execute createPolSkladSada(_polFak.idPolInt, NEW.modul); 
                else 
                  select createPolSklad(_polFak.idPolInt, NEW.modul) into _idPolSklad; 
                end if; 
              else 
                -- nejspis nebudeme delat nic 
              end if; 
            end if; 
          end if; 
        end loop; 
      end if;
    end if;
  end if;
    -- end of pregenerovani dobropisu

  if(OLD.generovatSkl <> NEW.generovatSkl) then
    if(NEW.generovatSkl = false and NEW.zdrojProSkl = true) then
      -- pokud se nema podle noveho nastaveni z typu dokladu generovat skladove doklady
      -- a tento doklad je zdrojovy pro generovani skladovych dokladu tak tyto automaticky
      -- vygenerovane doklady musim smazat

      -- nejdriv smazeme polozky navazanych dokladu
      _idDoklad = null;
      if(NEW.modul = 'FAV' or NEW.modul = 'FAP') then
        _idDoklad = NEW.idDoklFak;
        for _polFak in select * from dPolFak where idDoklFak = NEW.idDoklFak loop
          execute deleteNavazanePolSklad(_polFak.idPolFak, _polFak.modul, OLD.generovatSkl);
        end loop;
      elsif(NEW.modul = 'POK') then
        _idDoklad = NEW.idDoklInt;
        for _polFak in select * from dPolInt where idDoklInt = NEW.idDoklInt loop
          execute deleteNavazanePolSklad(_polFak.idPolInt, _polFak.modul, OLD.generovatSkl);
        end loop;
      end if;

      if(_idDoklad is not null) then
        for _idDoklSklad in select idTabB from dVazebTab where idTabA = _idDoklad and modulA = NEW.modul and modulB = 'SKL' and (typVazbyK = 'typVazbyDokl.hlavaSkl') loop
          select * into _doklSklad from dDoklSklad where idDoklSklad = _idDoklSklad;
          select count(idPolSklad) into _pocetPolozek from dPolSklad where idDoklSklad = _idDoklSklad;
          -- smazeme pouze takove doklady, ktere maji pocet polozek = 0 nejsou zdrojove pro generovani faktur
          if(_doklSklad.zdrojProFak = false and _pocetPolozek = 0) then
            delete from dvazebtab where idTabA = _idDoklad and modulA = NEW.modul and idTabB = _idDoklSklad and modulB = 'SKL' and typVazbyK = 'typVazbyDokl.hlavaSkl';
            delete from dDoklSklad where idDoklSklad = _idDoklSklad;
          end if;
        end loop;
      end if;
    elsif (NEW.generovatSkl = true and NEW.zdrojProSkl = true) then
      -- bylo false a nastavi se true tak musime zajistit vygenerovani skladoveho dokladu k polozkam, ktere nejste nejsou vyskladneny
      if(NEW.modul = 'FAV' or NEW.modul = 'FAP') then
        for _polFak in select * from dPolFak where idDoklFak = NEW.idDoklFak loop
          if(_polFak.typPolozkyK like 'typPolozky.katalog' and _polFak.zdrojProSkl) then
            select skladove into _skladove from cCenik where idCenik = _polFak.idCenik;
            if (_skladove and _polFak.idBspSkl is not null) then
              select findParovanyPolSklad(_polFak.idPolFak, NEW.modul) into _idPolSklad;
              if(_idPolSklad is null) then
                select count(*) into _sadaItemCount from csady where idceniksada = _polFak.idCenik;
                if(_sadaItemCount > 0) then
                  execute createPolSkladSada(_polFak.idPolFak, NEW.modul);
                else
                  select createPolSklad(_polFak.idPolFak, NEW.modul) into _idPolSklad;
                end if;
              else
                -- nejspis nebudeme delat nic
              end if;
            end if;
          end if;
        end loop;
      elsif (NEW.modul = 'POK') then
        for _polFak in select * from dPolInt where idDoklInt = NEW.idDoklInt loop
          if(_polFak.typPolozkyK like 'typPolozky.katalog' and _polFak.zdrojProSkl) then
            select skladove into _skladove from cCenik where idCenik = _polFak.idCenik;
            if (_skladove and _polFak.idBspSkl is not null) then
              select findParovanyPolSklad(_polFak.idPolInt, NEW.modul) into _idPolSklad;
              if(_idPolSklad is null) then
                select count(*) into _sadaItemCount from csady where idceniksada = _polFak.idCenik;
                if(_sadaItemCount > 0) then
                  execute createPolSkladSada(_polFak.idPolInt, NEW.modul);
                else
                  select createPolSklad(_polFak.idPolInt, NEW.modul) into _idPolSklad;
                end if;
              else
                -- nejspis nebudeme delat nic
              end if;
            end if;
          end if;
        end loop;
      end if;
    else
    end if;
  end if;

  if(OLD.idtypdoklskl is null and NEW.idtypdoklskl is not null) then
    if (NEW.generovatSkl = true and NEW.zdrojProSkl = true) then
      -- bylo false a nastavi se true tak musime zajistit vygenerovani skladoveho dokladu k polozkam, ktere nejste nejsou vyskladneny
      if(NEW.modul = 'FAV' or NEW.modul = 'FAP') then
        for _polFak in select * from dPolFak where idDoklFak = NEW.idDoklFak loop
          if(_polFak.typPolozkyK like 'typPolozky.katalog' and _polFak.zdrojProSkl) then
            select skladove into _skladove from cCenik where idCenik = _polFak.idCenik;
            if (_skladove and _polFak.idBspSkl is not null) then
              select findParovanyPolSklad(_polFak.idPolFak, NEW.modul) into _idPolSklad;
              if(_idPolSklad is null) then
                select count(*) into _sadaItemCount from csady where idceniksada = _polFak.idCenik;
                if(_sadaItemCount > 0) then
                  execute createPolSkladSada(_polFak.idPolFak, NEW.modul);
                else
                  select createPolSklad(_polFak.idPolFak, NEW.modul) into _idPolSklad;
                end if;
              else
                -- nejspis nebudeme delat nic
              end if;
            end if;
          end if;
        end loop;
      elsif (NEW.modul = 'POK') then
        for _polFak in select * from dPolInt where idDoklInt = NEW.idDoklInt loop
          if(_polFak.typPolozkyK like 'typPolozky.katalog' and _polFak.zdrojProSkl) then
            select skladove into _skladove from cCenik where idCenik = _polFak.idCenik;
            if (_skladove and _polFak.idBspSkl is not null) then
              select findParovanyPolSklad(_polFak.idPolInt, NEW.modul) into _idPolSklad;
              if(_idPolSklad is null) then
                select count(*) into _sadaItemCount from csady where idceniksada = _polFak.idCenik;
                if(_sadaItemCount > 0) then
                  execute createPolSkladSada(_polFak.idPolInt, NEW.modul);
                else
                  select createPolSklad(_polFak.idPolInt, NEW.modul) into _idPolSklad;
                end if;
              else
                -- nejspis nebudeme delat nic
              end if;
            end if;
          end if;
        end loop;
      end if;
    else
    end if;
  end if;

  -- propasovani zmen na dokladu faktury do skladoveho dokladu...
  -- napr. zmena firmy, cinnosti...
  if(NEW.generovatSkl = true and NEW.zdrojProSkl = true) then
    if(not compareId(OLD.idFirmy, NEW.idFirmy)
       or not compareVarchar(OLD.nazFirmy, NEW.nazFirmy)
       or not compareVarchar(OLD.ulice, NEW.ulice)
       or not compareVarchar(OLD.mesto, NEW.mesto)
       or not compareVarchar(OLD.psc, NEW.psc)
       or not compareId(OLD.idStatu, NEW.idStatu)
       or not compareVarchar(OLD.ic, NEW.ic)
       or not compareVarchar(OLD.dic, NEW.dic)
       or not compareVarchar(OLD.vatId, NEW.vatId)
       or not compareId(OLD.idMur, NEW.idMur)
       or not compareId(OLD.idKrajUrc, NEW.idKrajUrc)
       or not compareId(OLD.idStatUrc, NEW.idStatUrc)
       or not compareVarchar(OLD.cisObj, NEW.cisObj)
       or not compareVarchar(OLD.doprava, NEW.doprava)
       or not compareId(OLD.idDruhDopr, NEW.idDruhDopr)
       or not compareVarchar(OLD.popis, NEW.popis)
       or not compareVarchar(OLD.poznam, NEW.poznam)
       or not compareId(OLD.idcinnost, NEW.idCinnost)
       or not compareId(OLD.idStred, NEW.idStred)
       or not compareVarchar(OLD.varSym, NEW.varSym)
       or not compareId(OLD.idZakazky, NEW.idZakazky)
       or not compareVarchar(OLD.eanKod, NEW.eanKod)
       or not compareId(OLD.idstatpuvod, NEW.idStatPuvod)
       or not compareId(OLD.idstatodesl, NEW.idStatOdesl) 
       or not compareId(OLD.idKontaktOsoba, NEW.idKontaktOsoba)
       or not compareId(OLD.idZodpOsoba, NEW.idZodpOsoba)
    ) then
      if(NEW.modul = 'FAV' or NEW.modul = 'FAP') then
        _idDoklad = NEW.idDoklFak;
      elsif(NEW.modul = 'POK') then
        _idDoklad = NEW.idDoklInt;
      else
      end if;
    
      for _doklSklad in select * from dvazebtab vt join ddoklsklad ds on vt.idtabb = ds.iddoklsklad 
        where typVazbyK = 'typVazbyDokl.hlavaSkl' and idTabA = _idDoklad and modulA = NEW.modul loop
          update ddoklsklad set
            lastUpdate = LOCALTIMESTAMP,
            idFirmy = NEW.idFirmy,
            nazFirmy = NEW.nazFirmy,
            ulice = NEW.ulice,
            mesto = NEW.mesto,
            psc = NEW.psc,
            idStatu = NEW.idStatu,
            ic = NEW.ic,
            dic = NEW.dic,
            vatId = NEW.vatId,
            idMur = NEW.idMur,
            idKrajUrc = NEW.idKrajUrc,
            idStatUrc = NEW.idStatUrc,
            cisObj = NEW.cisObj,
            doprava = NEW.doprava,
            idDruhDopr = NEW.idDruhDopr,
            popis = NEW.popis,
            poznam = NEW.poznam,
            idcinnost = NEW.idCinnost,
            idStred = NEW.idStred,
            varSym = NEW.varSym, 
            idZakazky = NEW.idZakazky,
            eanKod = NEW.eanKod,
            idstatpuvod = NEW.idStatPuvod,
            idstatodesl = NEW.idStatOdesl, 
            idKontaktOsoba = NEW.idKontaktOsoba,
            idZodpOsoba = NEW.idZodpOsoba
          where idDoklSklad = _doklSklad.idDoklSklad;
      end loop;
    end if;
  end if;

  return NEW;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION ddokladupdatesklad() OWNER TO %firmaRole%;


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 625, 't', %appVersion%, clock_timestamp());
