--------------------------------------------------------------------------------
-- Bug 28947 – [winstrom] - sklad - zrychlení skladu a zrušení rozpadů fifa
--------------------------------------------------------------------------------

DROP FUNCTION dcanulozitpolozku(integer, date, integer, numeric, character varying, integer, character varying, date);

CREATE OR REPLACE FUNCTION sprepoctiskladkartu(i_mnozmj numeric, i_cenamj numeric, i_datvyst date, i_skladkartaid integer, i_doklskladid integer, i_skladid integer, i_nasobic integer)
  RETURNS void AS
$BODY$    
/* Prepocte stavy na skladove karte s id = iSkladKartaId */    
declare    
  /* Deklarace promennych */    
  _PomMnozMJ numeric(19,6);    
  _StavMJ numeric(19,6);    
  _StavTuz numeric(19,2);    
  _StavMen numeric(19,2);    
  _PrumCenaTuz numeric(19,6);    
  _PrumCenaMen numeric(19,6);    
  _PoslCenaTuz numeric(19,6);    
  _PoslCenaMen numeric(19,6);    
  _TypPohybuK varchar(50);    
  _DatPosl date;    
  _kurzSkladKarty numeric(19,6);   
  _kurzDokladu numeric(19,6);   
  loc_MnozMJ numeric(19,6);   
  _sklfifo boolean;    
   
  /* Deklarace kurzoru pro nacteni potrebnych dat ze skladove karty a dokladu */   
  declare ThisDoklSklad cursor for select TypPohybuK from dDoklSklad where idDoklSklad = i_DoklSkladId;   
  declare ThisSkladKarta cursor for select StavMJ,StavTuz,StavMen,PrumCenaTuz,PrumCenaMen,DatPosl from sKarty where idKarty = i_SkladKartaId;     
begin   
  loc_MnozMJ:= i_MnozMJ;   
   
  /* Nacteni dat ze skladove karty */   
  open ThisSkladKarta;   
  fetch ThisSkladKarta into _StavMJ,   
    _StavTuz,_StavMen,_PrumCenaTuz,_PrumCenaMen,_DatPosl;   
  close ThisSkladKarta;   
     
  /* Zjisteni typPohybuK */   
  open ThisDoklSklad;   
  fetch ThisDoklSklad into _TypPohybuK;   
  close ThisDoklSklad;   
  
  /* zjisteni meny skladove karty */  
  _KurzSkladKarty := (select getKurzFromSklad(i_skladId, i_DatVyst));  
  _KurzDokladu := (select getKurzFromDoklad(i_doklSkladId, i_DatVyst));  
    
  /* pokud jde o vydej musim odecitat */   
  if _TypPohybuK = 'typPohybu.vydej' then   
    loc_MnozMJ:= 0-loc_MnozMJ;   
  end if;   
     
  /* Vypocet StavMJ */   
  _StavMJ:=_StavMJ+loc_MnozMJ*i_Nasobic;   
  
  /* Vypocet StavTuz */   
  if (loc_MnozMJ = 0 and _TypPohybuK = 'typPohybu.prijem')then    
    _PomMnozMJ:=1;   
  else   
    _PomMnozMJ:=loc_MnozMJ;   
  end if;   
  _StavTuz:=_StavTuz+(_PomMnozMJ*i_CenaMJ*i_Nasobic*_KurzDokladu);
  /* Vypocet StavMen */   
  _StavMen:=_StavMen+(_PomMnozMJ*i_CenaMJ*i_Nasobic*_KurzDokladu)/_KurzSkladKarty;   
  
  /* Vypocet prumernych cen ma byt proveden jen pri prijmu*/  
  if _TypPohybuK = 'typPohybu.prijem' then
    /* Vypocet PrumCenaTuz */   
    if _StavMJ > 0 then   
      _PrumCenaTuz:=_StavTuz/_StavMJ;   
    end if;   
    /* Vypocet PrumCenaMen */   
    if _StavMJ > 0 then   
      _PrumCenaMen:=_StavMen/_StavMJ;   
    end if;   
  end if;   
   
  /* Prepocteni stavu skladu pro FIFO */
  -- drobna uprava prumerne ceny pokud by doslo k chybe vlivem zaokrouhleni a pro fifo nutnost  
  --_sklfifo := (select isfifosklad(i_DatVyst));  
  --if (_sklfifo) then  
    if(_StavMJ <> 0.0) then 
      _PrumCenaTuz := _StavTuz / _StavMJ;  
      _PrumCenaMen := _StavMen / _StavMJ; 
    end if; 
  --end if;  
   
  /* Nastaveni posledni ceny */   
  _PoslCenaTuz:= i_CenaMJ * _KurzDokladu;  
  _PoslCenaMen:= i_CenaMJ;   
  
  /* Nastaveni data posledniho pohybu na karte */   
  if _DatPosl is null then   
    _DatPosl:= i_DatVyst;   
  end if;   
  if _DatPosl < i_DatVyst then   
    _DatPosl:=i_DatVyst;   
  end if;   
  
  /* Update v databazi */
  if(_TypPohybuK = 'typPohybu.vydej') then
    update sKarty set StavMJ = _StavMJ,    
      StavTuz = _StavTuz,    
      StavMen = _StavMen,    
      PrumCenaTuz = _PrumCenaTuz,    
      PrumCenaMen = _PrumCenaMen,
      DatPosl = _DatPosl,
      lastUpdate = LOCALTIMESTAMP
      where    
      idKarty = i_SkladKartaId;    
  else
    update sKarty set StavMJ = _StavMJ,    
      StavTuz = _StavTuz,    
      StavMen = _StavMen,    
      PrumCenaTuz = _PrumCenaTuz,    
      PrumCenaMen = _PrumCenaMen,    
      PoslCenaTuz = _PoslCenaTuz,    
      PoslCenaMen = _PoslcenaMen,    
      DatPosl = _DatPosl,
      lastUpdate = LOCALTIMESTAMP
      where    
      idKarty = i_SkladKartaId;    
  end if;  
end;   
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;
ALTER FUNCTION sprepoctiskladkartu(numeric, numeric, date, integer, integer, integer, integer) OWNER TO %firmaRole%;


CREATE OR REPLACE FUNCTION sprepoctiskladkartu(i_mnozmj numeric, i_cenamj numeric, i_sumzkl numeric, i_datvyst date, i_skladkartaid integer, i_doklskladid integer, i_skladid integer, i_nasobic integer)
  RETURNS void AS
$BODY$    
/* Prepocte stavy na skladove karte s id = iSkladKartaId */    
declare    
  /* Deklarace promennych */    
  _PomMnozMJ numeric(19,6);    
  _StavMJ numeric(19,6);    
  _StavTuz numeric(19,2);    
  _StavMen numeric(19,2);    
  _PrumCenaTuz numeric(19,6);    
  _PrumCenaMen numeric(19,6);    
  _PoslCenaTuz numeric(19,6);    
  _PoslCenaMen numeric(19,6);    
  _TypPohybuK varchar(50);    
  _DatPosl date;    
  _kurzSkladKarty numeric(19,6);   
  _kurzDokladu numeric(19,6);   
  loc_MnozMJ numeric(19,6);   
  _sklfifo boolean;    
   
  /* Deklarace kurzoru pro nacteni potrebnych dat ze skladove karty a dokladu */   
  declare ThisDoklSklad cursor for select TypPohybuK from dDoklSklad where idDoklSklad = i_DoklSkladId;   
  declare ThisSkladKarta cursor for select StavMJ,StavTuz,StavMen,PrumCenaTuz,PrumCenaMen,DatPosl from sKarty where idKarty = i_SkladKartaId;     
begin   
  loc_MnozMJ:= i_MnozMJ;   
   
  /* Nacteni dat ze skladove karty */   
  open ThisSkladKarta;   
  fetch ThisSkladKarta into _StavMJ,   
    _StavTuz,_StavMen,_PrumCenaTuz,_PrumCenaMen,_DatPosl;   
  close ThisSkladKarta;   
     
  /* Zjisteni typPohybuK */   
  open ThisDoklSklad;   
  fetch ThisDoklSklad into _TypPohybuK;   
  close ThisDoklSklad;   
  
  /* zjisteni meny skladove karty */  
  _KurzSkladKarty := (select getKurzFromSklad(i_skladId, i_DatVyst));  
  _KurzDokladu := (select getKurzFromDoklad(i_doklSkladId, i_DatVyst));  
    
  /* pokud jde o vydej musim odecitat */   
  if _TypPohybuK = 'typPohybu.vydej' then   
    loc_MnozMJ:= 0-loc_MnozMJ;   
  end if;   
     
  /* Vypocet StavMJ */   
  _StavMJ:=_StavMJ+loc_MnozMJ*i_Nasobic;   
  
  /* Vypocet StavTuz */   
  if (loc_MnozMJ = 0 and _TypPohybuK = 'typPohybu.prijem')then    
    _PomMnozMJ:=1;   
    _StavTuz:=_StavTuz+(_PomMnozMJ*i_CenaMJ*i_Nasobic*_KurzDokladu);
  else   
    _PomMnozMJ:=loc_MnozMJ;
    if(_TypPohybuK = 'typPohybu.prijem') then
       /* Pricitam sumZkl */
      _StavTuz:=_StavTuz+(i_sumZkl*i_Nasobic);
    else
      /* Odecitam sumZkl */
      _StavTuz:=_StavTuz-(i_sumZkl*i_Nasobic);
    end if;
  end if;   
  
  /* Vypocet StavMen */   
  _StavMen:=_StavMen+(_PomMnozMJ*i_CenaMJ*i_Nasobic*_KurzDokladu)/_KurzSkladKarty;   
  
  /* Vypocet prumernych cen ma byt proveden jen pri prijmu*/  
  if _TypPohybuK = 'typPohybu.prijem' then
    /* Vypocet PrumCenaTuz */   
    if _StavMJ > 0 then   
      _PrumCenaTuz:=_StavTuz/_StavMJ;   
    end if;   
    /* Vypocet PrumCenaMen */   
    if _StavMJ > 0 then   
      _PrumCenaMen:=_StavMen/_StavMJ;   
    end if;   
  end if;   
   
  /* Prepocteni stavu skladu pro FIFO */
  -- drobna uprava prumerne ceny pokud by doslo k chybe vlivem zaokrouhleni a pro fifo nutnost  
  --_sklfifo := (select isfifosklad(i_DatVyst));  
  --if (_sklfifo) then  
    if(_StavMJ <> 0.0) then 
      _PrumCenaTuz := _StavTuz / _StavMJ;  
      _PrumCenaMen := _StavMen / _StavMJ; 
    end if; 
  --end if;  
   
  /* Nastaveni posledni ceny */   
  _PoslCenaTuz:= i_CenaMJ * _KurzDokladu;  
  _PoslCenaMen:= i_CenaMJ;   
  
  /* Nastaveni data posledniho pohybu na karte */   
  if _DatPosl is null then   
    _DatPosl:= i_DatVyst;   
  end if;   
  if _DatPosl < i_DatVyst then   
    _DatPosl:=i_DatVyst;   
  end if;   
  
  /* Update v databazi */
  if(_TypPohybuK = 'typPohybu.vydej') then
    update sKarty set StavMJ = _StavMJ,    
      StavTuz = _StavTuz,    
      StavMen = _StavMen,    
      PrumCenaTuz = _PrumCenaTuz,    
      PrumCenaMen = _PrumCenaMen,
      DatPosl = _DatPosl,
      lastUpdate = LOCALTIMESTAMP
      where    
      idKarty = i_SkladKartaId;    
  else
    update sKarty set StavMJ = _StavMJ,    
      StavTuz = _StavTuz,    
      StavMen = _StavMen,    
      PrumCenaTuz = _PrumCenaTuz,    
      PrumCenaMen = _PrumCenaMen,    
      PoslCenaTuz = _PoslCenaTuz,    
      PoslCenaMen = _PoslcenaMen,    
      DatPosl = _DatPosl,
      lastUpdate = LOCALTIMESTAMP
      where    
      idKarty = i_SkladKartaId;    
  end if;  
end;   
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;
ALTER FUNCTION sprepoctiskladkartu(numeric, numeric, numeric, date, integer, integer, integer, integer) OWNER TO %firmaRole%;


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 631, 't', %appVersion%, clock_timestamp());
