--------------------------------------------------------------------------------
-- Bug 32278 – [FlexiBee] Přidat do FlexiBee podporu obrázků ceníku
--------------------------------------------------------------------------------

ALTER TABLE wpriloha
    ADD COLUMN mainattachment boolean NOT NULL DEFAULT false,
    ADD COLUMN datahash character varying(50),
    ADD COLUMN picturewidth smallint,
    ADD COLUMN pictureheight smallint;

CREATE OR REPLACE FUNCTION doUpgrade()
    RETURNS void AS
$BODY$    
DECLARE
    _idstatu integer;
BEGIN
    update wpriloha set typk = 'typPrilohy.obrazek' where contenttype ~ 'image/.*' and typk !~ 'typPrilohy.(logo|podRaz|odkaz|obrazek)';
    update wpriloha set typk = 'typPrilohy.ostatni' where typk !~ 'typPrilohy.(logo|podRaz|odkaz|obrazek)';
END;
$BODY$
    LANGUAGE 'plpgsql' VOLATILE
    COST 100;


ALTER FUNCTION doUpgrade() OWNER TO %firmaRole%;

select doUpgrade();
drop function doUpgrade();

-- zvyseni verze databaze
INSERT INTO dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
    VALUES (nextval('seq_dbversion'), 689, 't', %appVersion%, clock_timestamp());
