--------------------------------------------------------------------------------
-- Bug 36686 – [WinStrom] U Sincoloru spatne pocita sklad
--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION sfifocenamj(idpohyb integer, iddokl integer, cenamjprijem numeric(19,6))
  RETURNS void AS
$BODY$  
declare  
	_typPohybuk character varying(255);
         _pouzitaPrijemka integer;
        _idPolSklad integer;
        _polSklad record;
        _cenaMj numeric(19,6);
        _kurzPrijem numeric(19,6);
        _kurzVydej numeric(19,6);
        _sumZkl numeric(19,6);
        _sumZklMen numeric(19,6);
        _vydejCiziMena boolean;
        _prijemCiziMena boolean;
        _datVystPrijem date;
begin  
	select typpohybuk into _typPohybuk from ddoklsklad where iddoklsklad = iddokl;	
	if (_typPohybuk = 'typPohybu.prijem') then
	        select datVyst into _datVystPrijem from ddoklsklad where iddoklsklad = iddokl;
                select getkurzfromdoklad(iddokl, _datVystPrijem) into _kurzPrijem;
                _cenaMj = cenamjprijem * _kurzPrijem;
                --pokud změna ceny na příjemce, tak změním dle vazeb na výdejkách 
         	for _idpolsklad in select idpolskladvydej from sfifovazby where idpolskladprijem = idpohyb loop
                  select * into _polSklad from dPolSklad where idPolSklad = _idPolSklad;
                  if(not _polSklad.cenyRucne) then

                    select getkurzfromdoklad(_polSklad.idDoklSklad, _polSklad.datVyst) into _kurzVydej;
                    select isdoklskladmenacizi(_polSklad.idDoklSklad, _polSklad.datVyst) into _vydejCiziMena;

                    select coalesce(sum(case when ps.mnozMj = fv.kusu then ps.sumZkl else (ps.sumZkl / ps.mnozMj) * fv.kusu end), 0.0) into _sumZkl from dpolsklad ps join sfifovazby fv 
                      on ps.idpolsklad = fv.idpolskladprijem
                      where idpolskladvydej = _idPolSklad;

                    if(_vydejCiziMena = true) then
                      _sumZklMen = _sumZkl / _kurzVydej ;
                      _cenaMj = _sumZklMen / _polSklad.mnozMj;
                    else
                      _sumZklMen = 0.0;
                      _cenaMj = _sumZkl / _polSklad.mnozMj;
                    end if;
                  
                    update dpolsklad set 
                      cenamj = _cenaMj,
                      cenaMjPoriz = _cenaMj,
                      sumZkl = _sumZkl,
                      sumZklMen = _sumZklMen 
                      where idpolsklad = _idPolSklad;
                    execute sprepoctisumydokladu(_polSklad.idDoklSklad);
                  end if;
         	end loop;
		--update dpolsklad set cenamj = cenamjprijem where idpolsklad = (select idpolskladvydej from sfifovazby where idpolskladprijem = idpohyb); 
         end if;
end;  
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION sfifocenamj(integer, integer, numeric(19,6)) OWNER TO %firmaRole%;

CREATE OR REPLACE FUNCTION dpolskladupdate()
  RETURNS trigger AS
$BODY$ 
declare 
  tmp_rozsirenepolozky_exists boolean; 
  _updatuj boolean; 
  _pocetPolozek integer; 
  _rozsirenaPolozka record; 
  _sklFifo boolean; 
  _vypnutySklad character varying;
  _mazatTmpTable boolean; 
  _polSklad record;
  _datPosl date;
  _newDatPosl date;
begin 

  if(NEW.idBspSkl = OLD.idBspSkl and NEW.idCenik = OLD.idCenik
    and comparevarchar(NEW.typPolozkyK, OLD.typPolozkyK)
    and comparevarchar(NEW.sarze, OLD.sarze) and comparedate(NEW.expirace, OLD.expirace)
    and NEW.mnozMj = OLD.mnozMj and NEW.cenaMj = OLD.cenaMj and NEW.sumZkl = OLD.sumZkl and NEW.sumZklMen = OLD.sumZklMen
    and NEW.storno = OLD.storno 
  ) then
    if(not comparedate(NEW.datVyst, OLD.datVyst)) then
      -- pokud se nezmenilo nic jinyho jen datum vystaveni
      select datPosl into _datPosl from skarty where idkarty = NEW.idkarty;
      select max(datVyst) into _newDatPosl from dPolSklad where idKarty = NEW.idKarty;
      
      if(_newDatPosl is not null and _datPosl is not null and _newDatPosl <> _datPosl) then
        update skarty set datPosl = _newDatPosl where idKarty = NEW.idKarty;
      end if;
    end if;
    return NEW;
  end if;

  /* 
    prepocet skladu budeme provadet jen v okamziku kdy neexistuje tabulka tmp_rozsirenePolozky 
    nebo kdyz tato tabulka existuje ale neni v ni obsazeno polozka kteoru chceme updatovat 
  */ 
  select getglotxvariable('vypniSklad') into _vypnutySklad; 
  if(_vypnutySklad is null or _vypnutySklad <> 'true') then 
    _updatuj = true; 
    tmp_rozsirenepolozky_exists := (select istableexist('tmp_RozsirenePolozky')); 
    if(tmp_rozsirenepolozky_exists = true) then 
      --select count(*) into _pocetPolozek from tmp_rozsirenePolozky where idPolSklad = NEW.idPolSklad; 
      --if(_pocetPolozek > 0) then 
      select 1 into _pocetPolozek from tmp_rozsirenePolozky where idPolSklad = NEW.idPolSklad limit 1; 
      if(_pocetPolozek is not null) then 
        _updatuj = false; 
      end if; 
    end if; 
 
    if(OLD.idPolSklad < 0 and NEW.idPolSklad > 0) then 
      _updatuj = false; 
    end if; 
   
    if (OLD.storno=false and NEW.storno=true) then
      execute sfifoStorno(OLD.idpolsklad, OLD.iddoklsklad);
    end if;

    _sklfifo := (select isfifosklad(NEW.datVyst));   
    if (_sklfifo) then   
      --fifo   
      if (OLD.cenamj <> NEW.cenamj or OLD.sumZkl <> NEW.sumZkl) then   
        execute sfifocenamj(OLD.idpolsklad, OLD.iddoklsklad, NEW.cenamj);   
      end if;     
      --fifo konec   
    end if;   
 
    -- tohle musi byt i pro prumerne ceny protoze jinak se negeneruji fifo vazby
    if (OLD.mnozMj = 0.0 and NEW.mnozMj != 0.0) then
      execute sfifovydej(NEW.idPolSklad, NEW.idCenik, NEW.idBspSkl, NEW.idkarty, NEW.mnozMjPlan, NEW.cenyRucne);
    end if;
    
    if(_updatuj) then 
 
      -- generuji rozsirene polozky 
      select skladGenerujRozsirenePolozky(NEW.datSklad, NEW.idPolSklad, NEW.idKarty) into _mazatTmpTable; 
     
      execute putglotxvariable('zurnalTxName', 'prepocetSkladu'); 
  
      for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
        if(_rozsirenaPolozka.idPolSklad <> OLD.idPolSklad) then 
          if(_rozsirenaPolozka.cenyRucne = true) then
            if(_rozsirenaPolozka.storno = false) then 
              select * into _polSklad from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad;
              execute sprepoctiskladkartu(_polSklad.mnozMj, _polSklad.cenaMj, _polSklad.sumZkl, _polSklad.datVyst, _polSklad.idKarty, _polSklad.idDoklSklad, _polSklad.idBspSkl, -1); 
            end if;
          else 
            execute skladOdpoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad); 
          end if;
        end if; 
      end loop; 

      if(OLD.storno = false) then
        execute sprepoctiskladkartu(OLD.mnozMj, OLD.cenaMj, OLD.sumZkl, OLD.datVyst, OLD.idKarty, OLD.idDoklSklad, OLD.idBspSkl, -1);
      end if;

      for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
        if(_rozsirenaPolozka.idPolSklad <> OLD.idPolSklad) then 
          if(_rozsirenaPolozka.cenyRucne = true) then
            if(_rozsirenaPolozka.storno = false) then 
              select * into _polSklad from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad;
              execute sprepoctiskladkartu(_polSklad.mnozMj, _polSklad.cenaMj, _polSklad.sumZkl, _polSklad.datVyst, _polSklad.idKarty, _polSklad.idDoklSklad, _polSklad.idBspSkl, 1); 
            end if;
          else
            execute skladZapoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad); 
          end if;
        else
          if(NEW.storno = false) then
            execute sprepoctiskladkartu(NEW.mnozMj, NEW.cenaMj, NEW.sumZkl, NEW.datVyst, NEW.idKarty, NEW.idDoklSklad, NEW.idBspSkl, 1);
          end if;
        end if;
      end loop; 
 
      if(_mazatTmpTable) then 
        drop table tmp_RozsirenePolozky; 
        drop table tmp_SkladoveKarty; 
        execute removeglotxvariable('zurnalTxName'); 
      end if; 
        
    end if; 
  end if;

  execute sprepoctisumydokladu(NEW.idDoklSklad); 

  return NEW; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpolskladupdate() OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 792, 't', %appVersion%, clock_timestamp());


