-------------------------------------------------------------------------
-- Bug 36758 – [Winstrom] Výdejka s mínusovou hodnotou (Sincolor - FIFO)
-------------------------------------------------------------------------

-- Function: skladfindcenamjnakup
-- DROP FUNCTION skladfindcenamjnakup(numeric, integer, integer, date, character varying, date, date, integer, integer);
CREATE OR REPLACE FUNCTION skladfindcenamjnakup(i_mnozmj numeric, i_idcenik integer, i_idskladu integer, i_datum date, i_sarze character varying, i_expirace date, i_dattrvan date, i_idvyrobnihocisla integer, i_idstred integer)
  RETURNS numeric AS
$BODY$
declare
  _sklfifo boolean;
  _mazatTmpTable boolean;
  _idkarty integer;
  _rozsirenaPolozka record;
  _iducetobdobi integer;
  _result numeric(19,6);
  _pomocDPolSkladF record;
  _mnozstvi numeric(19,6);
  _potrebnyPocet numeric(19,6);
  _sadaItemCount integer;
  _polozkaSady record;
  _pomoc numeric(19,6);

  _sumSumZkl numeric(19,6);
  _sumMnozMj numeric(19,6);
  _sumTuz numeric(19,6);
  _mnozMj numeric(19,6);
  _typPohybuK character varying;
  _karta record;
  _idskupzboz integer;
  _idSkladuPref integer;
  _cenik record;
  _sklad record;
  _query character varying;
begin
  _result = null;
  _mnozstvi = 0.0;

  if(i_mnozMj > 0) then
    select count(*) into _sadaItemCount from csady where idceniksada = i_idcenik;
    if(_sadaItemCount > 0) then
      FOR _polozkaSady IN (select * from cSady where idCenikSada = i_idcenik) LOOP
        -- TODO doresit sarze expirace a vyrobni cisla
        select skladfindcenamjnakup(i_mnozmj * _polozkaSady.mnozMj, _polozkaSady.idcenik, i_idskladu, i_datum, null, null, null, null, i_idstred) into _pomoc;
        if (_result is null) then
          _result = 0.0;
        end if;
        _result = _result + (_pomoc * _polozkaSady.mnozMj);
      end loop;
    else
      select * into _cenik from ccenik where idCenik = i_idcenik;
      if(_cenik.skladove) then
        select findiducetniobdobikdatu(i_datum) into _iducetobdobi;
        _sklfifo := (select isfifosklad(i_datum));
        if (_sklfifo) then
          if(i_idvyrobnihocisla is not null and i_idvyrobnihocisla > 0) then
            -- pokud je zadano vyrobni cislo ma nejvetsi prioritu
            select (sumzkl / (case when mnozmj = 0.0 then 1 else mnozmj end))::numeric(19,6) into _result 
              from dpolsklad where idpolsklad = (select idpolskladprijem from svyrobnicislo where idvyrobnicislo = i_idvyrobnihocisla);
          else
            _query = 'select * from dpolskladf' ||
                ' where idcenik = ''' || i_idcenik || '''' ||
                ' and idSkladu = ''' || i_idSkladu || '''';
             
             if (i_sarze is not null) then
               _query = _query ||
                   ' and sarze = ''' || i_sarze || '''';
             end if;
             if (i_expirace is not null) then
               _query = _query ||
                   ' and expirace = ''' || i_expirace || '''';
             end if;
             if (i_dattrvan is not null) then
               _query = _query ||
                   ' and dattrvan = ''' || i_dattrvan || '''';
             end if;

            _query = _query ||
                ' order by datSklad,idpolsklad';

            for _pomocDPolSkladF in execute _query loop
              if (i_mnozMj > _mnozstvi) then
                _potrebnyPocet = _pomocDPolSkladF.pocet;
                if ((_mnozstvi + _potrebnyPocet) > i_mnozMj) then
                  _potrebnyPocet = i_mnozMj - _mnozstvi;
                end if;
                _mnozstvi = _mnozstvi + _potrebnyPocet;
                if (_result is null) then
                  _result = 0.0;
                end if;
                _result = _result + _potrebnyPocet * _pomocDPolSkladF.cenaMjTuz;
              end if;
            end loop;
            if(_mnozstvi != 0.0) then
              _result = _result / _mnozstvi;
            else
              if (_result is not null) then
                _result = 0.0;
              end if;
            end if;
          end if;
        else
          -- generuji rozsirene polozky
          select * into _karta from skarty where idcenik = i_idcenik and idskladu = i_idskladu and iducetobdobi = _iducetobdobi;
          -- pokud neexistuje skladova karta pokusim se ji najit pomoci mapovani skladu
          if(_karta is null) then
            select idskupzboz into _idskupzboz from ccenik where idcenik = i_idcenik;
            select getPrefIdSkladu(i_idstred, _idskupzboz, i_idcenik) into _idSkladuPref;
            select * into _karta from skarty
              where idSkladu = _idSkladuPref and idCenik = i_idCenik and idUcetObdobi = _idUcetObdobi;
            if(_karta is null) then
              -- pokud ani podle mapovani skladu se skladova karta nenajde tak vyhazuju vyjimku
              select * into _sklad from dbsp where idBsp = i_idSkladu;
              raise exception '0007:Skladová karta neexistuje pro ceník % a sklad % a nebo je špatně nastaveno mapovaní skladu.', _cenik.nazev, _sklad.nazev;
            end if;
          end if;

          if(_karta is null) then
            raise exception 'Nenalezena sklad karta';
          end if;

          _sumTuz = _karta.stavTuz;
          _mnozMj = _karta.stavMj;
          if(_mnozMj <> 0.0) then
            _result = _sumTuz / _mnozMj;
          end if;
        end if;
      else
        --nejedna se o skladove zbozi
        _result = _cenik.nakupCena;
      end if;
    end if;

    if (_result is null) then
      select (case when cenjednotka<>0.0 then round(nakupcena/cenjednotka, 6) else 0.0 end) into _result from ccenik where idcenik = i_idcenik;
    end if;
  else
    _result = 0.0;  
  end if;
  return _result;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION skladfindcenamjnakup(numeric, integer, integer, date, character varying, date, date, integer, integer) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 796, 't', %appVersion%, clock_timestamp());
