--------------------------------------------------------------------------------
-- Bug 39948 - [Bug] Vytvořit upgrade script opravujici chybne ceny na zapornych prijemkach
--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION sopravcenynaprijemkach()
  RETURNS void AS
$BODY$ 
declare 
  _zaznam record;
begin
  for _zaznam in select ps.idkarty, ps.idpolsklad, ps.sumZkl as pssumzkl, ps.datVyst, pf.idpolfak, pf.sumZkl as pfsumzkl, ds.zdrojProFak from dpolsklad ps
        join ddoklsklad ds on ps.iddoklsklad = ds.iddoklsklad
        join dvazebtab vt on ps.idpolsklad = vt.idtabb and vt.modulB = ps.modul and (vt.typVazbyK = 'typVazbyDokl.polozkaSkl')
        join dpolfak pf on vt.idtaba = pf.idpolfak and vt.modulA = pf.modul
        where ds.typPohybuK = 'typPohybu.prijem' and ps.mnozMj < 0.0 and ps.sumZkl <> pf.sumZkl and ps.datVyst >= '2013-01-01'
        order by ps.datvyst
  loop
    update dpolsklad ps set
      cenaMj = _zaznam.pfsumzkl /ps.mnozMj,
      sumZkl = _zaznam.pfsumzkl
      where idpolsklad = _zaznam.idpolsklad;
  end loop;
end; 
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION sopravcenynaprijemkach() OWNER TO %firmaRole%;

select sopravcenynaprijemkach();

drop function sopravcenynaprijemkach();


-- zvyseni verze databaze
INSERT INTO dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  VALUES (nextval('seq_dbversion'), 865, 't', %appVersion%, clock_timestamp());
