--------------------------------------------------------------------------------
-- Bug 40797 - [Winstrom] Šarže a expirace X výrobní čísla ABRA FB ONE
--------------------------------------------------------------------------------
DROP VIEW dpolskladf;

CREATE OR REPLACE VIEW dpolskladf AS 
         SELECT p.idpolsklad, 
                CASE
                    WHEN p.typpohybuk::text = 'typPohybu.prijem'::text THEN p.mnozmj - jevydano(p.idpolsklad)
                    ELSE (- p.mnozmj) - jevydano(p.idpolsklad)
                END AS pocet, p.cenamj, p.datvyst, p.datsklad, p.dattrvan, p.datvyroby, p.expirace, p.idzakazky, p.idskladu, p.idcenik, p.sarze, NULL::integer AS idvyrobnicislo, c.evidvyrcis, c.evidSarze, c.evidexpir, p.typpohybuk, p.cenamjtuz
           FROM dpolskladdoklad p
      JOIN ccenik c ON c.idcenik = p.idcenik
     WHERE (p.typpohybuk::text = 'typPohybu.prijem'::text AND p.mnozmj >= 0.0 AND (p.mnozmj - jevydano(p.idpolsklad)) > 0::numeric OR p.typpohybuk::text = 'typPohybu.vydej'::text AND p.mnozmj < 0.0 AND ((- p.mnozmj) - jevydano(p.idpolsklad)) > 0::numeric) 
        AND c.evidvyrcis = false AND p.storno <> true
UNION ALL 
         SELECT p.idpolsklad, 1 AS pocet, p.cenamj, p.datvyst, p.datsklad, p.dattrvan, p.datvyroby, p.expirace, p.idzakazky, p.idskladu, p.idcenik, p.sarze, v.idvyrobnicislo, c.evidvyrcis, c.evidSarze, c.evidexpir, p.typpohybuk, p.cenamjtuz
           FROM svyrobnicislo v
      JOIN dpolskladdoklad p ON p.idpolsklad = v.idpolskladprijem
   JOIN ccenik c ON c.idcenik = p.idcenik
  WHERE p.typpohybuk::text = 'typPohybu.prijem'::text AND c.evidvyrcis = true  AND NOT (v.idvyrobnicislo IN ( SELECT sfifovazby.idvyrobnicislo
         FROM sfifovazby
        WHERE sfifovazby.idpolskladprijem = p.idpolsklad)) AND p.storno <> true;

ALTER TABLE dpolskladf
  OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 886, 't', %appVersion%, clock_timestamp());
