-----------------------------------------------------------------------------------------------------------------------------------------------
-- Bug 42959 - Kombinace požadavků na výdej, automatických rezervací a možnosti rezervovat do záporu způsbí nekonzistentní hodnoty v rezervací 
-----------------------------------------------------------------------------------------------------------------------------------------------

-- trigger rusici rezervaci pri vyskladneni
CREATE OR REPLACE FUNCTION dpolskladupdaterezer()
  RETURNS trigger AS $$
declare
  zmena numeric(19,6);
  _idFirmy integer;
  _typPohybuK varchar(50);
begin
  zmena = 0;
  if (tg_op = 'UPDATE') then
    if (OLD.mnozMjPlan = NEW.mnozMjPlan and compareid(OLD.idCenik, NEW.idCenik) and compareid(OLD.idBspSkl, NEW.idBspSkl)) then
      return NEW;         -- pokud nedoslo ke zmene ktera se nas netyka, ukoncime aby jsme nezpomalovali sklad
    end if;
  
    zmena = OLD.mnozMjPlan;
  end if;
  
  zmena = NEW.mnozMjPlan - zmena;
  select idfirmy, typPohybuK into _idFirmy, _typPohybuK from ddoklsklad where idDoklSklad = NEW.idDoklSklad;

  if (zmena > 0 and _typPohybuK = 'typPohybu.vydej') then
    perform odrezervuj(_idFirmy, NEW.idCenik, NEW.idBspSkl, zmena);
  end if;
  if (zmena <> 0 and _typPohybuK = 'typPohybu.prijem') then
    perform srezervujzprijemky(NEW.idCenik, NEW.idBspSkl, zmena);
  end if;

  return NEW;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.dpolskladupdaterezer() OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 936, 't', %appVersion%, clock_timestamp());
