-----------------------------------------------------
-- Bug 44879 - Aktualizace firmy padá na upgrade984
-----------------------------------------------------

create or replace function runupgrade()
    returns void as $$
declare
    _idtyporg integer;
    _idsesstdpred integer; 
    _minDbVersion integer;
    _idsesuzivpred integer[];
    _idsesrozpadUce integer[];
begin
  select idtyporg into _idtyporg from nnastav where ((select max(platioddata) from nnastav) is null
        or (select max(platioddata) from nnastav) = platioddata);

  -- chceme provést aktualizaci jen pro podnikatele
  if (_idtyporg = 1) then
  
    -- zajisíme, aby byla idčka, která chceme - trošku si tu budeme nastavovat, cílem je idsesstdpred = 454 a idsesradky = 188 - pro řádek přidaný v bug 44685
    update usesstdpred set idsesstdpred = 454 where idsesradky = (select idsesradky from usesradky where oznaceni = 'P  A  V  2' and idsestavy = 1);
    -- jen dočasné, aby šel provést update idčka usesradky
    update usesstdpred set idsesradky = 187 where idsesstdpred = 454;
    
    -- Bug 44933 - Neprojde upgrade988  - pro případ, že má někdo už vygenerovanou rozvahu odkazující na špatná id usesradky
    _idsesuzivpred := array(select idsesuzivpred from uSesUzivPred where idsesradky = (select idsesradky from usesradky where oznaceni = 'P  A  V  2' and idsestavy = 1));
    _idsesrozpaduce := array(select idsesrozpaduce from uSesRozpadUce where idsesradky = (select idsesradky from usesradky where oznaceni = 'P  A  V  2' and idsestavy = 1));
    update uSesUzivPred set idsesradky = 187 where idsesradky = (select idsesradky from usesradky where oznaceni = 'P  A  V  2' and idsestavy = 1);
    update uSesRozpadUce set idsesradky = 187 where idsesradky = (select idsesradky from usesradky where oznaceni = 'P  A  V  2' and idsestavy = 1);
    
    update usesradky set idsesradky = 188 where oznaceni = 'P  A  V  2' and idsestavy = 1;
    update usesstdpred set idsesradky = 188 where idsesstdpred = 454;
    
    update uSesUzivPred set idsesradky = 188 where idsesuzivpred = any(_idsesuzivpred);
    update uSesRozpadUce set idsesradky = 188 where idsesrozpaduce = any(_idsesrozpaduce);
    
    -- Bug 44928 - Promazat předpisy sestavy a rozpady řádků sestav v sestavách (podnikatelé)
    select min(dbversion) into _minDbVersion from dbversion;
    
    -- oprava jen ve verzích, kde to bylo rozbité
    if (_minDbVersion > 962) then
        delete from uSesUzivPred;
        delete from uSesRozpadUce;
    end if;
    
  end if;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();

drop function runupgrade();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 988, 't', %appVersion%, clock_timestamp());
