CREATE OR REPLACE FUNCTION create_or_drop_majetek_zurnal_triggers(docreate boolean)
  RETURNS void AS
$BODY$
BEGIN
  -- Na nektere z tabulek muze byt uvalen zamek (napr. typu AccessShareLock)
  LOCK TABLE mdannakl IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE mdanodpisy IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE mleasing IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE mmajetek IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE msazby IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE msplatkal IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE mtypleas IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE mtypmaj IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE mucetodpisy IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE mudalosti IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE mumisteni IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE mzapujcky IN ACCESS EXCLUSIVE MODE NOWAIT;
  
  IF docreate THEN
    CREATE TRIGGER mdannaklzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON mdannakl FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER mdanodpisyzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON mdanodpisy FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER mleasingzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON mleasing FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER mmajetekzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON mmajetek FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER msazbyzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON msazby FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER msplatkalzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON msplatkal FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER mtypleaszurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON mtypleas FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER mtypmajzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON mtypmaj FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER mucetodpisyzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON mucetodpisy FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER mudalostizurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON mudalosti FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER mumistenizurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON mumisteni FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

    CREATE TRIGGER mzapujckyzurnal
        BEFORE UPDATE OR INSERT OR DELETE
        ON mzapujcky FOR EACH ROW
        EXECUTE PROCEDURE logzurnal();

  ELSE
    DROP TRIGGER IF EXISTS mdannaklzurnal ON mdannakl;
    DROP TRIGGER IF EXISTS mdanodpisyzurnal ON mdanodpisy;
    DROP TRIGGER IF EXISTS mleasingzurnal ON mleasing;
    DROP TRIGGER IF EXISTS mmajetekzurnal ON mmajetek;
    DROP TRIGGER IF EXISTS msazbyzurnal ON msazby;
    DROP TRIGGER IF EXISTS msplatkalzurnal ON msplatkal;
    DROP TRIGGER IF EXISTS mtypleaszurnal ON mtypleas;
    DROP TRIGGER IF EXISTS mtypmajzurnal ON mtypmaj;
    DROP TRIGGER IF EXISTS mucetodpisyzurnal ON mucetodpisy;
    DROP TRIGGER IF EXISTS mudalostizurnal ON mudalosti;
    DROP TRIGGER IF EXISTS mumistenizurnal ON mumisteni;
    DROP TRIGGER IF EXISTS mzapujckyzurnal ON mzapujcky;
  END IF;
END;
$BODY$
LANGUAGE 'plpgsql' VOLATILE;
