<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
     xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java">
    <xsl:output method="xml" indent="yes" encoding="utf-8" />

    <xsl:template match="CASH_DOCUMENTS">
    
	<winstrom>
		<xsl:apply-templates select="CASH_DOCUMENT"/>
	</winstrom>
    </xsl:template>
<!--
flexibee2xml -t prodejni-kasa-in.xslt -x POKLDOKL.xml -o prodejni-kasa.xml
-->

    <xsl:template match="CASH_DOCUMENT">
        
        <xsl:choose>
            <xsl:when test="HEAD/CAVH_TYPE = '0'">
                <faktura-vydana>
                    <prodejka>true</prodejka>
                    <xsl:if test="HEAD/GLOB_OFFER = '0' or HEAD/CAVH_CANCEL = '1'">
                        <xsl:attribute name="action">storno</xsl:attribute>
                    </xsl:if>
                    <id>ext:GS-KASA-D:<xsl:value-of select="HEAD/FILIALKA_CODE"/>-<xsl:value-of select="HEAD/YEARDOC_ORDER"/></id>
                    <id>code:<xsl:value-of select="HEAD/FILIALKA_CODE"/>-<xsl:value-of select="HEAD/YEARDOC_ORDER"/></id>
                    <kod><xsl:value-of select="HEAD/FILIALKA_CODE"/>-<xsl:value-of select="HEAD/YEARDOC_ORDER"/></kod>
                    <typDokl>code:PRODEJ-<xsl:value-of select="HEAD/FILIALKA_CODE"/></typDokl>
                    <!--DOCSERIES_CODE>A110</DOCSERIES_CODE-->
                    <!--DOCSERIES_DESC>Tržbová pokladna</DOCSERIES_DESC-->
                    
                    <datVyst><xsl:value-of select="HEAD/CAVH_ACCOUNT_DATE"/></datVyst>
                    <popis><xsl:value-of select="HEAD/CAVH_SUBJECT"/></popis>
                    <nazFirmy><xsl:value-of select="HEAD/CAVH_RECEIVER"/></nazFirmy>
                                        
                    <!-- CAVH_TYPE = typ dokladu (0=Příjmový, 1=Výdajový); SmallInt; -->
                    <!--xsl:choose>
                        <xsl:when test="HEAD/CAVH_TYPE = '0'">
                        </xsl:when>
                        <xsl:when test="HEAD/CAVH_TYPE = '1'">
                        </xsl:when>
                    </xsl:choose-->
                    
                    <!--CAVH_TOTAL_SUM>117100.00</CAVH_TOTAL_SUM-->
                    <kurz><xsl:value-of select="java:flexibee.Tool.parseMoney(HEAD/CAVH_RATE)"/></kurz>
                    <mena>code:<xsl:value-of select="HEAD/CURR_CODE"/></mena>
                 
<!--                    <typUcOp>code:<xsl:value-of select="HEAD/ACCOD_CODE"/></typUcOp> -->
                 
                    <polozkyFaktury removeAll="true">
                        <xsl:for-each select="ITEMS/ITEM">
                            <faktura-vydana-polozka>
                                <typPolozkyK>typPolozky.ucetni</typPolozkyK>
                                <cisRad><xsl:value-of select="CAVI_NUMBER"/></cisRad>
                                <nazev><xsl:value-of select="CAVI_DESCRIPTION"/></nazev>
                                <sumZkl><xsl:value-of select="java:flexibee.Tool.parseMoney(CAVI_BASEVAT)"/></sumZkl>
                                <sumDph><xsl:value-of select="java:flexibee.Tool.parseMoney(CAVI_VAT)"/></sumDph>
                                <sumCelkem><xsl:value-of select="java:flexibee.Tool.parseMoney(CAVI_SUM)"/></sumCelkem>
                                
                                <!-- CAVI_VAT_CALCUL = způsob výpočtu DPH (1=Zdola, 2=Shora); SmallInt; P -->
                                <xsl:choose>
                                    <xsl:when test="CAVI_VAT_CALCUL = '1'">
                                        <typCenyDphK>typCeny.bezDph</typCenyDphK>
                                    </xsl:when>
                                    <xsl:when test="CAVI_VAT_CALCUL = '2'">
                                        <typCenyDphK>typCeny.sDphKoef</typCenyDphK>
                                    </xsl:when>
                                </xsl:choose>
                                
                                <szbDph><xsl:value-of select="java:flexibee.Tool.parseMoney(VAT_TARIFF)"/></szbDph>
                                <xsl:choose>
                                    <xsl:when test="VAT_CLASS = '0'">
                                        <typSzbDphK>typSzbDph.dphOsv</typSzbDphK>
                                    </xsl:when>
                                    <xsl:when test="VAT_CLASS = '1'">
                                        <typSzbDphK>typSzbDph.dphSniz</typSzbDphK>
                                    </xsl:when>
                                    <xsl:when test="VAT_CLASS = '2'">
                                        <typSzbDphK>typSzbDph.dphZakl</typSzbDphK>
                                    </xsl:when>
                                </xsl:choose>
                                
                                <!--ACVAT_CODE>UZP2</ACVAT_CODE-->
                                <!--ACVAT_DESC>20.0%: UZP-Uskutečněné zdanitelné plnění</ACVAT_DESC-->
                                <!--
                                <kopTypUcOp>false</kopTypUcOp>
                                <typUcOp>code:<xsl:value-of select="ACROW_CODE"/></typUcOp>
                                -->
                               <!-- <kopStred>false</kopStred>
                                <stredisko>code:<xsl:value-of select="DEPART_CODE"/></stredisko>
                                -->
                                <!--ACEXCP_CODE /-->
                                <!--ACEXCP_DESC /-->
                            </faktura-vydana-polozka>
                        </xsl:for-each>
                    </polozkyFaktury>
                    
                </faktura-vydana>
            </xsl:when>
        </xsl:choose>
    </xsl:template>

</xsl:stylesheet>