<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java">
 <xsl:output method="xml" indent="yes" encoding="utf-8" />
 <xsl:template match="MoneyData">
  <winstrom version="1.0">
    <xsl:apply-templates select="./SeznamUcOsnov/UcOsnova"/>
  </winstrom>
 </xsl:template>
 
 <xsl:template match="UcOsnova">
  <!-- pripadne zalozeni neexistujici standardni ucetni osnovy -->
  <ucetni-osnova update="ignore">
    <id>code:<xsl:value-of select="substring(Ucet, 1, 3)"/></id>
    <kod><xsl:value-of select="substring(Ucet, 1, 3)"/></kod>
    <nazev><xsl:value-of select="Nazev"/></nazev>
  </ucetni-osnova>
  
  <!-- zalozeni zaznamu v uctovem rozvrhu -->
  <ucet update="ignore">
    <id>ext:mS3ucet:<xsl:value-of select="Ucet"/></id>
    <id>code:<xsl:value-of select="Ucet"/></id>
    <kod><xsl:value-of select="Ucet"/></kod>
    <nazev><xsl:value-of select="Nazev"/></nazev>
    
    <!--<danovy-->
    <saldo>
      <xsl:choose>
        <xsl:when test="Saldo = 0">false</xsl:when>
        <xsl:otherwise>true</xsl:otherwise>
      </xsl:choose>
    </saldo>
    
    <typUctuK>
      <xsl:choose>
        <xsl:when test="DruhUctu = 1 and Vnitro = 0">typUctu.rozvahovy</xsl:when>
        <xsl:when test="DruhUctu = 1 and Vnitro = 1">typUctu.vnitropodnikovy</xsl:when>
        <xsl:when test="DruhUctu = 2">typUctu.vysledkovy</xsl:when>
        <xsl:when test="DruhUctu = 3">typUctu.zaverkovy</xsl:when>
        <xsl:when test="DruhUctu = 4">typUctu.podrozvahovy</xsl:when>
      </xsl:choose>
    </typUctuK>
    
    <druhUctuK>
      <xsl:choose>
        <xsl:when test="DruhUctu = 1 and UcetTyp = 1">druhUctu.aktivni</xsl:when>
        <xsl:when test="DruhUctu = 1 and UcetTyp = 2">druhUctu.pasivni</xsl:when>
        <xsl:when test="DruhUctu = 2 and UcetTyp = 3">druhUctu.naklady</xsl:when>
        <xsl:when test="DruhUctu = 2 and UcetTyp = 4">druhUctu.vynosy</xsl:when>
      </xsl:choose>
    </druhUctuK>
    
    <stdUcet><xsl:value-of select="substring(Ucet, 1, 3)"/></stdUcet>
  </ucet>
 </xsl:template>
</xsl:stylesheet>

