<?xml version="1.0" encoding="utf-8" ?>
<!-- 
 musí se použít pro import zatim restAPI 
 curl -v -u admin:heslo -X POST - -data-binary @parovani-uhrad-in.xml -H "Content-Type: application/xml" http://localhost:5434/c/firma/parovani-uhrad.xml 
 -->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java" >
  <xsl:output method="xml" indent="yes" encoding="utf-8" />
  <xsl:template match="winstrom">
    <winstrom version="1.0"  atomic="false">
      
     <xsl:apply-templates select="parovani-uhrad"/>
      
      
    </winstrom>
  </xsl:template>




    <!--
	UUID_DOKLAD; 
	ID_DOKLADU;
	DATUM_PLATBY;
	CASTKA;
	ID_DOKLAD_TYP;
	ID_PLAT_DOKLADU;
	UUID_DOKLAD_X_ZBOZI
    -->
    
  <xsl:template match="parovani-uhrad">
    
    <xsl:if test="CASTKA != '0'">
	<pokladni-pohyb>
    	    <id>ext:SOFIX:UHRADA_<xsl:value-of select="UUID_DOKLAD_X_ZBOZI"/>_<xsl:value-of select="UUID_DOKLAD"/></id>
	    <id>code:<xsl:value-of select="ID_DOKLADU"/>_<xsl:value-of select="ID_PLAT_DOKLADU"/></id>
	    <typDokl>code:<xsl:value-of select="java:flexibee.Tool.toUpper(java:flexibee.Tool.params('pokladna'))"/></typDokl>
	    <kod><xsl:value-of select="ID_DOKLADU"/>_<xsl:value-of select="ID_PLAT_DOKLADU"/></kod>
	    <datVyst><xsl:value-of select="java:flexibee.Tool.parseDate(DATUM_PLATBY, 'd.M.y')"/></datVyst>
	    <cisDosle><xsl:value-of select="ID_DOKLADU"/></cisDosle>
	    <typUcOp>code:ÚHRADA FA VYDANÉ</typUcOp>
	    <bezPolozek>true</bezPolozek>
	    <popis>Úhrada faktur ze systému SOFIX (automatický import)  - <xsl:value-of select="ID_PLAT_DOKLADU"/></popis>
	    <sumOsv><xsl:value-of select="java:flexibee.Tool.parseMoney(CASTKA)"/></sumOsv>
	    <sumZklZakl>0</sumZklZakl>


    	    <sparovani>
		<xsl:choose>
	    	    <xsl:when test="ID_DOKLAD_TYP = 'PFA'">
	        	<uhrazovanaFak type="faktura-prijata">ext:SOFIX:<xsl:value-of select="UUID_DOKLAD"/></uhrazovanaFak>
		    </xsl:when>
		    <xsl:otherwise>
	        	<uhrazovanaFak type="faktura-vydana">ext:SOFIX:<xsl:value-of select="UUID_DOKLAD"/></uhrazovanaFak>
		    </xsl:otherwise>
		</xsl:choose>
        	<zbytek>castecnaUhrada</zbytek>
    	    </sparovani>
	</pokladni-pohyb>
    </xsl:if>
    
  </xsl:template>
</xsl:stylesheet>