<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
     xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java"
>
    <xsl:output method="xml" indent="yes" encoding="utf-8" />

    <xsl:template match="/Root">
        <winstrom version="1.0">
            <xsl:apply-templates select="Seznam_firem"/>
        </winstrom>
    </xsl:template>

    <xsl:template match="/Seznam_firem">
        <winstrom version="1.0">
            <xsl:apply-templates select="Seznam_firem"/>
        </winstrom>
    </xsl:template>

<!--
.\flexibee2xml.exe -t adresar.in.xslt -x adresar.out.xml -o vystup.xml 2>a.out
kod, nazev
-->

    <xsl:template match="Seznam_firem">
        <adresar>
            <id>ext:4DD-ADR:<xsl:value-of select="java:flexibee.Tool.toUpper(Číslo_firmy)"/></id>
            <id>code:<xsl:value-of select="java:flexibee.Tool.toUpper(Číslo_firmy)"/></id>
            <kod><xsl:value-of select="java:flexibee.Tool.toUpper(Číslo_firmy)"/></kod>
            <xsl:choose>
                <xsl:when test="Název != ''">
                    <nazev><xsl:value-of select="Název"/></nazev>
                </xsl:when>
                <xsl:otherwise>
                    <nazev><xsl:value-of select="Číslo_firmy"/></nazev>
                </xsl:otherwise>
            </xsl:choose>
            <!--<nazev><xsl:value-of select="Název"/></nazev>-->

            <ulice><xsl:value-of select="Ulice"/></ulice>
            <mesto><xsl:value-of select="Sídlo_firmy"/></mesto>
            <tel><xsl:value-of select="Telefon"/></tel>
            <fax><xsl:value-of select="FAX"/></fax>
            <ic><xsl:value-of select="IČO"/></ic>
            <dic><xsl:value-of select="DIČ"/></dic>
            <psc><xsl:value-of select="PSČ"/></psc>
            <email><xsl:value-of select="Email"/></email>
            <www><xsl:value-of select="Web"/></www>

            <xsl:choose>
                <xsl:when test="Neplátce_DPH = 'Pravda' or Neplátce_DPH = 'true'">
                    <platceDph>false</platceDph>
                </xsl:when>
                <xsl:otherwise>
                    <platceDph>true</platceDph>
                </xsl:otherwise>
            </xsl:choose>

            <xsl:choose>
                <xsl:when test="Druh_firmy = 'ostatní'">
                    <typVztahuK>typVztahu.vsechno</typVztahuK>
                </xsl:when>
                <xsl:when test="Druh_firmy = 'Dodavatel a odběrat.'">
                    <typVztahuK>typVztahu.odberDodav</typVztahuK>
                </xsl:when>
                <xsl:when test="Druh_firmy = 'Dodavatel'">
                    <typVztahuK>typVztahu.dodavatel</typVztahuK>
                </xsl:when>
                <xsl:when test="Druh_firmy = 'odběratel'">
                    <typVztahuK>typVztahu.odberatel</typVztahuK>
                </xsl:when>
                <xsl:otherwise>
                    <typVztahuK>typVztahu.vsechno</typVztahuK>
                </xsl:otherwise>
            </xsl:choose>
                
            <xsl:choose>
                <xsl:when test="normalize-space(translate(java:flexibee.Tool.toUpper(Stát), 'ČĆ', 'CC' )) = 'CR'">
                    <stat>code:CZ</stat>
                </xsl:when>
                <xsl:when test="normalize-space(java:flexibee.Tool.toUpper(Stát)) = 'CZ'">
                    <stat>code:CZ</stat>
                </xsl:when>
                <xsl:when test="normalize-space(java:flexibee.Tool.toUpper(Stát)) = ''">
                    <stat>code:CZ</stat>
                </xsl:when>
                <xsl:when test="normalize-space(java:flexibee.Tool.toUpper(Stát)) = 'CZECH REPUBLIC'">
                    <stat>code:CZ</stat>
                </xsl:when>
                <xsl:when test="normalize-space(java:flexibee.Tool.toUpper(Stát)) = 'DEUTSCHLAND'">
                    <stat>code:DE</stat>
                </xsl:when>
                <xsl:otherwise>
                    <stat></stat>
                </xsl:otherwise>
            </xsl:choose>

            <splatDny><xsl:value-of select="substring-before(Plat.podmínky, ' ')"/></splatDny>
            <poznam><xsl:value-of select="Poznámka"/></poznam>
            <popis><xsl:value-of select="Informace"/></popis>
        </adresar>
    </xsl:template>

</xsl:stylesheet>
