<?xml version="1.0" encoding="utf-8" ?>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java" >
  
  <xsl:output method="xml" indent="yes" encoding="utf-8" />
  
      <xsl:variable name="radkyDoc" select="document('ucetni-doklady-radky.xml')"/>
      <xsl:key name="cisloKey" match="Řádky_úč.dokl." use="Číslo_dokladu"/>

    
    
    <!--
/usr/share/flexibee/bin/  

flexibee2xml -x ucetni-doklady.xml -t interni-doklad-in.xslt -o interni-doklad.xml  

-->

    <xsl:template match="/Root|/Účetní_doklady">
        <winstrom version="1.0">
<!--	    <xsl:apply-templates select="*[local-name() = 'Účetní_doklady' and position() &lt; 3]"/>  -->
            <xsl:apply-templates select="Účetní_doklady"/> 
        </winstrom>
    </xsl:template>

    <!-- 	
    <Účetní_doklady>
    		<Číslo_dokl.>1</Číslo_dokl.>             X
		<Datum>05.04.95</Datum>                  X
		<Úč.období>199504</Úč.období>
		<Obsahuje>vyúčt. Celní úřad</Obsahuje>   X
		<Daňový>True</Daňový>
		<Na_vstupu>True</Na_vstupu>
		<Exportováno>False</Exportováno>
		<Odpočet_DPH>0</Odpočet_DPH>
		<Částka>108638</Částka>                  X
		<Zákl.sazba_DPH>0</Zákl.sazba_DPH>
		<Sníž.sazba_DPH>0</Sníž.sazba_DPH>
		<Druh_země></Druh_země>
		<Poznámka></Poznámka>                    X
		<Zvláštní_režim>False</Zvláštní_režim>
	</Účetní_doklady>
	-->
    
  <xsl:template match="Účetní_doklady">
          <xsl:variable name="cislo" select="Číslo_dokl."/>
          <xsl:variable name="uc_obdobi" select="Úč.období"/>
          <xsl:variable name="obsahuje" select="Obsahuje"/>
          <xsl:variable name="poznamka" select="Poznámka"/>

    <xsl:if test="java:flexibee.Tool.substring(Úč.období, 4, 6) != '13'">

		<xsl:for-each select="$radkyDoc">
	  		<xsl:for-each select="key('cisloKey',$cislo)">

        <interni-doklad>
          <id>ext:4DD-INT:<xsl:value-of select="$cislo"/>-<xsl:value-of select="java:flexibee.Tool.toUpper(Řádek)"/></id>
          <popis><xsl:value-of select="java:flexibee.Tool.trim($obsahuje)"/></popis>
          <typDokl>code:HISTORIE</typDokl>
          <datVyst><xsl:value-of select="java:flexibee.Tool.substring($uc_obdobi, 0, 4)"/>-<xsl:value-of select="java:flexibee.Tool.substring($uc_obdobi, 4, 6)"/>-01</datVyst>
          <cisDosle><xsl:value-of select="Prvotní_doklad"/></cisDosle>
          <varSym><xsl:value-of select="Číslo_faktury"/></varSym>

	    <poznam><xsl:value-of select="java:flexibee.Tool.toUpper($poznamka)"/>, <xsl:if test="Prvotní_doklad != ''">Prvotní doklad: <xsl:value-of select="Prvotní_doklad"/></xsl:if><xsl:if test="Číslo_faktury != ''">, Číslo faktury: <xsl:value-of select="Číslo_faktury"/></xsl:if>
                  </poznam>
              

	    
                  <xsl:if test="java:flexibee.Tool.trim(Účet_MD) != ''">
                    <primUcet>code:<xsl:value-of select="java:flexibee.Tool.trim(Účet_MD)"/></primUcet>
                  </xsl:if>
                  <xsl:if test="java:flexibee.Tool.trim(Účet_DAL) != ''">
                    <protiUcet>code:<xsl:value-of select="java:flexibee.Tool.trim(Účet_DAL)"/></protiUcet>
                  </xsl:if>

                  <xsl:choose>
                    <xsl:when test="java:flexibee.Tool.trim(Středisko_DAL) != ''">
                      <stredisko>code:<xsl:value-of select="java:flexibee.Tool.toUpper(java:flexibee.Tool.trim(Středisko_DAL))"/></stredisko>
                    </xsl:when>
                    <xsl:when test="java:flexibee.Tool.trim(Středisko_MD) != ''">
                      <stredisko>code:<xsl:value-of select="java:flexibee.Tool.toUpper(java:flexibee.Tool.trim(Středisko_MD))"/></stredisko>
                    </xsl:when>
                    <xsl:otherwise>
                      <!-- středisko je povinné - jinak se doklad nezaúčtuje -->
                      <stredisko>code:C</stredisko>                    
                    </xsl:otherwise>
                  </xsl:choose>
                  <xsl:choose>
                    <xsl:when test="java:flexibee.Tool.trim(Zakázka_DAL) != ''">
                      <zakazka if-not-found="null">code:<xsl:value-of select="java:flexibee.Tool.toUpper(java:flexibee.Tool.trim(Zakázka_DAL))"/></zakazka>
                    </xsl:when>
                    <xsl:when test="java:flexibee.Tool.trim(Zakázka_MD) != ''">
                      <zakazka if-not-found="null">code:<xsl:value-of select="java:flexibee.Tool.toUpper(java:flexibee.Tool.trim(Zakázka_MD))"/></zakazka>
                    </xsl:when>
                  </xsl:choose>


         <polozkyIntDokladu>
	  		
	  		<!--
	  		<Řádky_úč.dokl.>
                      <Číslo_dokladu>2</Číslo_dokladu>
                      <Řádek>201</Řádek>
                      <Operace>Pv</Operace>
                      <Popis_úč.operac>P1/vý/Zeležářstv/Drobný nákup</Popis_úč.operac>    X
                      <Účet_MD>50101</Účet_MD>           X
                      <Středisko_MD>100</Středisko_MD>   X
                      <Zakázka_MD></Zakázka_MD>          X
                      <Účet_DAL>21100</Účet_DAL>         X
                      <Středisko_DAL></Středisko_DAL>    X
                      <Zakázka_DAL></Zakázka_DAL>        X
                      <Částka>137,7</Částka>             X
                      <Datum>14.04.95</Datum>
                      <Rozpis_DPH>0</Rozpis_DPH>
                      <Číslo_faktury></Číslo_faktury>         X
                      <Prvotní_doklad>1/611</Prvotní_doklad>  X
                      <Zařízení_MD></Zařízení_MD>
                      <Zařízení_DAL></Zařízení_DAL>
                      <Zaúčtováno_dne>00.00.00</Zaúčtováno_dne>             
                      <Číslo_firmy></Číslo_firmy>
              </Řádky_úč.dokl.>
        -->
	  		
	  	      <interni-doklad-polozka>
                  <id>ext:4DD-INTPOL:<xsl:value-of select="java:flexibee.Tool.toUpper(Číslo_dokladu)"/>-<xsl:value-of select="java:flexibee.Tool.toUpper(Řádek)"/></id>
                  <typPolozkyK>typPolozky.ucetni</typPolozkyK>
                  <nazev><xsl:value-of select="Popis_úč.operac"/></nazev>
                  <mnozMj>1</mnozMj>
                  
                  <sumDph>0.0</sumDph>
                  <sumCelkem><xsl:value-of select="java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(Částka), '2')"/></sumCelkem>

			 </interni-doklad-polozka>
         </polozkyIntDokladu>


        </interni-doklad>

      		</xsl:for-each>
          </xsl:for-each>

    </xsl:if>

  </xsl:template>
</xsl:stylesheet>
