<?xml version="1.0" encoding="utf-8" ?>
<!DOCTYPE tutorials [
    <!ENTITY under "">
]>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
     xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java"
>

    
    <xsl:output method="xml" indent="yes" encoding="utf-8" />
    
    <xsl:variable name="radkyDoc" select="document('knihavf-radky.xml')"/>

    <xsl:key name="cisloKey" match="&under;Řádky_vyd.fa" use="&under;Č.faktury"/>

    

    <xsl:template match="/Root|/Kniha_VF">
        <winstrom version="1.0">
            <!--
            Rada musi byt v samostatnem xml protoze nejde nacist cislo dokladu z transient rady
            <rada-pokladni-pohyb>
              <id>code:MIGRACNI-PRIJEM</id>
              <kod>MIGRACNI-PRIJEM</kod>
              <nazev>Migracni rada pro prijem - pro uhrady faktur pri migraci</nazev>
            </rada-pokladni-pohyb>
            <rada-pokladni-pohyb>
              <id>code:MIGRACNI-VYDEJ</id>
              <kod>MIGRACNI-VYDEJ</kod>
              <nazev>Migracni rada pro vydej - pro uhrady faktur pri migraci</nazev>
            </rada-pokladni-pohyb>
            -->
            <pokladna update="ignore">
              <id>ext:4DD-POKBSP:MIGRACNI</id>
              <id>code:MIGRACNI</id>
              <kod>MIGRACNI</kod>
              <nazev>Migracni pokladna - pro uhrady faktur pri migraci</nazev>
              <radaPrijem>code:POKLADNA+</radaPrijem>
              <radaVydej>code:POKLADNA-</radaVydej>
            </pokladna>
            <typ-pokladni-pohyb update="ignore">
              <id>ext:4DD-POKTYP:MIGRACNI</id>
              <id>code:MIGRACNI</id>
              <kod>MIGRACNI</kod>
              <nazev>Migracni typ pokladniho dokladu - pro uhrady faktur pri migraci</nazev>
              <ucetni>false</ucetni>
	      <generovatSkl>false</generovatSkl>
            </typ-pokladni-pohyb>

<!--	    <xsl:apply-templates select="*[local-name() = 'Kniha_VF' and position() &lt; 100]"/> -->
            <xsl:apply-templates select="Kniha_VF"/> 
        </winstrom>
    </xsl:template>

<!--
/usr/share/flexibee/bin/flexibee2xml -t knihavf-in.xslt -x knihavf.xml -o faktury-vydane.xml

.\flexibee2xml.exe -t adresar.in.xslt -x adresar.out.xml -o vystup.xml 2>a.out
kod, nazev
-->
    
    <!-- Toto je obsah. Je ale pro starší verzi, která české znaky na začátku slova exportuje bez podtržítka před
     
     <Kniha_PF>
        <Číslo_faktury>346</Číslo_faktury>
        <Datum_splatn.>1994-08-10T00:00:00</Datum_splatn.>
        <Úč.období>190000</Úč.období>
        <Dodavatel>2010</Dodavatel>
        <Číslo_bank.spoj>19-32102-191/0100</Číslo_bank.spoj>
        <Var.symbol>809030131</Var.symbol>
        <Konst.symbol>0008</Konst.symbol>
        <Obsahuje>telefonní poplatek</Obsahuje>
        <Částka>25266</Částka>
        <Úč.doklad>2</Úč.doklad>
        <Ind.přík.k_úh.>1</Ind.přík.k_úh.>
        <Ind.likvidace>1</Ind.likvidace>
        <Ind.párování>1</Ind.párování>
        <Typ_dodávky>1</Typ_dodávky>
        <Zbývá_zaplatit>0</Zbývá_zaplatit>
        <Datum_pořízení>1994-08-03T00:00:00</Datum_pořízení>
        <DPH_ve_sníž.sazbě>1202,7</DPH_ve_sníž.sazbě>
        <DPH_v_zákl.sazbě>0</DPH_v_zákl.sazbě>
        <Zpracoval>2</Zpracoval>
        <Typ_faktury>2</Typ_faktury>
        <Základ_v_zákl.sazbě>0</Základ_v_zákl.sazbě>
        <Základ_ve_sníž.sazbě>24054</Základ_ve_sníž.sazbě>
        <Základ_bez_daně>9,3</Základ_bez_daně>
        <Středisko></Středisko>
        <Uhrazeno_jinak>25266</Uhrazeno_jinak>
        <Exportováno>Nepravda</Exportováno>
        <Kód_měny></Kód_měny>
        <Kurs>0</Kurs>
        <Částka_v_měně>0</Částka_v_měně>
        <Odsouhlasena>Nepravda</Odsouhlasena>
        <Zakázka></Zakázka>
        <Datum_likvidace>1994-08-03T00:00:00</Datum_likvidace>
        <Spárována_zál.>Nepravda</Spárována_zál.>
        <Vratka_DPH>Nepravda</Vratka_DPH>
        <Platba>0</Platba>
        <Kurs_na_EUR>0</Kurs_na_EUR>
        <Den_zdan.plnění>1994-08-03T00:00:00</Den_zdan.plnění>
        <Odpočet_DPH>0</Odpočet_DPH>
        <Spec.symbol></Spec.symbol>
        <Poznámka></Poznámka>
        <Ověřil></Ověřil>
        <Platbu_povolil></Platbu_povolil>
        <Smlouva></Smlouva>
        <Řádek_zákl.sazby_DPH>0</Řádek_zákl.sazby_DPH>
        <Řádek_sníž.sazby_DPH>0</Řádek_sníž.sazby_DPH>
        <Zákl.sazba_DPH>23</Zákl.sazba_DPH>
        <Sníž.sazba_DPH>5</Sníž.sazba_DPH>
        <Kurs_k_31.12.>0</Kurs_k_31.12.>
        <Datum_uplatnění_DPH>1994-08-03T00:00:00</Datum_uplatnění_DPH>
     </Kniha_PF>     
     -->

    <xsl:template match="Kniha_VF">
      <xsl:if test="java:flexibee.Tool.parseMoney(&under;Úč.období) &lt; 201109 and java:flexibee.Tool.parseMoney(&under;Úč.období) &gt;= 201101 ">
       
        
        <xsl:variable name="cislo" select="&under;Č.faktury"/>
        
        <typ-faktury-vydane update="ignore">
            <id>ext:4DD-FAVTYP:<xsl:value-of select="java:flexibee.Tool.toUpper(Typ_faktury)"/></id>
            <id>code:<xsl:value-of select="java:flexibee.Tool.toUpper(Typ_faktury)"/></id>
            <kod><xsl:value-of select="java:flexibee.Tool.toUpper(Typ_faktury)"/></kod>
            <ucetni>false</ucetni>
            <generovatSkl>false</generovatSkl>
            <xsl:choose>
                 <xsl:when test="java:flexibee.Tool.toUpper(Typ_faktury) = '1'">
                      <nazev>Migrovana Faktura - <xsl:value-of select="java:flexibee.Tool.toUpper(Typ_faktury)"/></nazev>
                      <typDoklK>typDokladu.faktura</typDoklK>
                 </xsl:when>
                 <xsl:when test="java:flexibee.Tool.toUpper(Typ_faktury) = '2'">
                      <nazev>Migrovana Proforma - <xsl:value-of select="java:flexibee.Tool.toUpper(Typ_faktury)"/></nazev>
                      <typDoklK>typDokladu.proforma</typDoklK>
                 </xsl:when>
                 <xsl:when test="java:flexibee.Tool.toUpper(Typ_faktury) = '3'">
                      <nazev>Migrovana Zaloha - <xsl:value-of select="java:flexibee.Tool.toUpper(Typ_faktury)"/></nazev>
                      <typDoklK>typDokladu.zalohFaktura</typDoklK>
                 </xsl:when>
                 <xsl:when test="java:flexibee.Tool.toUpper(Typ_faktury) = '9'">
                      <nazev>Migrovany ZDD - <xsl:value-of select="java:flexibee.Tool.toUpper(Typ_faktury)"/></nazev>
                      <typDoklK>typDokladu.zdd</typDoklK>
                 </xsl:when>
                 <xsl:when test="java:flexibee.Tool.toUpper(Typ_faktury) = '10'">
                      <nazev>Migrovany Dobropis - <xsl:value-of select="java:flexibee.Tool.toUpper(Typ_faktury)"/></nazev>
                      <typDoklK>typDokladu.dobropis</typDoklK>
                 </xsl:when>
                 <xsl:otherwise>
                 </xsl:otherwise>
            </xsl:choose>
        </typ-faktury-vydane>
        <bankovni-ucet update="ignore">
            <id>ext:4DD-BANBSP:<xsl:value-of select="java:flexibee.Tool.toUpper(Bank.spojení)"/></id>
            <id>code:<xsl:value-of select="java:flexibee.Tool.toUpper(Bank.spojení)"/></id>
            <kod><xsl:value-of select="java:flexibee.Tool.toUpper(Bank.spojení)"/></kod>
            <nazev><xsl:value-of select="java:flexibee.Tool.toUpper(Bank.spojení)"/></nazev>
            <buc><xsl:value-of select="java:flexibee.Tool.split(Bank.spojení, '/', 0)"/></buc>
            <smerKod if-not-found="null">code:<xsl:value-of select="java:flexibee.Tool.split(Bank.spojení, '/', 1)"/></smerKod>
        </bankovni-ucet>
        <faktura-vydana>
            <id>ext:4DD-VF:<xsl:value-of select="java:flexibee.Tool.toUpper(&under;Č.faktury)"/></id>
            <typDokl>code:<xsl:value-of select="java:flexibee.Tool.toUpper(Typ_faktury)"/></typDokl>
            <kod><xsl:value-of select="java:flexibee.Tool.toUpper(&under;Č.faktury)"/></kod>
            <varSym><xsl:value-of select="Var.symbol"/></varSym>
            <xsl:if test="Datum_splat. != '0000-00-00'">
            <datSplat><xsl:value-of select="java:flexibee.Tool.parseDate(Datum_splat., 'd.M.y')"/></datSplat>
            </xsl:if>
            <datVyst><xsl:value-of select="java:flexibee.Tool.parseDate(Datum_pořízení, 'd.M.y')"/></datVyst>

            <!-- duzp jsou tady obe protoze musi byt stejne -->
	    <xsl:if test="Den_zdan.plnění != '0000-00-00'">
	     <datReal><xsl:value-of select="java:flexibee.Tool.parseDate(Den_zdan.plnění, 'd.M.y')"/></datReal>
        	<duzpUcto><xsl:value-of select="java:flexibee.Tool.parseDate(Den_zdan.plnění, 'd.M.y')"/></duzpUcto>
        	<duzpPuv><xsl:value-of select="java:flexibee.Tool.parseDate(Den_zdan.plnění, 'd.M.y')"/></duzpPuv>
	    </xsl:if>

            <xsl:if test="Odběratel != ''">
                <firma if-not-found="null">code:<xsl:value-of select="Odběratel"/></firma>
            </xsl:if>                
            <konSym if-not-found="null">code:<xsl:value-of select="Konst.symbol"/></konSym>
            <bspBan if-not-found="null">code:<xsl:value-of select="Bank.spojení"/></bspBan>
            <zdrojProSkl>false</zdrojProSkl>
            <generovatSkl>false</generovatSkl>

            <xsl:choose>
                 <!-- kod meny 1 je ocividne CZK -->
                 <xsl:when test="java:flexibee.Tool.toUpper(Kód_měny) != '' and java:flexibee.Tool.toUpper(Kód_měny) != '1' and Kurs != '' and Kurs != '0'">
                      <xsl:choose>
                           <xsl:when test="java:flexibee.Tool.toUpper(Kód_měny) = '3'">
                                <mena>code:EUR</mena>
                           </xsl:when>
                           <xsl:otherwise>
                                <mena>code:<xsl:value-of select="java:flexibee.Tool.toUpper(Kód_měny)"/></mena>
                           </xsl:otherwise>
                      </xsl:choose>
                      <kurz><xsl:value-of select="java:flexibee.Tool.parseMoney(Kurs)"/></kurz>                      
                      <sumCelkemMen><xsl:value-of select="java:flexibee.Tool.round((java:flexibee.Tool.parseMoney(&under;Částka_po_zaokr) - java:flexibee.Tool.parseMoney(Zbývá_zaplatit)) div java:flexibee.Tool.parseMoney(Kurs), '2')"/></sumCelkemMen>
                 </xsl:when>
                 <xsl:otherwise>
                 </xsl:otherwise>
            </xsl:choose>

            <!--<bezPolozek>true</bezPolozek>-->
            <polozkyFaktury>
		<xsl:for-each select="$radkyDoc">
			<xsl:for-each select="key('cisloKey',$cislo)">
			    <faktura-vydana-polozka>
                                <id>ext:4DD-FAVPOL:<xsl:value-of select="java:flexibee.Tool.toUpper(&under;Č.faktury)"/>-<xsl:value-of select="java:flexibee.Tool.toUpper(&under;Řádek)"/></id>
                                <xsl:choose>
                                    <xsl:when test="java:flexibee.Tool.toUpper(Kód_položky) = '' or java:flexibee.Tool.toUpper(Kód_položky) = ' '">
                                        <typPolozkyK>typPolozky.ucetni</typPolozkyK>
                                    </xsl:when>
                                    <xsl:otherwise>
                                        <typPolozkyK>typPolozky.katalog</typPolozkyK>
                                        <cenik>code:<xsl:value-of select="java:flexibee.Tool.toUpper(Kód_položky)"/></cenik>
                                        <eanKod><xsl:value-of select="java:flexibee.Tool.toUpper(Kód_EAN)"/></eanKod>
                                        <xsl:if test="Sklad = ''">
                                              <sklad>code:XXX_HISTORIE</sklad>
                                        </xsl:if>
                                        <xsl:if test="Sklad != ''">
                                              <sklad>code:<xsl:value-of select="java:flexibee.Tool.toUpper(Sklad)"/>_HISTORIE</sklad>
                                        </xsl:if>
                                    </xsl:otherwise>
                                </xsl:choose>
                                <nazev><xsl:value-of select="Název_položky"/></nazev>
				<xsl:choose> 
				    <xsl:when test="Množství != '0'">
                            		<mnozMj><xsl:value-of select="java:flexibee.Tool.parseMoney(Množství)"/></mnozMj>
				    </xsl:when>
				    <xsl:otherwise>
                            		<mnozMj>1</mnozMj>
				    </xsl:otherwise>
				</xsl:choose>
                                <!--<cenaMj><xsl:value-of select="java:flexibee.Tool.parseMoney(J.cena_prod.)"/></cenaMj>-->
                                <cenaMj>0.0</cenaMj>
                                <cenyRucne>true</cenyRucne>
                                <poznam>cena: <xsl:value-of select="java:flexibee.Tool.parseMoney(J.cena_prod.)"/>;\n <xsl:value-of select="Poznámka"/></poznam>
                                <zdrojProSkl>false</zdrojProSkl>
			    </faktura-vydana-polozka>
			</xsl:for-each>
                </xsl:for-each>
                <faktura-vydana-polozka>
                   <!-- osvobozeno -->
                   <id>ext:4DD-FAVPOL:<xsl:value-of select="java:flexibee.Tool.toUpper(&under;Č.faktury)"/>-OSV</id>
                   <typPolozkyK>typPolozky.ucetni</typPolozkyK>
                   <sumZkl><xsl:value-of select="java:flexibee.Tool.round((java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(&under;Částka_po_zaokr), '2') 
                       - java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(Základ_ve_sníž.sazbě), '2') 
                       - java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(DPH_ve_sníž.sazbě), '2')
                       - java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(Základ_v_zákl.sazbě), '2')
                       - java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(DPH_v_zákl.sazbě), '2')), '2')"/></sumZkl>
                   <sumDph>0.0</sumDph>
                   <sumCelkem><xsl:value-of select="java:flexibee.Tool.round((java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(&under;Částka_po_zaokr), '2') 
                       - java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(Základ_ve_sníž.sazbě), '2') 
                       - java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(DPH_ve_sníž.sazbě), '2')
                       - java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(Základ_v_zákl.sazbě), '2')
                       - java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(DPH_v_zákl.sazbě), '2')), '2')"/></sumCelkem>
                   <typSzbDphK>typSzbDph.dphOsv</typSzbDphK>
                </faktura-vydana-polozka>
                <faktura-vydana-polozka>
                   <!-- snizena sazba -->
                   <id>ext:4DD-FAVPOL:<xsl:value-of select="java:flexibee.Tool.toUpper(&under;Č.faktury)"/>-SNIZ</id>
                   <typPolozkyK>typPolozky.ucetni</typPolozkyK>
                   <sumZkl><xsl:value-of select="java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(Základ_ve_sníž.sazbě), '2')"/></sumZkl>
                   <sumDph><xsl:value-of select="java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(DPH_ve_sníž.sazbě), '2')"/></sumDph>
                   <sumCelkem><xsl:value-of select="java:flexibee.Tool.round((java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(Základ_ve_sníž.sazbě), '2')
                        + java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(DPH_ve_sníž.sazbě), '2')), '2')"/></sumCelkem>
                   <typSzbDphK>typSzbDph.dphSniz</typSzbDphK>
                </faktura-vydana-polozka>
                <faktura-vydana-polozka>
                   <!-- zakladni sazba -->
                   <id>ext:4DD-FAVPOL:<xsl:value-of select="java:flexibee.Tool.toUpper(&under;Č.faktury)"/>-ZAKL</id>
                   <typPolozkyK>typPolozky.ucetni</typPolozkyK>
                   <sumZkl><xsl:value-of select="java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(Základ_v_zákl.sazbě), '2')"/></sumZkl>
                   <sumDph><xsl:value-of select="java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(DPH_v_zákl.sazbě), '2')"/></sumDph>
                   <sumCelkem><xsl:value-of select="java:flexibee.Tool.round((java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(Základ_v_zákl.sazbě), '2')
                        + java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(DPH_v_zákl.sazbě), '2')), '2')"/></sumCelkem>
                   <typSzbDphK>typSzbDph.dphZakl</typSzbDphK>
                </faktura-vydana-polozka>
	    </polozkyFaktury>            

            <!--<sumCelkem><xsl:value-of select="java:flexibee.Tool.parseMoney(&under;Částka_po_zaokr)"/></sumCelkem>
            <sumOsv><xsl:value-of select="java:flexibee.Tool.round((java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(&under;Částka_po_zaokr), '2') 
                       - java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(Základ_ve_sníž.sazbě), '2') 
                       - java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(DPH_ve_sníž.sazbě), '2')
                       - java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(Základ_v_zákl.sazbě), '2')
                       - java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(DPH_v_zákl.sazbě), '2')), '2')"/></sumOsv>
            <sumZklSniz><xsl:value-of select="java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(Základ_ve_sníž.sazbě), '2')"/></sumZklSniz>
            <sumDphSniz><xsl:value-of select="java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(DPH_ve_sníž.sazbě), '2')"/></sumDphSniz>
            <sumZklZakl><xsl:value-of select="java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(Základ_v_zákl.sazbě), '2')"/></sumZklZakl>
            <sumDphZakl><xsl:value-of select="java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(DPH_v_zákl.sazbě), '2')"/></sumDphZakl>-->

            <!--<szbDphSniz><xsl:value-of select="java:flexibee.Tool.parseMoney(Sníž.sazba_DPH)"/></szbDphSniz>
            <szbDphZakl><xsl:value-of select="java:flexibee.Tool.parseMoney(Zákl.sazba_DPH)"/></szbDphZakl>-->
            
            <uvodTxt><xsl:value-of select="&under;Úvodní_text"/></uvodTxt>
            <zavTxt><xsl:value-of select="Doplň.text"/></zavTxt>
            <xsl:if test="Středisko != ''">
                <stredisko>code:<xsl:value-of select="Středisko"/></stredisko>
            </xsl:if>
            <xsl:if test="Zakázka != ''">
                <zakazka>code:<xsl:value-of select="java:flexibee.Tool.toUpper(Zakázka)"/></zakazka>
            </xsl:if>
            <popis><xsl:value-of select="Obsahuje"/>
			<xsl:if test="Den_zdan.plnění != Datum_pořízení">, DÚZP: <xsl:value-of select="Den_zdan.plnění"/></xsl:if>
	    </popis>

            <!-- 
              Hotovostni uhrada
              <hotovostni-uhrada>
                <pokladna>code:POKLADNA KČ</pokladna>
                <typDokl>code:STANDARD</typDokl>
                <castka>1000</castka>
                <datumUhrady>2011-01-01</datumUhrady>
              </hotovostni-uhrada>
            -->
            <xsl:choose>
              <!--<xsl:when test = "java:flexibee.Tool.round((java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(Základ_bez_daně), '2') 
                       + java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(Základ_ve_sníž.sazbě), '2') 
                       + java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(DPH_ve_sníž.sazbě), '2')
                       + java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(Základ_v_zákl.sazbě), '2')
                       + java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(DPH_v_zákl.sazbě), '2')
                       - java:flexibee.Tool.parseMoney(Zbývá_zaplatit)), '2') != 0">-->
              <xsl:when test = "java:flexibee.Tool.round((java:flexibee.Tool.parseMoney(&under;Částka_po_zaokr)- java:flexibee.Tool.parseMoney(Zbývá_zaplatit)), '2') != 0.0">
                <hotovostni-uhrada>
                   <uhrazujiciDokl>ext:4DD-VF-HU:<xsl:value-of select="java:flexibee.Tool.toUpper(&under;Č.faktury)"/></uhrazujiciDokl>
                   <pokladna>code:MIGRACNI</pokladna>
                   <typDokl>code:MIGRACNI</typDokl>
                   <xsl:choose>
                     <xsl:when test="java:flexibee.Tool.toUpper(Kód_měny) != ''">
                       <!--<castka><xsl:value-of select="java:flexibee.Tool.round((
                       (java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(Základ_bez_daně), '2') 
                       + java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(Základ_ve_sníž.sazbě), '2') 
                       + java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(DPH_ve_sníž.sazbě), '2')
                       + java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(Základ_v_zákl.sazbě), '2')
                       + java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(DPH_v_zákl.sazbě), '2')
                       - java:flexibee.Tool.parseMoney(Zbývá_zaplatit)) div java:flexibee.Tool.parseMoney(Kurs)
                       ), '2')"/></castka>-->
                       <castka><xsl:value-of select="java:flexibee.Tool.round((java:flexibee.Tool.parseMoney(&under;Částka_po_zaokr)- java:flexibee.Tool.parseMoney(Zbývá_zaplatit)) div java:flexibee.Tool.parseMoney(Kurs), '2')"/></castka>
                     </xsl:when>
                     <xsl:otherwise>          
                       <!--<castka><xsl:value-of select="java:flexibee.Tool.round((
                       java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(Základ_bez_daně), '2') 
                       + java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(Základ_ve_sníž.sazbě), '2') 
                       + java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(DPH_ve_sníž.sazbě), '2')
                       + java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(Základ_v_zákl.sazbě), '2')
                       + java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(DPH_v_zákl.sazbě), '2')
                       - java:flexibee.Tool.parseMoney(Zbývá_zaplatit))
                       , '2')"/></castka>-->
                       <castka><xsl:value-of select="java:flexibee.Tool.round((java:flexibee.Tool.parseMoney(&under;Částka_po_zaokr)- java:flexibee.Tool.parseMoney(Zbývá_zaplatit)), '2')"/></castka>
                     </xsl:otherwise>
                   </xsl:choose>
                   <xsl:choose>
                     <!--<xsl:when test="Datum_úhrady != '00.00.00'">-->
                     <xsl:when test="Datum_úhrady != '0000-00-00'">
                       <datumUhrady><xsl:value-of select="java:flexibee.Tool.parseDate(Datum_úhrady, 'd.M.y')"/></datumUhrady>
                     </xsl:when>
                     <xsl:when test="Datum_likvidace != '0000-00-00'">
                       <datumUhrady><xsl:value-of select="java:flexibee.Tool.parseDate(Datum_likvidace, 'd.M.y')"/></datumUhrady>
                     </xsl:when>
                     <xsl:otherwise>
                       <datumUhrady><xsl:value-of select="java:flexibee.Tool.parseDate(Datum_pořízení, 'd.M.y')"/></datumUhrady>
                     </xsl:otherwise>
                   </xsl:choose>
                </hotovostni-uhrada>
              </xsl:when>
              <xsl:when test = "(java:flexibee.Tool.parseMoney(Základ_bez_daně) + java:flexibee.Tool.parseMoney(Základ_ve_sníž.sazbě) + java:flexibee.Tool.parseMoney(DPH_ve_sníž.sazbě) + java:flexibee.Tool.parseMoney(Základ_v_zákl.sazbě) + java:flexibee.Tool.parseMoney(DPH_v_zákl.sazbě)) = 0">
                <stavUhrK>stavUhr.uhrazenoRucne</stavUhrK>
              </xsl:when>
              <xsl:otherwise>
              </xsl:otherwise>
            </xsl:choose>
        </faktura-vydana>
          </xsl:if>
    </xsl:template>

</xsl:stylesheet>
