<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
     xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java"
>
    <xsl:output method="xml" indent="yes" encoding="utf-8" />

    <xsl:template match="/Root">
        <winstrom version="1.0">
            <xsl:apply-templates select="Poč.stav_účtů"/>
        </winstrom>
    </xsl:template>

    <xsl:template match="/Poč.stav_účtů">
        <winstrom version="1.0">
<!--        	    <xsl:apply-templates select="*[local-name() = 'Poč.stav_účtů' and position() &lt; 200]"/> -->
        	    <xsl:apply-templates select="Poč.stav_účtů"/> 
        </winstrom>
    </xsl:template>

<!--
flexibee2xml -t obrat-in.xslt -x pocatecni-stavy-uctu.xml -o obrat.xml

	<Poč.stav_účtů>
		<Závod>0</Závod>
		<Pozice_rozvahy>21</Pozice_rozvahy>
		<xx></xx>
		<Poč.stav>2982579,9</Poč.stav>
		<Rok>1995</Rok>
		<Číslo_účtu>021</Číslo_účtu>
		<Období>199504</Období>
		<Měsíc>4</Měsíc>
		<Roč.MD>0</Roč.MD>
		<Roč.DAL>0</Roč.DAL>
		<Měs.MD>0</Měs.MD>
		<Měs.DAL>0</Měs.DAL>
	</Poč.stav_účtů>
-->


    <xsl:template match="Poč.stav_účtů">
      <xsl:if test="Měsíc = '1'">
            <obrat>
                <ucetniObdobi>code:<xsl:value-of select="Rok"/></ucetniObdobi>
                <ucet>code:<xsl:value-of select="Číslo_účtu"/></ucet>
                <obdobi>0</obdobi>
                <rok><xsl:value-of select="Rok"/></rok>
                <xsl:choose>
                  <xsl:when test="java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(Poč.stav), '2') &lt; 0">
                    <obrDal><xsl:value-of select="java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(Poč.stav), '2') * -1"/></obrDal>
                    <obrMd>0.0</obrMd>
                  </xsl:when>
                  <xsl:otherwise>
                    <obrMd><xsl:value-of select="java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(Poč.stav), '2')"/></obrMd>
                    <obrDal>0.0</obrDal>                    
                  </xsl:otherwise>
                </xsl:choose>
                <mena>code:CZK</mena>
                <stredisko>code:C</stredisko>
            </obrat>
        </xsl:if>
    </xsl:template>

</xsl:stylesheet>
