<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
     xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java"
>
    <xsl:output method="xml" indent="yes" encoding="utf-8" />
    
    <xsl:variable name="radkyDoc" select="document('prodejky-radky.xml')"/>

    <xsl:key name="cisloKey" match="_Řádky_prodejek" use="_Číslo_prodejky"/>

    

    <xsl:template match="/Root">
        <winstrom version="1.0">
<!--	    <xsl:apply-templates select="*[local-name() = 'Prodejky' and position() &lt; 3]"/>  -->
            <xsl:apply-templates select="Prodejky"/>  
        </winstrom>
    </xsl:template>

    <xsl:template match="/Prodejky">
        <winstrom version="1.0">
            <xsl:apply-templates select="Prodejky"/>
        </winstrom>
    </xsl:template>

<!--
/usr/share/flexibee/bin/flexibee2xml -t prodejka-in.xslt -x prodejky.xml -o pokladni-pohyb.xml

.\flexibee2xml.exe -t adresar.in.xslt -x adresar.out.xml -o vystup.xml 2>a.out
kod, nazev
-->

    <xsl:template match="Prodejky">
        <xsl:variable name="cislo" select="_Číslo_prodejky"/>

        <pokladni-pohyb>
            <id>ext:4DD-PROD:<xsl:value-of select="java:flexibee.Tool.toUpper(_Číslo_prodejky)"/></id>
            <typDokl>code:MIGRACNI</typDokl>
            <bsp>code:MIGRACNI</bsp>
	    <typPohybuK>typPohybu.prijem</typPohybuK>
            <kod><xsl:value-of select="java:flexibee.Tool.toUpper(_Číslo_prodejky)"/></kod>
            <varSym><xsl:value-of select="Var.symbol"/></varSym>
            <datVyst><xsl:value-of select="java:flexibee.Tool.parseDate(Datum, 'd.M.y')"/></datVyst>

            <xsl:if test="Odběratel != ''">
                <firma if-not-found="null">code:<xsl:value-of select="Odběratel"/></firma>
            </xsl:if>                
	    <xsl:if test="Konst.symbol != ''">
        	<konSym if-not-found="null">code:<xsl:value-of select="Konst.symbol"/></konSym>
	    </xsl:if>
            <bspBan if-not-found="null">code:<xsl:value-of select="Bank.spojení"/></bspBan>
            <zdrojProSkl>false</zdrojProSkl>
            <generovatSkl>false</generovatSkl>

            <!-- duzp jsou tady obe protoze musi byt stejne -->
	    <xsl:if test="Datum_zdan.plnění != '0000-00-00'">
	     <datReal><xsl:value-of select="java:flexibee.Tool.parseDate(Den_zdan.plnění, 'd.M.y')"/></datReal>
        	<duzpUcto><xsl:value-of select="java:flexibee.Tool.parseDate(Datum_zdan.plnění, 'd.M.y')"/></duzpUcto>
        	<duzpPuv><xsl:value-of select="java:flexibee.Tool.parseDate(Datum_zdan.plnění, 'd.M.y')"/></duzpPuv>
	    </xsl:if>

	    <xsl:if test="Smluvní_sleva != '' and Smluvní_sleva != '0'">
	    	<slevaDokl><xsl:value-of select="Smluvní_sleva"/></slevaDokl>
	    </xsl:if>


            <xsl:choose>
                 <!-- kod meny 1 je ocividne CZK -->
                 <xsl:when test="java:flexibee.Tool.toUpper(Kód_měny) != '' and java:flexibee.Tool.toUpper(Kód_měny) != '1' and Kurs != '' and Kurs != '0'">
                      <xsl:choose>
                           <xsl:when test="java:flexibee.Tool.toUpper(Kód_měny) = '3'">
                                <mena>code:EUR</mena>
                           </xsl:when>
                           <xsl:otherwise>
                                <mena>code:<xsl:value-of select="java:flexibee.Tool.toUpper(Kód_měny)"/></mena>
                           </xsl:otherwise>
                      </xsl:choose>
                      <kurz><xsl:value-of select="java:flexibee.Tool.parseMoney(Kurs)"/></kurz>                      
                      <sumCelkemMen><xsl:value-of select="java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(_Částka_po_zaok.) div java:flexibee.Tool.parseMoney(Kurs), '2')"/></sumCelkemMen>
                 </xsl:when>
                 <xsl:otherwise>
                 </xsl:otherwise>
            </xsl:choose>

            <!--<bezPolozek>true</bezPolozek>-->
            <polozkyIntDokladu>
		<xsl:for-each select="$radkyDoc">
			<xsl:for-each select="key('cisloKey',$cislo)">
			    <pokladni-pohyb-polozka>
                                <id>ext:4DD-PRODPOL:<xsl:value-of select="java:flexibee.Tool.toUpper(_Číslo_prodejky)"/>-<xsl:value-of select="java:flexibee.Tool.toUpper(_Řádek)"/></id>
                                <xsl:choose>
                                    <xsl:when test="java:flexibee.Tool.toUpper(Kód_EAN) = '' or java:flexibee.Tool.toUpper(Kód_EAN) = ' '">
                                        <typPolozkyK>typPolozky.ucetni</typPolozkyK>
                                    </xsl:when>
                                    <xsl:otherwise>
                                        <typPolozkyK>typPolozky.katalog</typPolozkyK>
                                        <cenik>ean:<xsl:value-of select="java:flexibee.Tool.toUpper(Kód_EAN)"/></cenik>
                                        <eanKod><xsl:value-of select="java:flexibee.Tool.toUpper(Kód_EAN)"/></eanKod>
                                	<sklad>code:XXX_HISTORIE</sklad>
                                    </xsl:otherwise>
                                </xsl:choose>
                                <nazev><xsl:value-of select="Název_položky"/></nazev>
				<xsl:choose> 
				    <xsl:when test="Množství != '0'">
                            		<mnozMj><xsl:value-of select="java:flexibee.Tool.parseMoney(Množství)"/></mnozMj>
				    </xsl:when>
				    <xsl:otherwise>
                            		<mnozMj>1</mnozMj>
				    </xsl:otherwise>
				</xsl:choose>

				<xsl:if test="Smluvní_sleva != '' and Smluvní_sleva != '0'">
	    			    <slevaPol><xsl:value-of select="Smluvní_sleva"/></slevaPol>
				</xsl:if>

                                <!--<cenaMj><xsl:value-of select="java:flexibee.Tool.parseMoney(J.cena_prodejní)"/></cenaMj>-->
                                <cenaMj>0.0</cenaMj>
                                <cenyRucne>true</cenyRucne>
                                <poznam>cena: <xsl:value-of select="java:flexibee.Tool.parseMoney(J.cena_prodejní)"/>; <xsl:value-of select="Poznámka"/></poznam>
                                <zdrojProSkl>false</zdrojProSkl>
			    </pokladni-pohyb-polozka>
			</xsl:for-each>
                </xsl:for-each>
                <pokladni-pohyb-polozka>
                   <!-- osvobozeno -->
                   <id>ext:4DD-PRODPOL:<xsl:value-of select="java:flexibee.Tool.toUpper(_Číslo_prodejky)"/>-OSV</id>
                   <typPolozkyK>typPolozky.ucetni</typPolozkyK>
                   <sumZkl><xsl:value-of select="java:flexibee.Tool.round((java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(_Částka_po_zaok.), '2') 
                       - java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(Základ_ve_sníž.sazbě), '2') 
                       - java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(DPH_ve_sníž.sazbě), '2')
                       - java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(Základ_v_zákl.sazbě), '2')
                       - java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(DPH_v_zákl.sazbě), '2')), '2')"/></sumZkl>
                   <sumDph>0.0</sumDph>
                   <sumCelkem><xsl:value-of select="java:flexibee.Tool.round((java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(_Částka_po_zaok.), '2') 
                       - java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(Základ_ve_sníž.sazbě), '2') 
                       - java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(DPH_ve_sníž.sazbě), '2')
                       - java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(Základ_v_zákl.sazbě), '2')
                       - java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(DPH_v_zákl.sazbě), '2')), '2')"/></sumCelkem>
                   <typSzbDphK>typSzbDph.dphOsv</typSzbDphK>
                </pokladni-pohyb-polozka>
                <pokladni-pohyb-polozka>
                   <!-- snizena sazba -->
                   <id>ext:4DD-PRODPOL:<xsl:value-of select="java:flexibee.Tool.toUpper(_Číslo_prodejky)"/>-SNIZ</id>
                   <typPolozkyK>typPolozky.ucetni</typPolozkyK>
                   <sumZkl><xsl:value-of select="java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(Základ_ve_sníž.sazbě), '2')"/></sumZkl>
                   <sumDph><xsl:value-of select="java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(DPH_ve_sníž.sazbě), '2')"/></sumDph>
                   <sumCelkem><xsl:value-of select="java:flexibee.Tool.round((java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(Základ_ve_sníž.sazbě), '2')
                        + java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(DPH_ve_sníž.sazbě), '2')), '2')"/></sumCelkem>
                   <typSzbDphK>typSzbDph.dphSniz</typSzbDphK>
                </pokladni-pohyb-polozka>
                <pokladni-pohyb-polozka>
                   <!-- zakladni sazba -->
                   <id>ext:4DD-PRODPOL:<xsl:value-of select="java:flexibee.Tool.toUpper(_Číslo_prodejky)"/>-ZAKL</id>
                   <typPolozkyK>typPolozky.ucetni</typPolozkyK>
                   <sumZkl><xsl:value-of select="java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(Základ_v_zákl.sazbě), '2')"/></sumZkl>
                   <sumDph><xsl:value-of select="java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(DPH_v_zákl.sazbě), '2')"/></sumDph>
                   <sumCelkem><xsl:value-of select="java:flexibee.Tool.round((java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(Základ_v_zákl.sazbě), '2')
                        + java:flexibee.Tool.round(java:flexibee.Tool.parseMoney(DPH_v_zákl.sazbě), '2')), '2')"/></sumCelkem>
                   <typSzbDphK>typSzbDph.dphZakl</typSzbDphK>
                </pokladni-pohyb-polozka>
	    </polozkyIntDokladu>            

            
            <zavTxt><xsl:value-of select="Doplň.text"/></zavTxt>
	    <poznam>Pokladna č. <xsl:value-of select="java:flexibee.Tool.toUpper(_Č.pokladny)"/></poznam>
            <xsl:if test="Středisko != ''">
                <stredisko>code:<xsl:value-of select="Středisko"/></stredisko>
            </xsl:if>
            <xsl:if test="Zakázka != ''">
                <zakazka>code:<xsl:value-of select="java:flexibee.Tool.toUpper(Zakázka)"/></zakazka>
            </xsl:if>
        </pokladni-pohyb>
    </xsl:template>

</xsl:stylesheet>
