<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
     xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java"
>
    <xsl:output method="xml" indent="yes" encoding="utf-8" />

    <xsl:template match="/Root">
        <winstrom version="1.0">
            <xsl:apply-templates select="Zakázky"/>
        </winstrom>
    </xsl:template>

    <xsl:template match="/Zakázky">
        <winstrom version="1.0">
            <xsl:apply-templates select="Zakázky"/>
        </winstrom>
    </xsl:template>

<!--
.\flexibee2xml.exe -t adresar.in.xslt -x adresar.out.xml -o vystup.xml 2>a.out
kod, nazev
-->

    <xsl:template match="Zakázky">
        <zakazka>
            <id>ext:4DD-ZAK:<xsl:value-of select="java:flexibee.Tool.toUpper(Č.zakázky)"/></id>
            <id>code:<xsl:value-of select="java:flexibee.Tool.toUpper(Č.zakázky)"/></id>
            <kod><xsl:value-of select="java:flexibee.Tool.toUpper(Č.zakázky)"/></kod>
            <xsl:choose>
                <xsl:when test="Název_zak. != ''">
                    <nazev><xsl:value-of select="Název_zak."/></nazev>
                </xsl:when>
                <xsl:otherwise>
                    <nazev><xsl:value-of select="Č.zakázky"/></nazev>
                </xsl:otherwise>
            </xsl:choose>
            <xsl:if test = "Firma != ''">
                <firma if-not-found="null">code:<xsl:value-of select="Firma"/></firma>
            </xsl:if>
            <datZahaj><xsl:value-of select="java:flexibee.Tool.parseDate(Dat.přijetí, 'd.M.y')"/></datZahaj>
            <xsl:if test = "Dat.plán.ukonč. != '00.00.00'">
                <datKonec><xsl:value-of select="java:flexibee.Tool.parseDate(Dat.plán.ukonč., 'd.M.y')"/></datKonec>
            </xsl:if>
            <xsl:if test = "Dat.skut.ukonč. != '00.00.00'">
                <termin><xsl:value-of select="java:flexibee.Tool.parseDate(Dat.skut.ukonč., 'd.M.y')"/></termin>
            </xsl:if>
            <poznam><xsl:value-of select="Poznámka"/></poznam>
            <xsl:if test = "Uzavřena = 'Pravda' or Uzavřena = 'true'">
                <stavZakazky>code:HOTOVO</stavZakazky>
            </xsl:if>
            <popis><xsl:value-of select="Identifikace"/></popis>
            <!--Vystavil-->
            <!--Hodnota_s_DPH-->
            <xsl:if test = "Středisko != ''">
                <stredisko>code:<xsl:value-of select="Středisko"/></stredisko>
            </xsl:if>
            <!--_Úvodní_text-->
            <!--Doplň.text-->
            <!--_Č.faktury-->
            <!--Hodnota-->
            <xsl:if test = "Typ_zakázky != ''">
                 <typZakazky if-not-found="null">code:<xsl:value-of select="Typ_zakázky"/></typZakazky>
            </xsl:if>
            <!--Exportováno-->
            <!--Interní-->
        </zakazka>
    </xsl:template>

</xsl:stylesheet>
